      SUBROUTINE RCA01
C
C        RCA01 IS THE INITILIZATION ROUTINE
C
      SAVE
      CHARACTER   TITLE*80,TYPE*15
      CHARACTER*3 ACYCLE,ALIST(5),ADIAGDT,AINPCHCK
      INTEGER*2  SYSGDP(40)
      INCLUDE  'RCACM'

C        INITIAL -SYSBY- SETTINGS
      DO I=1,40
       SYSGDP(I)=1
      ENDDO

C        DEFINE I/O DEVICES
      IN = 5
      OUT = 6
C   Begin McCardell
C     OPEN (UNIT=IN,FILE='INPUT')
C     OPEN (UNIT=OUT,FILE='OUTPUT')
C   End McCardell 
C        THE -LIST- ARRAY CONTROLS THE LISTING OF THE USERS INPUT DECK
C         LIST(#)        CONTROLS THE LISTING OF
C              1   GEOMETRY...EXCHANGES, VOLUMES AND FLOWS
C              2   BOUNDARY CONDITIONS
C              3   LOADINGS
C              4   PARAMETERS, CONSTANTS AND MISC TIME FNS
C              5   INITIAL CONDITIONS
C        LIST =  ON = 1   LIST INPUT
C        LIST = OFF = 0   DO NOT LIST INPUT
C
      READ(IN,1000)  COMMENT
 1000 FORMAT(A)
      CYCLE=0
      LIST=0
      IDIAGDT=0
      INPCHCK=0
      READ(IN,1100,ERR=950)   ACYCLE,ALIST,ADIAGDT,AINPCHCK
 1100 FORMAT(8(7X,A3))
      IF(ACYCLE.EQ.' ON' .OR. ACYCLE.EQ.'  1') CYCLE=1
      IF(ALIST(1).EQ.' ON' .OR. ALIST(1).EQ.'  1') LIST(1)=1
      IF(ALIST(2).EQ.' ON' .OR. ALIST(2).EQ.'  1') LIST(2)=1
      IF(ALIST(3).EQ.' ON' .OR. ALIST(3).EQ.'  1') LIST(3)=1
      IF(ALIST(4).EQ.' ON' .OR. ALIST(4).EQ.'  1') LIST(4)=1
      IF(ALIST(5).EQ.' ON' .OR. ALIST(5).EQ.'  1') LIST(5)=1
      IF(ADIAGDT.EQ.' ON' .OR. ADIAGDT.EQ.'  1') IDIAGDT=1
      IF(AINPCHCK.EQ.' ON' .OR. AINPCHCK.EQ.'  1') INPCHCK=1
      WRITE(OUT,1500)  NX,NY,NZ,NOSYS
 1500 FORMAT( 1H1/1X,120('*')/1X,120('*')////
     .   25X,'R C A 3 D   - -  R O W / C O L U M N   A E S O P'/
     .   25X,'                  ( 3 - D I M E N S I O N A L )'//
     .   70X,'Version 3.00  Released June 30,2004'/
     .   70X,'DEVELOPED BY HYDROQUAL INC.  MAHWAH, NJ'/
     .   70X,'THIS EXECUTABLE COMPILED FOR:  NX =',I4/
     .   97X,'    NY =',I4/97X,'    NZ =',I4/97X,' NOSYS =',I4/
     .   ////1X,120('*')/1X,120('*')//)
      IF(CYCLE.EQ.0)  THEN
         WRITE(OUT,1600)
 1600    FORMAT(
     .     15X,'INITIAL CONDITIONS WILL BE READ FROM USER INPUT DECK'//)
      ELSE
         WRITE(OUT,1601)
 1601    FORMAT(
     .     15X,'INITIAL CONDITIONS WILL BE READ FROM RCAFIC'//)
      ENDIF

      READ(IN,1000) COMMENT
   10 READ(IN,1000) TITLE
      IF(TITLE(1:3).NE.'END' .AND. TITLE(1:3).NE.'end')   THEN
         WRITE(OUT,1110)   TITLE
 1110    FORMAT(10X,A80)
         GO TO 10
      ENDIF
      WRITE(OUT,2100)
 2100 FORMAT(    ////1X,120('*')/1X,120('*')////)

C        READ STATE VARIABLE NAMES
      READ(IN,1000) COMMENT
      READ(IN,1120,ERR=950)  (SYNAME(I),I=1,NOSYS)
 1120 FORMAT(10A8)
      WRITE(OUT,2250)  (I,SYNAME(I),I=1,NOSYS)
 2250 FORMAT(5X,'THE FOLLOWING STATE-VARIABLES ARE BEING MODELED'/ 20X,
     .   'SYSTEM     VARIABLE'/20X,6('-'),5X,8('-')/(20X,I4,'.',6X,A8))

C     System Bypass Options
      READ(IN,1000) COMMENT
      READ(IN,3000,ERR=950)   (SYSBY(I),I=1,NOSYS)
 3000 FORMAT(40I2)
      WRITE(OUT,4000)    NOSYS,(SYSBY(I),I=1,NOSYS)
 4000 FORMAT(15X,'SYSTEM BYPASS OPTIONS FOR SYSTEMS 1 TO',I3,' ARE',/
     .  15X,50I2)

C        DETERMINE SYSTEM NUMBER OF LAST ACTIVE SYSTEM
      DO 20 ISYS=1,NOSYS
        SYSGDP(ISYS) = SYSBY(ISYS)
        IF(SYSBY(ISYS).EQ.0)   MXACTS = ISYS
   20 CONTINUE

      WRITE(10)   NX,NY,NZ,NOSYS
      WRITE(10)   SYNAME
      WRITE(10)   SYSGDP
      WRITE(OUT,4500)
 4500 FORMAT(////1X,119('*')/1X,119('*'))

C        OTHER INITIALIZATION
      TIME=0.0
      INITB = 0
      IREC=0
      NOKINSYS=0

      CDARAY = 0.
      CARAY = 0.
      BATM = 0.
      SATM = 0.
      BBC = 0.
      SBC = 0.
      BPS = 0.
      SPS = 0.
      BNPS = 0.
      SNPS = 0.
      BFL = 0.
      SFL = 0.
      VDER = 0.
      QX = 0.
      QY = 0.
      RX = 0.
      RY = 0.
      QZ = 0.
      RZ = 0.

      RETURN

 950  CALL FMTER
      CALL EXIT
      END
