      SUBROUTINE RCA14
C 
C        RCA14 READS INFORMATION FOR SUB-DOMAIN GRIDS (IF CHOSEN BY USER)
C 
      SAVE
      INCLUDE 'RCACM' 
      CHARACTER  DMTFILNA*40,DMBCFILNA*40
      REAL   BBUFFER(50000),SBUFFER(50000)
      INTEGER  FSMNEW(NX,NY)

C        READ NAME OF SUB-DOMAIN INPUT FILE
      READ(IN,1000)  COMMENT
 1000 FORMAT(A)
      READ(IN,1000)  SUBDFILNA
      WRITE(OUT,1010)  SUBDFILNA
 1010 FORMAT(//41X,'OPENING SUBDFILNA = ',A40)
      OPEN(39,FILE=SUBDFILNA,FORM='FORMATTED',STATUS='OLD',ERR=995)

C        READ NEW LAND MASK ARRAY -FSM-
      READ(39,1000)  COMMENT
      DO 50 IY=1,NY
       READ(39,1100)  (FSMNEW(IX,IY),IX=1,NX)
 1100  FORMAT(20I4)
   50 CONTINUE

C        CHECK FOR ERRORS
      DO 75 IY=1,NY
       DO 75 IX=1,NX
        IF(FSMNEW(IX,IY).EQ.FSM(IX,IY)) GO TO 70
        IF(FSMNEW(IX,IY).EQ.2 .AND. FSM(IX,IY).EQ.1) GO TO 70
        GO TO 900
   70   FSM(IX,IY)=FSMNEW(IX,IY)
   75 CONTINUE

C        OUTPUT LAND MASK ARRAY
      WRITE(OUT,1120) (I,I=1,6),(I,I=1,9),0,(I,I=1,9),0,(I,I=1,9),0
     .               ,(I,I=1,9),0,(I,I=1,9),0,(I,I=1,9),0
 1120 FORMAT(//41X,'REVISED COMPUTATIONAL GRID (FSM LAND MASK ARRAY)'/
     .         33X,'FSM = 1 ==> ACTIVE WATER CELL   FSM = 2 ==> INACTIVE
     . WATER CELL'/
     .          2X,'IY  IX-->'/5X,6(19X,I1)/5X,60I2)
      DO IY=NY,1,-1
      WRITE(OUT,1122)  IY,(IFIX(FSM(IX,IY)),IX=1,NX)
 1122  FORMAT(I4,1X,60I2/(5X,60I2))
      ENDDO
      WRITE(OUT,1122)

C        OBTAIN FILE NAMES AND THEN OPEN FILES FOR DOMAIN BOUNDARY
C        TIME HISTORY AND CONCENTRATION INFORMATION 
      READ(39,1000)  COMMENT
      READ(39,1200)  DMTFILNA,DMBCFILNA
 1200 FORMAT(2A40)
      OPEN(40,FILE=DMTFILNA,FORM='UNFORMATTED',STATUS='OLD',ERR=995)
      READ(40)  NDMPSDM
      IBUFSIZ=NDMPSDM*5*NOSYS
      READ(40)  ((IFDMPSDM(I,J),J=1,3),I=1,NDMPS)
C        CONVERT 3-D ARRAY POSITIONS (IX,IY,IZ) TO 2-D ARRAY POSITIONS
C        AND VECTOR POSITION
      DO IDMP=1,NDMPS
        IFDMPSDM2D(IDMP) = IFDMPSDM(IDMP,1) + (IFDMPSDM(IDMP,2)-1)*NX
        IFDMPSDM1D(IDMP) = IFDMPSDM2D(IDMP) + (IFDMPSDM(IDMP,3)-1)*NX*NY
      ENDDO
      READ(40)  DDGDPBYSDM
C        DUMMY READ FOR DDNAMES
      READ(40)
      OPEN(41,FILE=DMBCFILNA,FORM='UNFORMATTED',STATUS='OLD',ERR=995)

      READ(39,1000)  COMMENT
      READ(39,1220)  ISDMPWLOPT
 1220 FORMAT(I10)
      IF(ISDMPWLOPT.EQ.0) THEN
        WRITE(OUT,1250)   
 1250   FORMAT(///10X,'SUB-DOMAIN WATER CELL "BOUNDARIES" WILL BE UPDATE
     .D AS STEP FUNCTIONS'///)
      ELSE
        WRITE(OUT,1260)   
 1260   FORMAT(///10X,'SUB-DOMAIN WATER CELL "BOUNDARIES" WILL BE UPDATE
     .D AS PIECE-WISE LINEAR FUNCTIONS'///)
      ENDIF

C        IF TZERO GREATER THAN ZERO SPIN DOWN THE SUB-DOMAIN BOUNDARY FILES
      IF(TZERO.GT.0.) THEN
        DO ILOOP=1,100000
         READ(40,END=920) NXTSDMT
         READ(41)
         IF(NXTSDMT.GE.TZERO) GO TO 100
        ENDDO
      ENDIF

      RETURN
      
      ENTRY RCA14SUBD

  100 IF(TIME.GE.NXTSDMT) THEN
        READ(40)  NXTSDMT
        READ(41)  (BBUFFER(I),I=1,IBUFSIZ)
        IF(ISDMPWLOPT.EQ.1) THEN
          OLDSDMT=NXTSDMT
          DO I=1,IBUFSIZ
           SBUFFER(I)=BBUFFER(I)
          ENDDO
          READ(40)  NXTDSMT
          READ(41)  (BBUFFER(I),I=1,IBUFSIZ)
          DO I=1,IBUFSIZ
           SBUFFER(I) = (SBUFFER(I)-BBUFFER(I))/(OLDSDMT-NXTDSMT)
          ENDDO
        ENDIF
      ENDIF
      ICNT=1
      IF(ISDMPWLOPT.EQ.0) THEN
        DO 225 ISYS=1,NOSYS
         DO 220 ID=1,NDMPSDM
          IX=IFDMPSDM(ID,1)
          IY=IFDMPSDM(ID,2)
          IZ=IFDMPSDM(ID,3)
          CARAY(IX,IY,IZ,ISYS)=BBUFFER(ICNT)
          ICNT=ICNT+5
  220    CONTINUE
  225   CONTINUE
      ELSE
        DELTSDM=TIME-NXTSDMT
        DO 245 ISYS=1,NOSYS
         DO 240 ID=1,NDMPSDM
          IX=IFDMPSDM(ID,1)
          IY=IFDMPSDM(ID,2)
          IZ=IFDMPSDM(ID,3)
          CARAY(IX,IY,IZ,ISYS)=DELTSDM*SBUFFER(ICNT) + BBUFFER(ICNT)
          ICNT=ICNT+5
  240    CONTINUE
  245   CONTINUE
      ENDIF

      RETURN

  900 WRITE(OUT,9000)  IX,IY,FSMNEW(IX,IY),FSM(IX,IY)
 9000 FORMAT(///10X,
     .   'INPUT ERROR WHEN READING LAND MASK ARRAY FOR SUB-DOMAIN(S)'
     .   'IX,IY =',2I4,' SUBDOMAIN FSM(IX,IY) =',I3,
     .   ' ORIGINAL FSM(IX,IY) =',I3/10X,'RCA TERMINATED'//)
      CALL EXIT
  920 WRITE(OUT,9200)  
 9200 FORMAT(///10X,
     .   'ERROR END-OF-FILE ENCOUNTERED WHEN READING SUB-DOMAIN FILES TO
     . CORRECT FOR TZERO'/10X,'RCA TERMINATED'//)
      CALL EXIT
  995 WRITE(OUT,9950)  
 9950 FORMAT(//11X,'ERROR...USER REQUESTED INPUT FILE NOT PRESENT'/
     . 11X,'CHECK SPELLING OF THE FILE NAME -OR- DIRECTORY PATH'/
     . 11X,'RCA TERMINATED'//)
      END 
