      MODULE ALLOCRCASPLT
       REAL, ALLOCATABLE :: FLXMB(:,:,:,:)
       REAL, ALLOCATABLE :: FLYMB(:,:,:,:)
      END MODULE ALLOCRCASPLT
      SUBROUTINE RCASPLT
      USE  ALLOCRCASPLT
C 
C        RCASPLT IS THE MASTER SUBROUTINE USED FOR INTEGRATING THE DIFFERENTIAL
C                EQUATIONS OF THE WATER QUALITY MODEL.
C                TIME DERIVATIVE: EXPLICIT - SPLIT TIMESTEP
C                SPACE DERIVATIVE: UPWIND
C
C************************************************************************
C 
      SAVE
      INCLUDE 'RCACM' 
      INTEGER  NEGSEG(99,3)
      REAL   CONCS(NX,NY,0:NZ)
     .      ,DM(NX,NY,NZ,NOSYS),BVOLN(NX,NY,NZ),TOTMAS
     .      ,AL(NX,NY,NZ),AD(NX,NY,NZ),AU(NX,NY,NZ)
     .      ,BETA(NX,NY,NZ),GAMMA(NX,NY,NZ)
     .      ,MF(NX,NY,NZ),CDARAYS(NX,NY,NZ,NOSYS)
     .      ,SYSMASS(NOSYS+NOKINSYS),SYSLOADS(4,NOSYS) 
     .      ,ADDMASS(NX,NY,NZ,NOSYS)

C        INITIALIZATION
      INITB=0
      ITRAK=1 
      ITIMESECS=0
      ITIMEWQSECS=0
      TIME=0.0
      NXPRTD=IPRNTDSECS
      NXPRTG=IPRNTGSECS
      IWRTADDM=0
      IADDMDEBUG=0
      INITMB=1
      IF(MASSBAL.EQ.1) THEN
        IF(ISMBSECS.EQ.0) THEN
          NXPRTMB=0
          INITMB=0
        ELSE
          NXPRTMB=ISMBSECS
          INITMB=1
        ENDIF
      ENDIF
      NSPLIT = DTFULL/DTSPLIT
      IF(TZERO.NE.0.) THEN
         TIME = TZERO
         CALL RCA08
         ITIMESECS = 86400.*TZERO
         ITIMEWQSECS = 86400.*TZERO
         NXPRTD = ITIMESECS+IPRNTDSECS
         NXPRTG = ITIMESECS+IPRNTGSECS
         IF(MASSBAL.EQ.1) THEN
           IF(ITIMESECS.LT.ISMBSECS) THEN
             NXPRTMB=ISMBSECS
             INITMB=1
           ELSE
             NXPRTMB = ITIMESECS
             INITMB=0
           ENDIF
         ENDIF
      ENDIF
C        INITIALIZE KINETICS
      CALL TUNER_INIT
C        INITIALIZE ARRAYS
      DO 5 ISYS=1,NOSYS
       DO 5 IZ=1,NZ
        DO 5 IY=1,NY
         DO 5 IX=1,NX
          CDARAYS(IX,IY,IZ,ISYS) = 0.0
    5 CONTINUE
      DO 10 IZ=1,NZ
       DO 10 IY=1,NY
        DO 10 IX=1,NX
          CONCS(IX,IY,IZ) = 0.0
   10 CONTINUE
      IF(MASSBAL.EQ.1) THEN
       ALLOCATE(FLXMB(NX,NY,NZ,NOSYS+NOKINSYS),STAT=ISTAT)
       ALLOCATE(FLYMB(NX,NY,NZ,NOSYS+NOKINSYS),STAT=ISTAT)
        DO 12 ISYS=1,NOSYS+NOKINSYS
         DO 12 IZ=1,NZ
          DO 12 IY=1,NY
           DO 12 IX=1,NX
            FLXMB(IX,IY,IZ,ISYS)=0.
            FLYMB(IX,IY,IZ,ISYS)=0.
   12   CONTINUE
        DO 14 ISYS=1,NOSYS
         DO I=1,4
          SYSLOADS(I,ISYS)=0.0
         ENDDO
   14   CONTINUE
       IF(INITMB.EQ.0) THEN
        DO 16 ISYS=1,NOSYS
         SYSMASS(ISYS)=0.0
         DO 16 IZ=1,NZ
          DO 16 IY=1,NY
           DO 16 IX=1,NX
            IF(FSM(IX,IY).EQ.1.)  SYSMASS(ISYS) = SYSMASS(ISYS) +
     .                            BVOL(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)
  16    CONTINUE
        DO 17 ISYS=1,NOKINSYS
         SYSMASS(NOSYS+ISYS)=0.0
         DO 17 IZ=1,NZ
          DO 17 IY=1,NY
           DO 17 IX=1,NX
            IF(FSM(IX,IY).EQ.1.)
     .                 SYSMASS(NOSYS+ISYS) = SYSMASS(NOSYS+ISYS) +
     .                 BVOL(IX,IY,IZ)*CKINARRAY(IX,IY,IZ,ISYS)
  17    CONTINUE
        WRITE(17)  TIME,SYSMASS,SYSLOADS,FLXMB,FLYMB
        NXPRTMB=NXPRTMB+IPRNTMBSECS
        INITMB=1
       ENDIF
      ENDIF

C        SET UP -AVECT- ARRAYS FOR TIME = 0.0 (TZERO)
      CALL RCASPLT1

C        PRINT INITIAL CONDITIONS
      CALL RCA09
      IDISK = 3 
 
C        BEGINNING OF FULL INTEGRATION TIMESTEP LOOP
   30 CONTINUE

C        GET TOTAL MASS PER SYSTEM IF MASS/FLUX BALANCES REQUESTED
      IF(MASSBAL.EQ.1 .AND. ITIMESECS.EQ.NXPRTMB) THEN
       DO 35 ISYS=1,NOSYS
        SYSMASS(ISYS)=0.0
        DO 35 IZ=1,NZ
         DO 35 IY=1,NY
          DO 35 IX=1,NX
           IF(FSM(IX,IY).EQ.1.)  SYSMASS(ISYS) = SYSMASS(ISYS) +
     .                           BVOL(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)
  35   CONTINUE
       DO 40 ISYS=1,NOKINSYS
        SYSMASS(NOSYS+ISYS)=0.0
        DO 40 IZ=1,NZ
         DO 40 IY=1,NY
          DO 40 IX=1,NX
           IF(FSM(IX,IY).EQ.1.)
     .                SYSMASS(NOSYS+ISYS) = SYSMASS(NOSYS+ISYS) +
     .                BVOL(IX,IY,IZ)*CKINARRAY(IX,IY,IZ,ISYS)
  40   CONTINUE
      ENDIF

C        IF PIECEWISE LINEAR BOUNDARY CONDITIONS THEN
C           GET CONCENTRATIONS AT CURRENT TIME LEVEL
      IF(IBCPWLOPT.EQ.1) THEN
c$doacross local(isys,deltbc,iz,iy,ix,i)
        DO 50 ISYS=1,NOSYS
          IF(NOBC(ISYS).EQ.0) GO TO 50
          DELTBC = TIME - NXBCT
          DO 45 I=1,NOBC(ISYS)
            IX=IBC(1,I,ISYS)
            IY=IBC(2,I,ISYS)
            IZ=IBC(3,I,ISYS)
            CARAY(IX,IY,IZ,ISYS) = DELTBC*SBC(I,ISYS) + BBC(I,ISYS)
   45     CONTINUE
   50  CONTINUE
      ENDIF

C        EVALUATE KINETIC DERIVATIVES
      IF (DTWQ.EQ.0.0.OR.ITIMESECS.GE.ITIMEWQSECS) THEN
        CALL TUNER
        IDISK = 0
        ITIMEWQSECS=ITIMEWQSECS+IDTWQSECS
        TIMEWQ=ITIMEWQSECS/86400.
      ENDIF
      INITB = 1
c     print *,'after tuner at time',time
c     write(6,'(10e11.3)') caray(39:40,39,:,11),cdaray(39:40,39,:,11)
c     write(6,'(10e11.3)') caray(39:40,41,:,11),cdaray(39:40,41,:,11)
c     write(6,'(10e11.3)') caray(39:40,43,:,11),cdaray(39:40,43,:,11)

C        IF TUNER CALLED OR IF LOADS CHANGED THEN UPDATE -CDARAYS-
c$doacross local(isys,iz,iy,ix,is,ie,i),share(cdarays)
      DO 80 ISYS=1,NOSYS

C        SOURCES/SINKS DUE TO KINETICS
       DO 55 IZ=1,NZ
        DO 55 IY=1,NY
         IS = IXS(IY)
         IE = IXE(IY)
         IF(IS.EQ.0) GO TO 55
         DO 54 IX=IS,IE
           CDARAYS(IX,IY,IZ,ISYS) = CDARAY(IX,IY,IZ,ISYS)
  54     CONTINUE
  55   CONTINUE
 
C        SET MASS BALANCE FLAG FOR ACCUMULATING LOADS
       IMBWK=0
       IF(MASSBAL.EQ.1 .AND. ITIMESECS.GE.ISMBSECS) THEN
        IF(IMBDOPT.EQ.0) THEN
         IF(ITIMESECS.EQ.NXPRTMB) IMBWK=1
          DTMB=1.
        ELSE
         IMBWK=1
         DTMB=DT
        ENDIF
       ENDIF
 
C  ADD LOADS
       IF(NOPS(ISYS).GT.0) THEN
        DELTPS = TIME - NXPST
        DO 60 I=1,NOPS(ISYS) 
         WK = DELTPS*SPS(I,ISYS) + BPS(I,ISYS)
         IF(IMBWK.EQ.1)  SYSLOADS(1,ISYS) = SYSLOADS(1,ISYS)+DTMB*WK
         IX = IPS(1,I,ISYS)
         IY = IPS(2,I,ISYS)
         IWK = IPS(3,I,ISYS)
         DO IZ=1,NZ
          CDARAYS(IX,IY,IZ,ISYS) = CDARAYS(IX,IY,IZ,ISYS) +
     .          ZFRACPS(IZ,IWK)*WK
         ENDDO
   60   CONTINUE
       ENDIF
       IF(NONPS(ISYS).GT.0) THEN
        DELTNPS = TIME - NXNPST
        DO 65 I=1,NONPS(ISYS)
         WK = DELTNPS*SNPS(I,ISYS) + BNPS(I,ISYS)
         IF(IMBWK.EQ.1)  SYSLOADS(2,ISYS) = SYSLOADS(2,ISYS)+DTMB*WK
         IX = INPS(1,I,ISYS)
         IY = INPS(2,I,ISYS)
         IWK = INPS(3,I,ISYS)
         DO IZ=1,NZ
          CDARAYS(IX,IY,IZ,ISYS) = CDARAYS(IX,IY,IZ,ISYS) +
     .          ZFRACNPS(IZ,IWK)*WK
         ENDDO
   65   CONTINUE
       ENDIF
       IF(NOFL(ISYS).GT.0) THEN
        DELTFL = TIME - NXFLT
        DO 70 I=1,NOFL(ISYS)
         WK = DELTFL*SFL(I,ISYS) + BFL(I,ISYS)
         IF(IMBWK.EQ.1)  SYSLOADS(3,ISYS) = SYSLOADS(3,ISYS)+DTMB*WK
         IX = IFL(1,I,ISYS)
         IY = IFL(2,I,ISYS)
         IWK = IFL(3,I,ISYS)
         DO IZ=1,NZ
          CDARAYS(IX,IY,IZ,ISYS) = CDARAYS(IX,IY,IZ,ISYS) +
     .          ZFRACFL(IZ,IWK)*WK
         ENDDO
   70   CONTINUE
       ENDIF
       IF(NOATM(ISYS).GT.0) THEN
        DELTATM = TIME - NXATMT
        DO 75 IY=1,NY
         IS = IXS(IY)
         IE = IXE(IY)
         IF(IS.EQ.0) GO TO 75
         DO 74 IX=IS,IE
          IF(FSM(IX,IY).NE.1.) GO TO 74
          CDARAYS(IX,IY,1,ISYS) = CDARAYS(IX,IY,1,ISYS) +
     .          (DELTATM*SATM(IX,IY,ISYS) + BATM(IX,IY,ISYS))*XAZ(IX,IY)
          IF(IMBWK.EQ.1)  SYSLOADS(4,ISYS) = SYSLOADS(4,ISYS) +
     .       DTMB*(DELTATM*SATM(IX,IY,ISYS)+BATM(IX,IY,ISYS))*XAZ(IX,IY)
   74    CONTINUE
   75   CONTINUE
       ENDIF

   80 CONTINUE
c     print *,'after loads'
c     write(6,'(10e11.3)') caray(39:40,39,:,11),cdaray(39:40,39,:,11)
c     write(6,'(10e11.3)') caray(39:40,41,:,11),cdaray(39:40,41,:,11)
c     write(6,'(10e11.3)') caray(39:40,43,:,11),cdaray(39:40,43,:,11)
c     print *,'fsm,fsmsplt'
c     write(6,'(12e11.3)') fsm(39:40,39),fsmsplt(39:40,39,:)
c     write(6,'(12e11.3)') fsm(39:40,41),fsmsplt(39:40,41,:)
c     write(6,'(12e11.3)') fsm(39:40,43),fsmsplt(39:40,43,:)

C        INTEGRATION STEP BEGINS HERE

C        UPDATE CARAY IF SUBDOMAIN GRID OPTION ACTIVE
      IF(ISUBDOM.EQ.1) CALL RCA14SUBD

c$doacross local(isys,iz,iy,ix),share(dm)
      DO 110 ISYS=1,NOSYS
       DO 110 IZ=1,NZ
        DO 110 IY=1,NY
          DO 110 IX=1,NX
            DM(IX,IY,IZ,ISYS) = 0.0
  110 CONTINUE
      
C        CHECK TO SEE IF THERE ARE "HIGH SPEED" SEGMENTS
      IF(NSEGSPLT.EQ.0) GO TO 200
C     PERFORM SPLIT TIMESTEP COMPUTATION
C        FIRST INTEGRATING CRITICAL TIMESTEP SEGMENTS
c$doacross local(isys,isplit,iseg,iz,iy,ix,is,ie,inegs,aa,fmax,fmin,
c$&              totmas,concs,dmsplt,qxsplt,antiqxsplt,fluxin,fluxout,
c$&              qysplt,antiqysplt,qzsplt,antiqzsplt,
c$&              rxflx1,rxflx2,ryflx1,ryflx2),
c$&              mp_schedtype=dynamic, chunk=1
      DO 190 ISYS=1,NOSYS 
C        CHECK FOR SYSTEM BYPASS
       IF(SYSBY(ISYS).EQ.1) GO TO 190
       INEGS=0
       TOTMAS=0.0
       DO 180 ISPLIT=1,NSPLIT
        DO 120 ISEG=1,NSEGSPLT
          IX = ISEGSPLT(ISEG,1)
          IY = ISEGSPLT(ISEG,2)
          IZ = ISEGSPLT(ISEG,3)

C        COMPUTE VOLUMES AT TIME LEVEL 'N+1'
          BVOLN(IX,IY,IZ) = BVOL(IX,IY,IZ)
     .                           + ISPLIT*DTSPLIT*VDERSPLT(ISEG)
 
C        COMPUTE CHANGE IN MASS FOR CRITICAL SEGMENT
          DMSPLT = CDARAYS(IX,IY,IZ,ISYS)
     .        - DIAGSPLT(ISEG)*CARAY(IX,IY,IZ,ISYS)
     .         + AVECTSPLT(ISEG,1)*CARAY(IX-1,IY,IZ,ISYS)
     .          + AVECTSPLT(ISEG,2)*CARAY(IX+1,IY,IZ,ISYS)
     .           + AVECTSPLT(ISEG,3)*CARAY(IX,IY-1,IZ,ISYS)
     .            + AVECTSPLT(ISEG,4)*CARAY(IX,IY+1,IZ,ISYS)
          IF(IZ.GT.1)   
     .      DMSPLT = DMSPLT + AVECTSPLT(ISEG,5)*CARAY(IX,IY,IZ-1,ISYS)
          IF(IZ.LT.NZ)   
     .      DMSPLT = DMSPLT + AVECTSPLT(ISEG,6)*CARAY(IX,IY,IZ+1,ISYS)
C        COMPUTE CHANGE IN MASS IN SEGMENTS ADJOINING CRITICAL SEGMENT
            DM(IX-1,IY,IZ,ISYS) = DM(IX-1,IY,IZ,ISYS) +
     .         AVECTSPLT(ISEG,7)*CARAY(IX,IY,IZ,ISYS)/NSPLIT
            DM(IX+1,IY,IZ,ISYS) = DM(IX+1,IY,IZ,ISYS) +
     .         AVECTSPLT(ISEG,8)*CARAY(IX,IY,IZ,ISYS)/NSPLIT
            DM(IX,IY-1,IZ,ISYS) = DM(IX,IY-1,IZ,ISYS) +
     .         AVECTSPLT(ISEG,9)*CARAY(IX,IY,IZ,ISYS)/NSPLIT
            DM(IX,IY+1,IZ,ISYS) = DM(IX,IY+1,IZ,ISYS) +
     .         AVECTSPLT(ISEG,10)*CARAY(IX,IY,IZ,ISYS)/NSPLIT
            IF(IZ.GT.1)  DM(IX,IY,IZ-1,ISYS) = DM(IX,IY,IZ-1,ISYS) +
     .         AVECTSPLT(ISEG,11)*CARAY(IX,IY,IZ,ISYS)/NSPLIT
            IF(IZ.LT.NZ)  DM(IX,IY,IZ+1,ISYS) = DM(IX,IY,IZ+1,ISYS) +
     .         AVECTSPLT(ISEG,12)*CARAY(IX,IY,IZ,ISYS)/NSPLIT

C        NOW COMPUTE CHANGE IN CONCENTRATION FOR CRITICAL SEGMENT
            CONCS(IX,IY,IZ) = ((BVOL(IX,IY,IZ)+(ISPLIT-1)*DTSPLIT
     .           *VDERSPLT(ISEG))*CARAY(IX,IY,IZ,ISYS) + DTSPLIT*DMSPLT)
     .                /BVOLN(IX,IY,IZ)
C        PREVENT NEGATIVE SOLUTIONS
            IF(CONCS(IX,IY,IZ).LT.CMIN(ISYS))
     .        CONCS(IX,IY,IZ) = MAX(CARAY(IX,IY,IZ,ISYS)/4.,CMIN(ISYS))

  120   CONTINUE

C        CHECK FOR MASS/FLUX BALANCE COMPUTATIONS
        IF(MASSBAL.EQ.0) GO TO 123
C        INSTANTANEOUS OR AVERAGED
        IF(IMBDOPT.EQ.0) THEN 
          IF(ITIMESECS.NE.NXPRTMB) GO TO 123
          DO  ISEG=1,NSEGSPLT
           IX = ISEGSPLT(ISEG,1)
           IY = ISEGSPLT(ISEG,2)
           IZ = ISEGSPLT(ISEG,3)
           FLXMB(IX,IY,IZ,ISYS) = FLXMB(IX,IY,IZ,ISYS) + 1./NSPLIT*
     .         (AMAX1(0.,QX(IX,IY,IZ)*CARAY(IX-1,IY,IZ,ISYS))
     .        + AMIN1(0.,QX(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)) 
     .        + RX(IX,IY,IZ)*
     .           (CARAY(IX-1,IY,IZ,ISYS)-CARAY(IX,IY,IZ,ISYS)))
           FLXMB(IX+1,IY,IZ,ISYS) = FLXMB(IX+1,IY,IZ,ISYS) +
     .          1./NSPLIT*(1.-FSMSPLT(IX+1,IY,IZ))*
     .         (AMAX1(0.,QX(IX+1,IY,IZ)*CARAY(IX,IY,IZ,ISYS))
     .        + AMIN1(0.,QX(IX+1,IY,IZ)*CARAY(IX+1,IY,IZ,ISYS))
     .        + RX(IX+1,IY,IZ)*
     .           (CARAY(IX,IY,IZ,ISYS)-CARAY(IX+1,IY,IZ,ISYS)))
           FLYMB(IX,IY,IZ,ISYS) = FLYMB(IX,IY,IZ,ISYS) + 1./NSPLIT*
     .         (AMAX1(0.,QY(IX,IY,IZ)*CARAY(IX,IY-1,IZ,ISYS))
     .        + AMIN1(0.,QY(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS))
     .        + RY(IX,IY,IZ)*
     .           (CARAY(IX,IY-1,IZ,ISYS)-CARAY(IX,IY,IZ,ISYS)))
           FLYMB(IX,IY+1,IZ,ISYS) = FLYMB(IX+1,IY,IZ,ISYS) +
     .          1./NSPLIT*(1.-FSMSPLT(IX,IY+1,IZ))*
     .         (AMAX1(0.,QY(IX,IY+1,IZ)*CARAY(IX,IY,IZ,ISYS))
     .        + AMIN1(0.,QY(IX,IY+1,IZ)*CARAY(IX,IY+1,IZ,ISYS))
     .        + RY(IX,IY+1,IZ)*
     .           (CARAY(IX,IY,IZ,ISYS)-CARAY(IX,IY+1,IZ,ISYS)))
          ENDDO
        ELSE
          IF(ITIMESECS.LT.ISMBSECS) GO TO 123
          DO  ISEG=1,NSEGSPLT
           IX = ISEGSPLT(ISEG,1)
           IY = ISEGSPLT(ISEG,2)
           IZ = ISEGSPLT(ISEG,3)
           FLXMB(IX,IY,IZ,ISYS) = FLXMB(IX,IY,IZ,ISYS) + DTSPLIT*
     .         (AMAX1(0.,QX(IX,IY,IZ)*CARAY(IX-1,IY,IZ,ISYS))
     .        + AMIN1(0.,QX(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS))
     .        + RX(IX,IY,IZ)*
     .           (CARAY(IX-1,IY,IZ,ISYS)-CARAY(IX,IY,IZ,ISYS)))
           FLXMB(IX+1,IY,IZ,ISYS) = FLXMB(IX+1,IY,IZ,ISYS) + DTSPLIT*
     .          (1.-FSMSPLT(IX+1,IY,IZ))*
     .         (AMAX1(0.,QX(IX+1,IY,IZ)*CARAY(IX,IY,IZ,ISYS))
     .        + AMIN1(0.,QX(IX+1,IY,IZ)*CARAY(IX+1,IY,IZ,ISYS))
     .        + RX(IX+1,IY,IZ)*
     .           (CARAY(IX,IY,IZ,ISYS)-CARAY(IX+1,IY,IZ,ISYS)))
           FLYMB(IX,IY,IZ,ISYS) = FLYMB(IX,IY,IZ,ISYS) + DTSPLIT*
     .         (AMAX1(0.,QY(IX,IY,IZ)*CARAY(IX,IY-1,IZ,ISYS))
     .        + AMIN1(0.,QY(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS))
     .        + RY(IX,IY,IZ)*
     .           (CARAY(IX,IY-1,IZ,ISYS)-CARAY(IX,IY,IZ,ISYS)))
           FLYMB(IX,IY+1,IZ,ISYS) = FLYMB(IX,IY+1,IZ,ISYS) + DTSPLIT*
     .          (1.-FSMSPLT(IX,IY+1,IZ))*
     .         (AMAX1(0.,QY(IX,IY+1,IZ)*CARAY(IX,IY,IZ,ISYS))
     .        + AMIN1(0.,QY(IX,IY+1,IZ)*CARAY(IX,IY+1,IZ,ISYS))
     .        + RY(IX,IY+1,IZ)*
     .           (CARAY(IX,IY,IZ,ISYS)-CARAY(IX,IY+1,IZ,ISYS)))
          ENDDO
        ENDIF

  123   DO 155 ISEG=1,NSEGSPLT
          IX = ISEGSPLT(ISEG,1)
          IY = ISEGSPLT(ISEG,2)
          IZ = ISEGSPLT(ISEG,3)
          CARAY(IX,IY,IZ,ISYS) = CONCS(IX,IY,IZ)
  155   CONTINUE

  180  CONTINUE

      DO 185 ISEG=1,NSEGSPLT
        IX = ISEGSPLT(ISEG,1)
        IY = ISEGSPLT(ISEG,2)
        IZ = ISEGSPLT(ISEG,3)
        DM(IX,IY,IZ,ISYS) = 0.0
  185  CONTINUE

  190 CONTINUE

C        UPDATE VOLUMES FOR CRITICAL SEGMENTS
      DO 195 ISEG=1,NSEGSPLT
        IX = ISEGSPLT(ISEG,1)
        IY = ISEGSPLT(ISEG,2)
        IZ = ISEGSPLT(ISEG,3)
        BVOL(IX,IY,IZ) = BVOLN(IX,IY,IZ)
  195 CONTINUE

  200 CONTINUE
c     print *,'after splits'
c     write(6,'(10e11.3)') caray(39:40,39,1:NZ,11)
c     write(6,'(10e11.3)') caray(39:40,41,1:NZ,11)
c     write(6,'(10e11.3)') caray(39:40,43,1:NZ,11)

C-----------------------------------------------------------------------
C        NOW TAKE FULL EXPLICIT STEP FOR REMAINING WATER SEGMENTS

C        COMPUTE VOLUMES AT TIME LEVEL 'N+1'
c$doacross local(iz,iy,ix)
      DO 210 IZ=1,NZ
        DO 210 IY=1,NY
          DO 210 IX=1,NX
            BVOLN(IX,IY,IZ) = BVOL(IX,IY,IZ) +
     .           (FSM(IX,IY)-FSMSPLT(IX,IY,IZ))*DT*VDER(IX,IY,IZ)
 210  CONTINUE
 
C        UPDATE -DM- TO INCLUDE KINETICS AND LOADS
c$doacross local(isys,iz,iy,ix,is,ie)
      DO 215 ISYS=1,NOSYS
       DO 215 IZ=1,NZ
        DO 215 IY=1,NY
         IS = IXS(IY)
         IE = IXE(IY)
         IF(IS.EQ.0) GO TO 215
         DO 214 IX=IS,IE
          DM(IX,IY,IZ,ISYS) = DM(IX,IY,IZ,ISYS)
     .       + (FSM(IX,IY)-FSMSPLT(IX,IY,IZ))*CDARAYS(IX,IY,IZ,ISYS)
  214    CONTINUE
  215 CONTINUE
 
c$doacross local(isys,iy,ix,iz,is,ie,i,j,ilyr,aa,fmax,fmin,inegs,totmas,
c$&        concs,antiqx,antiqy,antiqz,qxflx,qyflx,qzflx,fluxin,fluxout,
c$&        rxflx,ryflx),share(negseg)
c$&        ,mp_schedtype=dynamic, chunk=1

c          rxflx,ryflx,mf,al,ad,au,beta,gamma),share(negseg)
      DO 400 ISYS=1,NOSYS 
C        CHECK FOR SYSTEM BYPASS
      IF(SYSBY(ISYS).EQ.1) GO TO 400
      INEGS=0
      TOTMAS=0.0

C  CALCULATE CHANGE IN CONCENTRATION DUE TO ADVECTIVE TRANSPORT
C    AND HORIZONTAL MIXING PROCESSES
      IF (NZ.GT.1) THEN
C      SURFACE LAYER
        DO 220 IY=1,NY
          IS = IXS(IY)
          IE = IXE(IY)
          IF(IS.EQ.0) GO TO 220
          DO 219 IX=IS,IE
            IF(FSM(IX,IY).NE.1.)GO TO 219
            DM(IX,IY,1,ISYS) = DM(IX,IY,1,ISYS)
     .        - DIAG(IX,IY,1)*CARAY(IX,IY,1,ISYS)
     .         + AVECT(IX,IY,1,1)*CARAY(IX-1,IY,1,ISYS)
     .          + AVECT(IX,IY,1,2)*CARAY(IX+1,IY,1,ISYS)
     .           + AVECT(IX,IY,1,3)*CARAY(IX,IY-1,1,ISYS)
     .            + AVECT(IX,IY,1,4)*CARAY(IX,IY+1,1,ISYS)
     .             + AVECT(IX,IY,1,6)*CARAY(IX,IY,2,ISYS)
            CONCS(IX,IY,1) = (BVOL(IX,IY,1)*CARAY(IX,IY,1,ISYS)
     .                         + DT*DM(IX,IY,1,ISYS))/BVOLN(IX,IY,1)
  219     CONTINUE
  220   CONTINUE
C      LAYERS 2 TO NZ-1
        DO 225 IZ=2,NZ-1
          DO 225 IY=1,NY
            IS = IXS(IY)
            IE = IXE(IY)
            IF(IS.EQ.0) GO TO 225
            DO 224 IX=IS,IE
              IF(FSM(IX,IY).NE.1.)GO TO 224
              DM(IX,IY,IZ,ISYS) = DM(IX,IY,IZ,ISYS)
     .         - DIAG(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)
     .          + AVECT(IX,IY,IZ,1)*CARAY(IX-1,IY,IZ,ISYS)
     .           + AVECT(IX,IY,IZ,2)*CARAY(IX+1,IY,IZ,ISYS)
     .            + AVECT(IX,IY,IZ,3)*CARAY(IX,IY-1,IZ,ISYS)
     .             + AVECT(IX,IY,IZ,4)*CARAY(IX,IY+1,IZ,ISYS)
     .              + AVECT(IX,IY,IZ,5)*CARAY(IX,IY,IZ-1,ISYS)
     .               + AVECT(IX,IY,IZ,6)*CARAY(IX,IY,IZ+1,ISYS)
              CONCS(IX,IY,IZ) = (BVOL(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)
     .                           + DT*DM(IX,IY,IZ,ISYS))/BVOLN(IX,IY,IZ)
  224       CONTINUE
  225   CONTINUE
C      BOTTOM LAYER
        DO 230 IY=1,NY
          IS = IXS(IY)
          IE = IXE(IY)
          IF(IS.EQ.0) GO TO 230
          DO 229 IX=IS,IE
            IF(FSM(IX,IY).NE.1.)GO TO 229
            DM(IX,IY,NZ,ISYS) = DM(IX,IY,NZ,ISYS)
     .        - DIAG(IX,IY,NZ)*CARAY(IX,IY,NZ,ISYS)
     .         + AVECT(IX,IY,NZ,1)*CARAY(IX-1,IY,NZ,ISYS)
     .          + AVECT(IX,IY,NZ,2)*CARAY(IX+1,IY,NZ,ISYS)
     .           + AVECT(IX,IY,NZ,3)*CARAY(IX,IY-1,NZ,ISYS)
     .            + AVECT(IX,IY,NZ,4)*CARAY(IX,IY+1,NZ,ISYS)
     .             + AVECT(IX,IY,NZ,5)*CARAY(IX,IY,NZ-1,ISYS)
            CONCS(IX,IY,NZ) =
     .             (BVOL(IX,IY,NZ)*CARAY(IX,IY,NZ,ISYS)
     .                   + DT*DM(IX,IY,NZ,ISYS))/BVOLN(IX,IY,NZ)
  229     CONTINUE
  230   CONTINUE
c     if(isys.eq.11) then
c     print *,'concs'
c     write(6,'(10e11.3)') concs(39:40,39,1:NZ)
c     write(6,'(10e11.3)') concs(39:40,41,1:NZ)
c     write(6,'(10e11.3)') concs(39:40,43,1:NZ)
c     endif
 
      ELSE
 
C        ONE LAYER MODEL
        IZ=1
        DO 235 IY=1,NY
          IS = IXS(IY)
          IE = IXE(IY)
          IF(IS.EQ.0) GO TO 235
          DO 234 IX=IS,IE
            IF(FSM(IX,IY).NE.1.)GO TO 234
            DM(IX,IY,IZ,ISYS) = DM(IX,IY,IZ,ISYS)
     .       - DIAG(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)
     .        + AVECT(IX,IY,IZ,1)*CARAY(IX-1,IY,IZ,ISYS)
     .         + AVECT(IX,IY,IZ,2)*CARAY(IX+1,IY,IZ,ISYS)
     .          + AVECT(IX,IY,IZ,3)*CARAY(IX,IY-1,IZ,ISYS)
     .           + AVECT(IX,IY,IZ,4)*CARAY(IX,IY+1,IZ,ISYS)

            CONCS(IX,IY,IZ) = (BVOL(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)
     .                         + DT*DM(IX,IY,IZ,ISYS))/BVOLN(IX,IY,IZ)
  234     CONTINUE
  235   CONTINUE

      ENDIF
c     if(isys.eq.11) then
c     print *,'before horiz bc'
c     write(6,'(10e11.3)') concs(39:40,39,1:NZ),dm(39:40,39,1:NZ,11)
c     write(6,'(10e11.3)') concs(39:40,41,1:NZ),dm(39:40,41,1:NZ,11)
c     write(6,'(10e11.3)') concs(39:40,43,1:NZ),dm(39:40,43,1:NZ,11)
c     endif
 
C  BOUNDARY ELEMENTS ARE UNCHANGED
      DO 240 I=1,NOBCALL
        IX=IBCALL(1,I)
        IY=IBCALL(2,I)
        IZ=IBCALL(3,I)
        CONCS(IX,IY,IZ)=CARAY(IX,IY,IZ,ISYS)
  240 CONTINUE

C        CHECK FOR MASS/FLUX BALANCE COMPUTATIONS
      IF(MASSBAL.EQ.0) GO TO 260
C        INSTANTANEOUS OR AVERAGED
      IF(IMBDOPT.EQ.0 .AND. ITIMESECS.NE.NXPRTMB) GO TO 260
      IF(ITIMESECS.LT.ISMBSECS) GO TO 260
      DO 250 IZ=1,NZ
       DO 250 IY=1,NY
        DO 250 IX=1,NX
         IF(FSM(IX,IY).NE.1.) GO TO 250
         FLXMB(IX,IY,IZ,ISYS) = FLXMB(IX,IY,IZ,ISYS) + DTMB*
     .        (1.-FSMSPLT(IX,IY,IZ))*
     .        (AMAX1(0.,QX(IX,IY,IZ)*CARAY(IX-1,IY,IZ,ISYS))
     .       + AMIN1(0.,QX(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS))
     .       + RX(IX,IY,IZ)*
     .          (CARAY(IX-1,IY,IZ,ISYS)-CARAY(IX,IY,IZ,ISYS)))
         FLYMB(IX,IY,IZ,ISYS) = FLYMB(IX,IY,IZ,ISYS) + DTMB*
     .        (1.-FSMSPLT(IX,IY,IZ))*
     .        (AMAX1(0.,QY(IX,IY,IZ)*CARAY(IX,IY-1,IZ,ISYS))
     .       + AMIN1(0.,QY(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS))
     .       + RY(IX,IY,IZ)*
     .          (CARAY(IX,IY-1,IZ,ISYS)-CARAY(IX,IY,IZ,ISYS)))
  250 CONTINUE

  260 CONTINUE
C        CHECK TO SEE IF THERE ARE SINK/SOURCE CONNECTIONS
C        SINK/SOURCE CONNECTIONS ARE IN PAIRS (FROM/TO -QFR/+QTO)
      IF(NOSSQ.NE.0) THEN
        DTSS = DTFULL/FLOAT(NSSSPLIT)
        DO ITIME=1,NSSSPLIT
          DO ISSCNT=1,NOSSQ,2
            IXFR=ISSQ(ISSCNT)
            IYFR=JSSQ(ISSCNT)
            IXTO=ISSQ(ISSCNT+1)
            IYTO=JSSQ(ISSCNT+1)
            DMASS=0.0
            DO IZ=1,NZ
              CDTERM = QSSQ(ISSCNT)*VSSQDIST(ISSCNT,IZ)*
     .                 CARAY(IXFR,IYFR,IZ,ISYS)
              DMASS = DMASS+CDTERM
              CONCS(IXFR,IYFR,IZ) = CONCS(IXFR,IYFR,IZ)
     .              + DTSS*CDTERM/BVOLN(IXFR,IYFR,IZ)
            ENDDO
C        ADJUST DMASS IN CASE SOME FLOW IS LOST VIA INLINE PROCESSES
            DMASS = DMASS*ABS(QSSQ(ISSCNT)/(QSSQ(ISSCNT+1)+1.E-20))
            DO IZ=1,NZ
              CONCS(IXTO,IYTO,IZ) = CONCS(IXTO,IYTO,IZ)
     .          -DTSS*DMASS*VSSQDIST(ISSCNT+1,IZ)/BVOLN(IXTO,IYTO,IZ)
            ENDDO
          ENDDO
        ENDDO
      ENDIF
c     if(isys.eq.11) then
c     print *,'after from/to'
c     write(6,'(10e11.3)') concs(39:40,39,1:NZ),dm(39:40,39,1:NZ,11)
c     write(6,'(10e11.3)') concs(39:40,41,1:NZ),dm(39:40,41,1:NZ,11)
c     totmas=0.0
c     do iz=1,nz
c      totmas=totmas+concs(40,41,iz)*bvoln(40,41,iz)
c     enddo
c     print *,'totmas=',totmas
c     write(6,'(10e11.3)') concs(39:40,43,1:NZ),dm(39:40,43,1:NZ,11)
c     endif

C***********************************************************************
C        COMPLETE REST OF INTEGRATION STEP
C        I.E., THE IMPLICIT VERTICAL DIFFUSION STEP  (IF NZ > 1)
      IF (NZ.EQ.1) GO TO 390
      DO 350 IZ=1,NZ
       DO 350 IY=1,NY
        IS = IXS(IY)
        IE = IXE(IY)
        IF(IS.EQ.0) GO TO 350
        DO 349 IX=IS,IE
          MF(IX,IY,IZ) = CONCS(IX,IY,IZ)*BVOLN(IX,IY,IZ)
 349    CONTINUE
 350  CONTINUE
C        SET UP DIAGONAL AND OFF-DIAGONAL ELEMENTS
      DO 360 IY=1,NY
       IS = IXS(IY)
       IE = IXE(IY)
       IF(IS.EQ.0) GO TO 360
       DO 359 IX=IS,IE
        IF(FSM(IX,IY).NE.1.) GO TO 359
        AL(IX,IY,1) = 0.
        AD(IX,IY,1) = BVOLN(IX,IY,1) + DT*RZ(IX,IY,2)
        AU(IX,IY,1) = -DT*RZ(IX,IY,2)
        DO 355 IZ=2,NZ-1
         AL(IX,IY,IZ) = -DT*RZ(IX,IY,IZ)
         AD(IX,IY,IZ) = BVOLN(IX,IY,IZ) +
     .                     DT*(RZ(IX,IY,IZ) + RZ(IX,IY,IZ+1))
         AU(IX,IY,IZ) = -DT*RZ(IX,IY,IZ+1)
  355   CONTINUE
        AL(IX,IY,NZ) = -DT*RZ(IX,IY,NZ)
        AD(IX,IY,NZ) = BVOLN(IX,IY,NZ) + DT*RZ(IX,IY,NZ)
        AU(IX,IY,NZ) = 0.0
  359  CONTINUE
  360 CONTINUE
C        FORWARD SWEEP OF TRIDIAGONAL SCHEME
      DO 370 IY=1,NY
       IS = IXS(IY)
       IE = IXE(IY)
       IF(IS.EQ.0) GO TO 370
       DO 369 IX=IS,IE
        IF(FSM(IX,IY).NE.1.) GO TO 369
        BETA(IX,IY,1) = AD(IX,IY,1)
        GAMMA(IX,IY,1) = MF(IX,IY,1)/BETA(IX,IY,1)
        DO 365 IZ=2,NZ
         BETA(IX,IY,IZ) = AD(IX,IY,IZ)
     .               - AL(IX,IY,IZ)*AU(IX,IY,IZ-1)/BETA(IX,IY,IZ-1)
         GAMMA(IX,IY,IZ) = (MF(IX,IY,IZ)
     .               - AL(IX,IY,IZ)*GAMMA(IX,IY,IZ-1))/BETA(IX,IY,IZ)
  365   CONTINUE
  369  CONTINUE
  370 CONTINUE
C        BACKWARD SWEEP FOR SOLUTION
      DO 380 IY=1,NY
       IS = IXS(IY)
       IE = IXE(IY)
       IF(IS.EQ.0) GO TO 380
       DO 379 IX=IS,IE
        IF(FSM(IX,IY).NE.1.) GO TO 379
        CONCS(IX,IY,NZ) = GAMMA(IX,IY,NZ)
        DO 375 ILYR=2,NZ
         IZ = NZ+1-ILYR
         CONCS(IX,IY,IZ) = GAMMA(IX,IY,IZ)
     .           - AU(IX,IY,IZ)*CONCS(IX,IY,IZ+1)/BETA(IX,IY,IZ)
  375   CONTINUE
  379  CONTINUE
  380 CONTINUE
c     if(isys.eq.11) then
c     print *,'after implicit'
c     write(6,'(10e11.3)') concs(39:40,39,1:NZ)
c     write(6,'(10e11.3)') concs(39:40,41,1:NZ)
c     totmas=0.0
c     do iz=1,nz
c      totmas=totmas+concs(40,41,iz)*bvoln(40,41,iz)
c     enddo
c     print *,'totmas=',totmas
c     write(6,'(10e11.3)') concs(39:40,43,1:NZ)
c     endif

C  BOUNDARY ELEMENTS ARE UNCHANGED
      DO 385 I=1,NOBCALL
        IX=IBCALL(1,I)
        IY=IBCALL(2,I)
        IZ=IBCALL(3,I)
        CONCS(IX,IY,IZ)=CARAY(IX,IY,IZ,ISYS)
  385 CONTINUE
 
  390 CONTINUE

C        CHECK TO SEE IF NEGATIVE SOLUTIONS PERMITTED 
      DO 395 IZ=1,NZ
        DO 395 IY=1,NY
          IS = IXS(IY)
          IE = IXE(IY)
          IF(IS.EQ.0) GO TO 395
          DO 394 IX=IS,IE
            IF(FSM(IX,IY).NE.1.) GO TO 394
            IF (NEGSLN.EQ.1) THEN
              CARAY(IX,IY,IZ,ISYS) = CONCS(IX,IY,IZ)
            ELSE
C        IF NOT ... CHECK TO MAKE SURE SOLUTION IS NOT
C                   FORCED THRU ZERO (OR <CMIN>  RECOMMEND = 1.0E-20)
              IF(CONCS(IX,IY,IZ).GE.CMIN(ISYS)) THEN
                CARAY(IX,IY,IZ,ISYS) = CONCS(IX,IY,IZ)
              ELSE
C          PREVENT NEG SOLN BY QUARTERING PRESENT CONC AND PRINT WARNING
c               print *,'negative conc at time in ix,iy,iz,isys'
c               write(6,'(f7.3,4i5,2e12.4)')  time,ix,iy,iz,isys,
c    .                    concs(ix,iy,iz),cmin(isys)
                CARAY(IX,IY,IZ,ISYS) =
     .                      MAX(CARAY(IX,IY,IZ,ISYS)/4.,CMIN(ISYS))
c$        call mp_setlock
                INEGS = INEGS+1
                IF(INEGS.LE.99) THEN
                  NEGSEG(INEGS,1) = IX
                  NEGSEG(INEGS,2) = IY
                  NEGSEG(INEGS,3) = IZ
                ENDIF
                TOTMAS = TOTMAS+BVOLN(IX,IY,IZ)*
     .                   (CARAY(IX,IY,IZ,ISYS)-CONCS(IX,IY,IZ))
                ADDMASS(IX,IY,IZ,ISYS) = ADDMASS(IX,IY,IZ,ISYS) +
     .           BVOLN(IX,IY,IZ)*(CARAY(IX,IY,IZ,ISYS)-CONCS(IX,IY,IZ))
                IWRTADDM=1
c$        call mp_unsetlock
                ENDIF
              ENDIF
  394     CONTINUE
  395 CONTINUE

      IF(IADDMDEBUG.EQ.1) THEN
       IF(INEGS.GT.0)  THEN
         CALL RCAMESS(2,0.001*TOTMAS)
C$          call mp_setlock
         WRITE(OUT,1000)  ((NEGSEG(I,J),J=1,3),I=1,MIN(INEGS,99))
 1000    FORMAT(30X,12I5)
C$           call mp_unsetlock
       ENDIF
      ENDIF

  400 CONTINUE

C        SEE IF MASS HAS BEEN ADDED TO SYSTEM
      IF(IWRTADDM.EQ.1) THEN
        OPEN(19,FILE='RCAFADDM',FORM='UNFORMATTED',STATUS='REPLACE')
        WRITE(19)  ADDMASS
        CLOSE(19)
        IWRTADDM=0
      ENDIF

C        FLUX BALANCES FOR MISC KINETIC VARIABLES
      IF(MASSBAL.EQ.0 .OR. NOKINSYS.EQ.0) GO TO 410
C        INSTANTANEOUS OR AVERAGED
      IF(IMBDOPT.EQ.0) THEN 
       IF(ITIMESECS.NE.NXPRTMB) GO TO 410
       DO 405 ISYS=1,NOKINSYS
        DO 405 IZ=1,NZ
         DO 405 IY=1,NY
          DO 405 IX=1,NX
           IF(FSM(IX,IY).NE.1.) GO TO 405
            FLXMB(IX,IY,IZ,NOSYS+ISYS) = 
     .         (AMAX1(0.,QX(IX,IY,IZ)*CKINARRAY(IX-1,IY,IZ,ISYS))
     .        + AMIN1(0.,QX(IX,IY,IZ)*CKINARRAY(IX,IY,IZ,ISYS))
     .        + RX(IX,IY,IZ)
     .           *(CKINARRAY(IX-1,IY,IZ,ISYS)-CKINARRAY(IX,IY,IZ,ISYS)))
            FLYMB(IX,IY,IZ,NOSYS+ISYS) = 
     .         (AMAX1(0.,QY(IX,IY,IZ)*CKINARRAY(IX,IY-1,IZ,ISYS))
     .        + AMIN1(0.,QY(IX,IY,IZ)*CKINARRAY(IX,IY,IZ,ISYS))
     .        + RY(IX,IY,IZ)
     .           *(CKINARRAY(IX,IY-1,IZ,ISYS)-CKINARRAY(IX,IY,IZ,ISYS)))
  405  CONTINUE
      ELSE
       DO 407 ISYS=1,NOKINSYS
        DO 407 IZ=1,NZ
         DO 407 IY=1,NY
          DO 407 IX=1,NX
           IF(FSM(IX,IY).NE.1.) GO TO 407
            FLXMB(IX,IY,IZ,NOSYS+ISYS) = FLXMB(IX,IY,IZ,NOSYS+ISYS) 
     .        +DT*(AMAX1(0.,QX(IX,IY,IZ)*CKINARRAY(IX-1,IY,IZ,ISYS))
     .            +AMIN1(0.,QX(IX,IY,IZ)*CKINARRAY(IX,IY,IZ,ISYS))
     .            + RX(IX,IY,IZ)
     .           *(CKINARRAY(IX-1,IY,IZ,ISYS)-CKINARRAY(IX,IY,IZ,ISYS)))
            FLYMB(IX,IY,IZ,NOSYS+ISYS) = FLYMB(IX,IY,IZ,NOSYS+ISYS) 
     .        +DT*(AMAX1(0.,QY(IX,IY,IZ)*CKINARRAY(IX,IY-1,IZ,ISYS))
     .            +AMIN1(0.,QY(IX,IY,IZ)*CKINARRAY(IX,IY,IZ,ISYS))
     .            + RY(IX,IY,IZ)
     .           *(CKINARRAY(IX,IY-1,IZ,ISYS)-CKINARRAY(IX,IY,IZ,ISYS)))
  407  CONTINUE
      ENDIF
        
C***********************************************************************

C        UPDATE VOLUMES FOR NEXT TIMESTEP
  410 DO 415 IZ=1,NZ
       DO 415 IY=1,NY
        DO 415 IX=1,NX
         BVOL(IX,IY,IZ) = BVOLN(IX,IY,IZ)
  415 CONTINUE

C  PREPARE FOR NEXT TIME STEP
      ITIMESECS = ITIMESECS + IDTSECS
      TIME = ITIMESECS/86400.
 
C        CHECK TO SEE IF IT IS TIME TO PRINT RESULTS
 
C  FIRST DETAILED DUMPS
      IF(ITIMESECS.LT.NXPRTD) GO TO 435
C  DETAILED PRINT TIME
C  SET IDISK FOR DETAILED DUMPS
      IDISK=2
      NXPRTD = NXPRTD + IPRNTDSECS
C  SECOND GLOBAL DUMPS
 435  IF(ITIMESECS.LT.NXPRTG) GO TO 450
C  GLOBAL PRINT TIME
C  CALL PRINT ROUTINE
      CALL RCA09
      IDISK=IDISK+1
      NXPRTG = NXPRTG + IPRNTGSECS
       
C  NOW PERFORM STABILITY CHECK
      DO 445 ISYS=1,NOSYS 
        IF(SYSBY(ISYS).EQ.1) GO TO 445
        CKMAX = CMAX(ISYS)
        DO 440 IZ=1,NZ
          DO 440 IY=1,NY
            IS = IXS(IY)
            IE = IXE(IY)
            IF(IS.EQ.0) GO TO 440
            DO 439 IX=IS,IE
              IF(FSM(IX,IY).NE.1.) GO TO 439
              IF(CARAY(IX,IY,IZ,ISYS).GE.CKMAX) GO TO 500
  439       CONTINUE
  440   CONTINUE
  445 CONTINUE

C  MASS/FLUX BALANCE DUMPS
  450 IF(MASSBAL.EQ.0) GO TO 470
      IF(ITIMESECS.LT.NXPRTMB) GO TO 470
       IF(IMBDOPT.EQ.0) THEN
        WRITE(17)  TIME,SYSMASS,SYSLOADS,FLXMB,FLYMB
       ELSE
        TIMEAVE=FLOAT(IPRNTMBSECS)/86400.
        DO 455 ISYS=1,NOSYS+NOKINSYS
         DO 455 IZ=1,NZ
          DO 455 IY=1,NY
           DO 455 IX=1,NX
            FLXMB(IX,IY,IZ,ISYS)=FLXMB(IX,IY,IZ,ISYS)/TIMEAVE
            FLYMB(IX,IY,IZ,ISYS)=FLYMB(IX,IY,IZ,ISYS)/TIMEAVE
  455   CONTINUE
        DO ISYS=1,NOSYS
         DO I=1,4
          SYSLOADS(I,ISYS)=SYSLOADS(I,ISYS)/TIMEAVE
         ENDDO
        ENDDO
        WRITE(17)  TIME,SYSMASS,SYSLOADS,FLXMB,FLYMB
       ENDIF
C        RESET ARRAYS AND COUNTER
      DO 460 ISYS=1,NOSYS
       DO 460 I=1,4
        SYSLOADS(I,ISYS)=0.
  460 CONTINUE
      DO 465 ISYS=1,NOSYS+NOKINSYS
       DO 465 IZ=1,NZ
        DO 465 IY=1,NY
         DO 465 IX=1,NX
          FLXMB(IX,IY,IZ,ISYS)=0.0
          FLYMB(IX,IY,IZ,ISYS)=0.0
  465 CONTINUE
      NXPRTMB = NXPRTMB + IPRNTMBSECS
      IF(NXPRTMB.GT.IEMBSECS) MASSBAL=0

C        CHECK TO SEE IF USER WISHES TO TERMINATE RUN
      CALL CHECKSTOP(IVAL)
      IF(IVAL.EQ.0) GO TO 470
C        TERMINATE / CALL TUNER TO PERFORM LAST DUMPS
      CALL TUNER
      WRITE(OUT,7000)
 7000 FORMAT(///30X,'USER REQUESTED TERMINATION VIA CHECKSTOP FILE'/
     .          30X,'RCASPLT FINISHED INTEGRATION')
      IF(MASSBAL.EQ.1) THEN
        DEALLOCATE(FLXMB)
        DEALLOCATE(FLYMB)
      ENDIF
      CALL EXIT


C        CHECK TO SEE IF NECESSARY TO UPDATE TIME-VARIABLE FUNCTIONS
C        POINT SOURCE LOADS 
  470 IF(IPSOPT.GT.1.AND.TIME.GE.NXPST) THEN
         CALL RCA10(SPS,BPS,MXWK,NOPS,NXPST,33,IPSPWLOPT,SCALPS)
      ENDIF
C        NONPOINT SOURCE LOADS 
      IF(INPSOPT.GT.1.AND.TIME.GE.NXNPST) THEN
         CALL RCA10(SNPS,BNPS,MXWK,NONPS,NXNPST,34,INPSPWLOPT,SCALNPS)
      ENDIF
C        FALL-LINE LOADS 
      IF(IFLOPT.GT.1.AND.TIME.GE.NXFLT) THEN
         CALL RCA10(SFL,BFL,MXWK,NOFL,NXFLT,35,IFLPWLOPT,SCALFL)
      ENDIF
C        ATMOSPHERIC LOADS 
      IF(IATMOPT.GT.1.AND.TIME.GE.NXATMT) THEN
         CALL RCA10(SATM,BATM,NX*NY,NOATM,NXATMT,36,IATMPWLOPT,
     .              SCALATM)
      ENDIF
C        NEXT BOUNDARY CONDITIONS 
      IF(IBCOPT.GT.1.AND.TIME.GT.NXBCT) CALL RCA11 

C        CHECK TO SEE IF NECESSARY TO UPDATE TRANSPORT FIELDS
C     IF(ITIMESECS.GE.HYDBRK(ITIMHYD)) THEN
      IF(ITIMESECS.GE.NXHYDTSECS) THEN
         CALL RCA03A
         CALL RCASPLT1
C        ITIMHYD = ITIMHYD+1
      ENDIF

C        CHECK FOR END OF SIMULATION...
C           IF NOT GO BACK AND TAKE NEXT INTEGRATION STEP

      IF(TIME.LE.TEND) GO TO 30 


C        FINISHED...
      WRITE(OUT,8000)
 8000 FORMAT(///30X,'RCASPLT FINISHED INTEGRATION'/
     .          30X,'USER DUMPS TO FOLLOW'//)
      IF(MASSBAL.EQ.1) THEN
        DEALLOCATE(FLXMB)
        DEALLOCATE(FLYMB)
      ENDIF
      RETURN

C         STABILITY CRITERIA VIOLATED...ABEND 
  500 CALL RCAMESS(1,CKMAX) 
      WRITE(OUT,9000)  BVOLN(IX,IY,IZ),DIAG(IX,IY,IZ)
 9000 FORMAT(10X,'VOLUME =',E13.4,'  ,DIAGONAL =',E13.4)
      IREC = IREC+1 
      IDISK = 1 
      INITB = 2
      CALL TUNER
      RETURN
      END 
