      SUBROUTINE  RCASPLT2
C 
C        RCASPLT2 SETS UP THE -QSPLT- AND -RSPLT- VECTORS
C                 FOR THE SPLIT AND FULL TIMESTEP SEGMENTS
C                 FOR RCASPLTFL
C 
      SAVE

      INCLUDE  'RCACM'

      REAL
     .    QXSPLT(MXSEGSPLT,2),QYSPLT(MXSEGSPLT,2),QZSPLT(MXSEGSPLT,2)
     .   ,USPLT(MXSEGSPLT,2),VSPLT(MXSEGSPLT,2),WSPLT(MXSEGSPLT,2)
      REAL   TIMESTEP(NX,NY,NZ)
      EQUIVALENCE
     .   (AVECTSPLT(1,1),QXSPLT(1,1)) , (AVECTSPLT(1,3),QYSPLT(1,1))
     .  ,(AVECTSPLT(1,5),QZSPLT(1,1)) , (AVECTSPLT(1,7),USPLT(1,1))
     .  ,(AVECTSPLT(1,9),VSPLT(1,1))  , (AVECTSPLT(1,11),WSPLT(1,1))
      EQUIVALENCE  (TIMESTEP(1,1,1),SCRATCH_TRAN(1,1,1,1))

      FSMSPLT = 0
      NSEGSPLT = 0
C        IF PERFORMING SPLIT TIMESTEPS (DTSPLIT.NE.DTFULL)
      IF(DTSPLIT.EQ.DTFULL)  RETURN
C        GENERATE VECTOR OF SEGMENTS WITH TIMESTEP
C        REQUIREMENTS BELOW -DTFULL-
      DO 240 IZ=1,NZ
       DO 240 IY=1,NY
        IS = IXS(IY)
        IE = IXE(IY)
        IF(IS.EQ.0)   GO TO 240
        DO 239 IX=IS,IE
         IF(FSM(IX,IY).LE.0.0)  GO TO 239
         IF(0.9*TIMESTEP(IX,IY,IZ).LE.DTFULL)  THEN
           NSEGSPLT = NSEGSPLT+1
           IF(NSEGSPLT.GT.MXSEGSPLT)  GO TO 300
           ISEGSPLT(NSEGSPLT,1) = IX
           ISEGSPLT(NSEGSPLT,2) = IY
           ISEGSPLT(NSEGSPLT,3) = IZ
           FSMSPLT(IX,IY,IZ) = 1
           VDERSPLT(NSEGSPLT) = VDER(IX,IY,IZ)
           VDER(IX,IY,IZ) = 0.0
           QXSPLT(NSEGSPLT,1) = QX(IX,IY,IZ)
           QYSPLT(NSEGSPLT,1) = QY(IX,IY,IZ)
           QZSPLT(NSEGSPLT,1) = QZ(IX,IY,IZ)
           QXSPLT(NSEGSPLT,2) = QX(IX+1,IY,IZ)
           QYSPLT(NSEGSPLT,2) = QY(IX,IY+1,IZ)
           QZSPLT(NSEGSPLT,2) = QZ(IX,IY,IZ+1)
         ENDIF
  239   CONTINUE
  240 CONTINUE

      DO 270 ISEG=1,NSEGSPLT
       IX =  ISEGSPLT(ISEG,1)
       IY =  ISEGSPLT(ISEG,2)
       IZ =  ISEGSPLT(ISEG,3)
       QX(IX,IY,IZ) = 0.0
       QX(IX+1,IY,IZ) = 0.0
       QY(IX,IY,IZ) = 0.0
       QY(IX,IY+1,IZ) = 0.0
       QZ(IX,IY,IZ) = 0.0
       QZ(IX,IY,IZ+1) = 0.0
  270 CONTINUE

      RETURN

  300 WRITE(OUT,3000)   DTFULL,MXSEGSPLT
 3000 FORMAT(///15X,'ERROR...NUMBER OF SEGMENTS BELOW -DTFULL- (',F10.4,
     .   ') EXCEEDED -MXSEGSPLT- OF',I6/15X,'RCA TERMINATED')
      CALL EXIT
      END
