      MODULE ALLOCRCASPLTFL
       REAL, ALLOCATABLE :: FLXMB(:,:,:,:)
       REAL, ALLOCATABLE :: FLYMB(:,:,:,:)
       REAL, ALLOCATABLE :: RMASK(:,:)
      END MODULE ALLOCRCASPLTFL
      SUBROUTINE RCASPLTFL
      USE  ALLOCRCASPLTFL
C 
C        RCASPLTFL IS THE MASTER SUBROUTINE USED TO INTEGRATE THE
C                  DIFFERENTIAL EQUATIONS OF THE WATER QUALITY MODEL.
C                  TIME DERIVATIVE: EXPLICIT - SPLIT TIMESTEP
C                  SPACE DERIVATIVE: UPWIND - FLUX LIMITER (SUPERBEE)
C
C************************************************************************
C 
      SAVE
      INCLUDE 'RCACM' 
      INTEGER  NEGSEG(99,3)
      REAL   CONCS(NX,NY,0:NZ)
     .      ,DM(NX,NY,NZ,NOSYS),BVOLN(NX,NY,NZ),TOTMAS
     .      ,DXBAR(NX,NY),DYBAR(NX,NY)
     .      ,D(NX,NY),U(NX,NY,NZ),V(NX,NY,NZ)
     .      ,W(NX,NY,NZ)
     .      ,AL(NX,NY,NZ),AD(NX,NY,NZ),AU(NX,NY,NZ)
     .      ,BETA(NX,NY,NZ),GAMMA(NX,NY,NZ)
     .      ,MF(NX,NY,NZ),CDARAYS(NX,NY,NZ,NOSYS)
     .      ,SYSMASS(NOSYS+NOKINSYS),SYSLOADS(4,NOSYS) 
     .      ,ADDMASS(NX,NY,NZ,NOSYS)
      REAL
     .    QXSPLT(MXSEGSPLT,2),QYSPLT(MXSEGSPLT,2),QZSPLT(MXSEGSPLT,2)
     .   ,USPLT(MXSEGSPLT,2),VSPLT(MXSEGSPLT,2),WSPLT(MXSEGSPLT,2)
      EQUIVALENCE
     .   (AVECTSPLT(1,1),QXSPLT(1,1)) , (AVECTSPLT(1,3),QYSPLT(1,1))
     .  ,(AVECTSPLT(1,5),QZSPLT(1,1)) , (AVECTSPLT(1,7),USPLT(1,1))
     .  ,(AVECTSPLT(1,9),VSPLT(1,1))  , (AVECTSPLT(1,11),WSPLT(1,1))


C        INITIALIZATION
      ALLOCATE(RMASK(0:NX+1,0:NY+1),STAT=ISTAT)
      RMASK = 0.
      DO IY=1,NY
       DO IX=1,NX
        IF(FSM(IX,IY).EQ.1.) RMASK(IX,IY)=1.
       ENDDO
      ENDDO
      INITMB=0
      ITRAK=1 
      ITIMESECS=0
      ITIMEWQSECS=0
      TIME=0.0
      NXPRTD=IPRNTDSECS
      NXPRTG=IPRNTGSECS
      IWRTADDM=0
      IADDMDEBUG=0
      INITMB=1
      IF(MASSBAL.EQ.1) THEN
        IF(ISMBSECS.EQ.0) THEN
          NXPRTMB=0
          INITMB=0
        ELSE
          NXPRTMB=ISMBSECS
          INITMB=1
        ENDIF
      ENDIF
      INITB=0
      NSPLIT = DTFULL/DTSPLIT
      IF(TZERO.NE.0.) THEN
         TIME = TZERO
         CALL RCA08
         ITIMESECS = 86400.*TZERO
         ITIMEWQSECS = 86400.*TZERO
         NXPRTD = ITIMESECS+IPRNTDSECS
         NXPRTG = ITIMESECS+IPRNTGSECS
         IF(MASSBAL.EQ.1) THEN
           IF(ITIMESECS.LT.ISMBSECS) THEN
             NXPRTMB=ISMBSECS
             INITMB=1
           ELSE
             NXPRTMB = ITIMESECS
             INITMB=0
           ENDIF
         ENDIF
      ENDIF
C        INITIALIZE TUNER
      CALL TUNER_INIT
C        INITIALIZE ARRAYS
      CDARAYS = 0.0
      CONCS = 0.0
      IF(MASSBAL.EQ.1) THEN
       ALLOCATE(FLXMB(NX,NY,NZ,NOSYS+NOKINSYS),STAT=ISTAT)
       ALLOCATE(FLYMB(NX,NY,NZ,NOSYS+NOKINSYS),STAT=ISTAT)
       FLXMB=0.
       FLYMB=0.
       SYSLOADS=0.0
       IF(INITMB.EQ.0) THEN
        DO 16 ISYS=1,NOSYS
         SYSMASS(ISYS)=0.0
         DO 16 IZ=1,NZ
          DO 16 IY=1,NY
           DO 16 IX=1,NX
            IF(FSM(IX,IY).EQ.1.)  SYSMASS(ISYS) = SYSMASS(ISYS) +
     .                            BVOL(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)
  16    CONTINUE
        DO 17 ISYS=1,NOKINSYS
         SYSMASS(NOSYS+ISYS)=0.0
         DO 17 IZ=1,NZ
          DO 17 IY=1,NY
           DO 17 IX=1,NX
            IF(FSM(IX,IY).EQ.1.)
     .                 SYSMASS(NOSYS+ISYS) = SYSMASS(NOSYS+ISYS) +
     .                 BVOL(IX,IY,IZ)*CKINARRAY(IX,IY,IZ,ISYS)
  17    CONTINUE
        WRITE(17)  TIME,SYSMASS,SYSLOADS,FLXMB,FLYMB
        NXPRTMB=NXPRTMB+IPRNTMBSECS
        INITMB=1
       ENDIF
      ENDIF

C        SET UP -AVECT- ARRAYS FOR TIME = 0.0 (TZERO)
      CALL RCASPLT2

C        PRINT INITIAL CONDITIONS
      CALL RCA09
      IDISK = 3 
 
C        BEGINNING OF FULL INTEGRATION TIMESTEP LOOP
   30 CONTINUE

C        GET TOTAL MASS PER SYSTEM IF MASS/FLUX BALANCES REQUESTED
      IF(MASSBAL.EQ.1 .AND. ITIMESECS.EQ.NXPRTMB) THEN
       DO 35 ISYS=1,NOSYS
        SYSMASS(ISYS)=0.0
        DO 35 IZ=1,NZ
         DO 35 IY=1,NY
          DO 35 IX=1,NX
           IF(FSM(IX,IY).EQ.1.)  SYSMASS(ISYS) = SYSMASS(ISYS) +
     .                           BVOL(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)
  35   CONTINUE
       DO 40 ISYS=1,NOKINSYS
        SYSMASS(NOSYS+ISYS)=0.0
        DO 40 IZ=1,NZ
         DO 40 IY=1,NY
          DO 40 IX=1,NX
           IF(FSM(IX,IY).EQ.1.)
     .                SYSMASS(NOSYS+ISYS) = SYSMASS(NOSYS+ISYS) +
     .                BVOL(IX,IY,IZ)*CKINARRAY(IX,IY,IZ,ISYS)
  40   CONTINUE
      ENDIF

C        IF PIECEWISE LINEAR BOUNDARY CONDITIONS THEN
C           GET CONCENTRATIONS AT CURRENT TIME LEVEL
      IF(IBCPWLOPT.EQ.1) THEN
c$doacross local(isys,deltbc,iz,iy,ix,i)
        DO 50 ISYS=1,NOSYS
          IF(NOBC(ISYS).EQ.0) GO TO 50
          DELTBC = TIME - NXBCT
          DO 45 I=1,NOBC(ISYS)
            IX=IBC(1,I,ISYS)
            IY=IBC(2,I,ISYS)
            IZ=IBC(3,I,ISYS)
            CARAY(IX,IY,IZ,ISYS) = DELTBC*SBC(I,ISYS) + BBC(I,ISYS)
   45     CONTINUE
   50  CONTINUE
      ENDIF

C        EVALUATE KINETIC DERIVATIVES
      IF (DTWQ.EQ.0.0.OR.ITIMESECS.GE.ITIMEWQSECS) THEN
        CALL TUNER
        IDISK = 0
        ITIMEWQSECS=ITIMEWQSECS+IDTWQSECS
        TIMEWQ=ITIMEWQSECS/86400.
      ENDIF
      INITB = 1

C        COMPUTE DEPTHS AT TIME LEVEL N
      DELT = TIME - (NXHYDTSECS-IHYDDTSECS)/86400.
c$doacross local(iy,ix) , share(d)
      DO IY=1,NY
       DO IX=1,NX
        D(IX,IY) = H(IX,IY)+ETA(IX,IY)+DELT*DETA(IX,IY)*86400.
       ENDDO
      ENDDO

C        CALCULATE CONSTANTS USED FOR FLUX LIMITER
c$doacross local(iy,ix) , share(dxbar1,dxbar2,dybar1,dybar2)
      DO IY=2,NY
       DO IX=2,NX
        DXBAR(IX,IY) = 0.5*(DX(IX,IY)+DX(IX,IY-1))
        DYBAR(IX,IY) = 0.5*(DY(IX,IY)+DY(IX-1,IY))
       ENDDO
      ENDDO
c$doacross local(iz,iy,ix) , share(u,v,w)
      DO IZ=1,NZ
       DO IY=2,NY
        DO IX=2,NX
          U(IX,IY,IZ)=QX(IX,IY,IZ)/
     .       (DZ(IZ)*0.5*(D(IX,IY)+D(IX-1,IY))*DYBAR(IX,IY))
          V(IX,IY,IZ)=QY(IX,IY,IZ)/
     .       (DZ(IZ)*0.5*(D(IX,IY)+D(IX,IY-1))*DXBAR(IX,IY))
          W(IX,IY,IZ)=QZ(IX,IY,IZ)/XAZ(IX,IY)
        ENDDO
       ENDDO
      ENDDO
C        "HIGH SPEED" SEGMENTS AS WELL
c$doacross local(ix,iy,iz) , share(usplt,vsplt,wsplt)
      IF(NSEGSPLT.GT.0) THEN
       DO ISEG=1,NSEGSPLT
        IX =  ISEGSPLT(ISEG,1)
        IY =  ISEGSPLT(ISEG,2)
        IZ =  ISEGSPLT(ISEG,3)
        USPLT(ISEG,1) = QXSPLT(ISEG,1)/
     .       (DZ(IZ)*0.5*(D(IX,IY)+D(IX-1,IY))*DYBAR(IX,IY))
        USPLT(ISEG,2) = QXSPLT(ISEG,2)/
     .       (DZ(IZ)*0.5*(D(IX,IY)+D(IX+1,IY))*DYBAR(IX+1,IY))
        VSPLT(ISEG,1) = QYSPLT(ISEG,1)/
     .       (DZ(IZ)*0.5*(D(IX,IY)+D(IX,IY-1))*DXBAR(IX,IY))
        VSPLT(ISEG,2) = QYSPLT(ISEG,2)/
     .       (DZ(IZ)*0.5*(D(IX,IY)+D(IX,IY+1))*DXBAR(IX,IY+1))
        WSPLT(ISEG,1) = QZSPLT(ISEG,1)/XAZ(IX,IY)
        WSPLT(ISEG,2) = QZSPLT(ISEG,2)/XAZ(IX,IY)
       ENDDO
      ENDIF

C        DERIVATIVES DUE TO KINETICS AND LOADS
c$doacross local(isys,iz,iy,ix,is,ie,i),share(cdarays)
      DO 80 ISYS=1,NOSYS

C        SOURCES/SINKS DUE TO KINETICS
        CDARAYS(:,:,:,ISYS) = CDARAY(:,:,:,ISYS)
 
C        SET MASS BALANCE FLAG FOR LOADS
       IMBWK=0
       IF(MASSBAL.EQ.1 .AND. ITIMESECS.GE.ISMBSECS) THEN
        IF(IMBDOPT.EQ.0) THEN
         IF(ITIMESECS.EQ.NXPRTMB) IMBWK=1
          DTMB=1.
        ELSE
         IMBWK=1
         DTMB=DT
        ENDIF
       ENDIF
 
C  ADD LOADS
       IF(NOPS(ISYS).GT.0) THEN
        DELTPS = TIME - NXPST
        DO 60 I=1,NOPS(ISYS) 
         WK = DELTPS*SPS(I,ISYS) + BPS(I,ISYS)
         IF(IMBWK.EQ.1)  SYSLOADS(1,ISYS) = SYSLOADS(1,ISYS)+DTMB*WK
         IX = IPS(1,I,ISYS)
         IY = IPS(2,I,ISYS)
         IWK = IPS(3,I,ISYS)
         DO IZ=1,NZ
          CDARAYS(IX,IY,IZ,ISYS) = CDARAYS(IX,IY,IZ,ISYS) +
     .          ZFRACPS(IZ,IWK)*WK
         ENDDO
   60   CONTINUE
       ENDIF
       IF(NONPS(ISYS).GT.0) THEN
        DELTNPS = TIME - NXNPST
        DO 65 I=1,NONPS(ISYS)
         WK = DELTNPS*SNPS(I,ISYS) + BNPS(I,ISYS)
         IF(IMBWK.EQ.1)  SYSLOADS(2,ISYS) = SYSLOADS(2,ISYS)+DTMB*WK
         IX = INPS(1,I,ISYS)
         IY = INPS(2,I,ISYS)
         IWK = INPS(3,I,ISYS)
         DO IZ=1,NZ
          CDARAYS(IX,IY,IZ,ISYS) = CDARAYS(IX,IY,IZ,ISYS) +
     .          ZFRACNPS(IZ,IWK)*WK
         ENDDO
   65   CONTINUE
       ENDIF
       IF(NOFL(ISYS).GT.0) THEN
        DELTFL = TIME - NXFLT
        DO 70 I=1,NOFL(ISYS)
         WK = DELTFL*SFL(I,ISYS) + BFL(I,ISYS)
         IF(IMBWK.EQ.1)  SYSLOADS(3,ISYS) = SYSLOADS(3,ISYS)+DTMB*WK
         IX = IFL(1,I,ISYS)
         IY = IFL(2,I,ISYS)
         IWK = IFL(3,I,ISYS)
         DO IZ=1,NZ
          CDARAYS(IX,IY,IZ,ISYS) = CDARAYS(IX,IY,IZ,ISYS) +
     .          ZFRACFL(IZ,IWK)*WK
         ENDDO
   70   CONTINUE
       ENDIF
       IF(NOATM(ISYS).GT.0) THEN
        DELTATM = TIME - NXATMT
        DO 75 IY=1,NY
         IS = IXS(IY)
         IE = IXE(IY)
         IF(IS.EQ.0) GO TO 75
         DO 74 IX=IS,IE
          IF(FSM(IX,IY).NE.1.) GO TO 74
          CDARAYS(IX,IY,1,ISYS) = CDARAYS(IX,IY,1,ISYS) +
     .          (DELTATM*SATM(IX,IY,ISYS) + BATM(IX,IY,ISYS))*XAZ(IX,IY)
          IF(IMBWK.EQ.1)  SYSLOADS(4,ISYS) = SYSLOADS(4,ISYS) +
     .       DTMB*(DELTATM*SATM(IX,IY,ISYS)+BATM(IX,IY,ISYS))*XAZ(IX,IY)
   74    CONTINUE
   75   CONTINUE
       ENDIF

   80 CONTINUE

C        UPDATE CARAY IF SUBDOMAIN GRID OPTION ACTIVE
      IF(ISUBDOM.EQ.1) CALL RCA14SUBD

c$doacross local(isys,iz,iy,ix),share(dm)
      DM = 0.0
      
C        CHECK TO SEE IF THERE ARE "HIGH SPEED" SEGMENTS
      IF(NSEGSPLT.EQ.0) GO TO 200
C     PERFORM SPLIT TIMESTEP COMPUTATION
C        FIRST INTEGRATING CRITICAL TIMESTEP SEGMENTS
c$doacross local(isys,isplit,iseg,iz,iy,ix,is,ie,inegs,aa,fmax,fmin,
c$&              totmas,concs,dmsplt,qxsplt,antiqxsplt,fluxin,fluxout,
c$&              qysplt,antiqysplt,qzsplt,antiqzsplt,
c$&              rxflx1,rxflx2,ryflx1,ryflx2),
c$&              mp_schedtype=dynamic, chunk=1
      DO 190 ISYS=1,NOSYS 
C        CHECK FOR SYSTEM BYPASS
       IF(SYSBY(ISYS).EQ.1) GO TO 190
       INEGS=0
       TOTMAS=0.0
       DO 180 ISPLIT=1,NSPLIT
        CONCS = 0.
        DO 115 ISEG=1,NSEGSPLT
          IX = ISEGSPLT(ISEG,1)
          IY = ISEGSPLT(ISEG,2)
          IZ = ISEGSPLT(ISEG,3)

C        COMPUTE VOLUMES AT TIME LEVEL 'N+1'
          BVOLN(IX,IY,IZ) = BVOL(IX,IY,IZ)
     .                           + ISPLIT*DTSPLIT*VDERSPLT(ISEG)
 
C        COMPUTE CHANGE IN MASS FOR CRITICAL SEGMENT
          DMSPLT = CDARAYS(IX,IY,IZ,ISYS)

C        TRANSPORT IN -X- DIRECTION
           QXVAL = QXSPLT(ISEG,1)
           CXP=RMASK(IX+1,IY)*(CARAY(IX+1,IY,IZ,ISYS)
     .             -CARAY(IX,IY,IZ,ISYS))
           CX=CARAY(IX,IY,IZ,ISYS)-CARAY(IX-1,IY,IZ,ISYS)
           CXM=RMASK(IX-2,IY)*(CARAY(IX-1,IY,IZ,ISYS)
     .             -CARAY(MAX(IX-2,1),IY,IZ,ISYS))
           IF(CX.NE.0.) THEN
             IF(QXVAL.GT.0.) THEN
               R=CXM/(CX+1.E-20)
             ELSE
               R=CXP/(CX+1.E-20)
             ENDIF
           ELSE
             IF(QXVAL.GT.0.) THEN
               R=CXM*1.E+10
             ELSE
               R=CXP*1.E+10
             ENDIF
           ENDIF
C             SUPERBEE
           PHIX = AMAX1(0.,AMIN1(2.*R,1.),AMIN1(R,2.))
C             MUSCL
C          PHIX(IX,IY,IZ) = AMAX1(0.,AMIN1(AMIN1(0.5*(1.+R),2.),2.*R))
           ALPHA = DT*USPLT(ISEG,1)/DXBAR(IX,IY)
           TERM =
     .          0.5*QXVAL*(CARAY(IX,IY,IZ,ISYS)+CARAY(IX-1,IY,IZ,ISYS))
     .        - 0.5*((1.-PHIX)*ABS(QXVAL)+QXVAL*ALPHA*PHIX)*CX
     .        - RX(IX,IY,IZ)*CX
           DMSPLT = DMSPLT+TERM
           DM(IX-1,IY,IZ,ISYS) = DM(IX-1,IY,IZ,ISYS)-TERM

           QXVAL = QXSPLT(ISEG,2)
           CXP=RMASK(IX+2,IY)*(CARAY(MIN(NX,IX+2),IY,IZ,ISYS)
     .             -CARAY(IX+1,IY,IZ,ISYS))
           CX=CARAY(IX+1,IY,IZ,ISYS)-CARAY(IX,IY,IZ,ISYS)
           CXM=RMASK(IX-1,IY)*(CARAY(IX,IY,IZ,ISYS)
     .             -CARAY(MAX(IX-1,1),IY,IZ,ISYS))
           IF(CX.NE.0.) THEN
             IF(QXVAL.GT.0.) THEN
               R=CXM/(CX+1.E-20)
             ELSE
               R=CXP/(CX+1.E-20)
             ENDIF
           ELSE
             IF(QXVAL.GT.0.) THEN
               R=CXM*1.E+10
             ELSE
               R=CXP*1.E+10
             ENDIF
           ENDIF
C             SUPERBEE
           PHIX = AMAX1(0.,AMIN1(2.*R,1.),AMIN1(R,2.))
           ALPHA = DT*USPLT(ISEG,2)/DXBAR(IX+1,IY)
           TERM =
     .          0.5*QXVAL*(CARAY(IX+1,IY,IZ,ISYS)+CARAY(IX,IY,IZ,ISYS))
     .        - 0.5*((1.-PHIX)*ABS(QXVAL)+QXVAL*ALPHA*PHIX)*CX
     .        - RX(IX+1,IY,IZ)*CX
           DMSPLT = DMSPLT-TERM
           DM(IX+1,IY,IZ,ISYS) = DM(IX+1,IY,IZ,ISYS)+TERM

C        TRANSPORT IN -Y- DIRECTION
           QYVAL = QYSPLT(ISEG,1)
           CYP=RMASK(IX,IY+1)*(CARAY(IX,IY+1,IZ,ISYS)
     .             -CARAY(IX,IY,IZ,ISYS))
           CY=CARAY(IX,IY,IZ,ISYS)-CARAY(IX,IY-1,IZ,ISYS)
           CYM=RMASK(IX,MAX(IY-2,1))*(CARAY(IX,IY-1,IZ,ISYS)
     .             -CARAY(IX,MAX(IY-2,1),IZ,ISYS))
           IF(CY.NE.0.) THEN
             IF(QYVAL.GT.0.) THEN
               R=CYM/(CY+1.E-20)
             ELSE
               R=CYP/(CY+1.E-20)
             ENDIF
           ELSE
             IF(QYVAL.GT.0.) THEN
               R=CYM*1.E+10
             ELSE
               R=CYP*1.E+10
             ENDIF
           ENDIF
C             SUPERBEE
           PHIY = AMAX1(0.,AMIN1(2.*R,1.),AMIN1(R,2.))
           ALPHA = DT*VSPLT(ISEG,1)/DYBAR(IX,IY)
           TERM =
     .          0.5*QYVAL*(CARAY(IX,IY,IZ,ISYS)+CARAY(IX,IY-1,IZ,ISYS))
     .        - 0.5*((1.-PHIY)*ABS(QYVAL)+QYVAL*ALPHA*PHIY)*CY
     .        - RY(IX,IY,IZ)*CY
           DMSPLT = DMSPLT+TERM
           DM(IX,IY-1,IZ,ISYS) = DM(IX,IY-1,IZ,ISYS)-TERM

           QYVAL = QYSPLT(ISEG,2)
           CYP=RMASK(IX,IY+2)*(CARAY(IX,MIN(NY,IY+2),IZ,ISYS)
     .             -CARAY(IX,IY+1,IZ,ISYS))
           CY=CARAY(IX,IY+1,IZ,ISYS)-CARAY(IX,IY,IZ,ISYS)
           CYM=RMASK(IX,IY-1)*(CARAY(IX,IY,IZ,ISYS)
     .             -CARAY(IX,MAX(IY-1,1),IZ,ISYS))
           IF(CY.NE.0.) THEN
             IF(QYVAL.GT.0.) THEN
               R=CYM/(CY+1.E-20)
             ELSE
               R=CYP/(CY+1.E-20)
             ENDIF
           ELSE
             IF(QYVAL.GT.0.) THEN
               R=CYM*1.E+10
             ELSE
               R=CYP*1.E+10
             ENDIF
           ENDIF
C             SUPERBEE
           PHIY = AMAX1(0.,AMIN1(2.*R,1.),AMIN1(R,2.))
           ALPHA = DT*VSPLT(ISEG,2)/DYBAR(IX,IY+1)
           TERM =
     .          0.5*QYVAL*(CARAY(IX,IY+1,IZ,ISYS)+CARAY(IX,IY,IZ,ISYS))
     .        - 0.5*((1.-PHIY)*ABS(QYVAL)+QYVAL*ALPHA*PHIY)*CY
     .        - RY(IX,IY,IZ)*CY
           DMSPLT = DMSPLT-TERM
           DM(IX,IY+1,IZ,ISYS) = DM(IX,IY+1,IZ,ISYS)+TERM

C        TRANSPORT IN -Z- DIRECTION
           IF(IZ.EQ.1) GO TO 100
           QZVAL = QZSPLT(ISEG,1)
           CZP = CARAY(IX,IY,MAX(1,IZ-2),ISYS)
     .         - CARAY(IX,IY,MAX(1,IZ-1),ISYS)
           CZ = CARAY(IX,IY,MAX(1,IZ-1),ISYS)-CARAY(IX,IY,IZ,ISYS)
           CZM = CARAY(IX,IY,IZ,ISYS)-CARAY(IX,IY,MIN(NZ,IZ+1),ISYS)
           IF(CZ.NE.0.) THEN
             IF(QZVAL.GT.0.) THEN
               R=CZM/(CZ+1.E-20)
             ELSE
               R=CZP/(CZ+1.E-20)
             ENDIF
           ELSE
             IF(QZVAL.GT.0.) THEN
               R=CZM*1.E+10
             ELSE
               R=CZP*1.E+10
             ENDIF
           ENDIF
C             SUPERBEE
           PHIZ = AMAX1(0.,AMIN1(2.*R,1.),AMIN1(R,2.))
           ALPHA = DT*WSPLT(ISEG,1)/XAZ(IX,IY)
           TERM =
     .          0.5*QZVAL*(CARAY(IX,IY,IZ,ISYS)+CARAY(IX,IY,IZ-1,ISYS))
     .        - 0.5*((1.-PHIZ)*ABS(QZVAL)+QZVAL*ALPHA*PHIZ)*CZ
           DMSPLT = DMSPLT-TERM
           DM(IX,IY,IZ-1,ISYS) = DM(IX,IY,IZ-1,ISYS)+TERM

  100      IF(IZ.EQ.NZ) GO TO 110
           QZVAL = QZSPLT(ISEG,2)
           CZP = CARAY(IX,IY,MAX(1,IZ-1),ISYS) - CARAY(IX,IY,IZ,ISYS)
           CZ = CARAY(IX,IY,IZ,ISYS)-CARAY(IX,IY,MIN(NZ,IZ+1),ISYS)
           CZM = CARAY(IX,IY,MIN(NZ,IZ+1),ISYS)
     .         - CARAY(IX,IY,MIN(NZ,IZ+2),ISYS)
           IF(CZ.NE.0.) THEN
             IF(QZVAL.GT.0.) THEN
               R=CZM/(CZ+1.E-20)
             ELSE
               R=CZP/(CZ+1.E-20)
             ENDIF
           ELSE
             IF(QZVAL.GT.0.) THEN
               R=CZM*1.E+10
             ELSE
               R=CZP*1.E+10
             ENDIF
           ENDIF
C             SUPERBEE
           PHIZ = AMAX1(0.,AMIN1(2.*R,1.),AMIN1(R,2.))
           ALPHA = DT*WSPLT(ISEG,2)/XAZ(IX,IY)
           TERM =
     .          0.5*QZVAL*(CARAY(IX,IY,MIN(NZ,IZ+1),ISYS)
     .                     +CARAY(IX,IY,IZ,ISYS))
     .        - 0.5*((1.-PHIZ)*ABS(QZVAL)+QZVAL*ALPHA*PHIZ)*CZ
           DMSPLT = DMSPLT+TERM
           DM(IX,IY,IZ+1,ISYS) = DM(IX,IY,IZ+1,ISYS)-TERM

  110      CONTINUE
C        NOW COMPUTE CHANGE IN CONCENTRATION FOR HIGH-SPEED SEGMENT
            CONCS(IX,IY,IZ) = ((BVOL(IX,IY,IZ)+(ISPLIT-1)*DTSPLIT
     .           * VDERSPLT(ISEG))*CARAY(IX,IY,IZ,ISYS)
     .           + DTSPLIT*DMSPLT)/BVOLN(IX,IY,IZ)

  115   CONTINUE

C        CHECK FOR MASS/FLUX BALANCE COMPUTATIONS
        IF(MASSBAL.EQ.0) GO TO 123
C        INSTANTANEOUS OR AVERAGED
        IF(IMBDOPT.EQ.0) THEN 
          IF(ITIMESECS.NE.NXPRTMB) GO TO 123
          DO  ISEG=1,NSEGSPLT
           IX = ISEGSPLT(ISEG,1)
           IY = ISEGSPLT(ISEG,2)
           IZ = ISEGSPLT(ISEG,3)
           FLXMB(IX,IY,IZ,ISYS) = FLXMB(IX,IY,IZ,ISYS) + 1./NSPLIT*
     .         (AMAX1(0.,QXSPLT(ISEG,1)*CARAY(IX-1,IY,IZ,ISYS))
     .        + AMIN1(0.,QXSPLT(ISEG,1)*CARAY(IX,IY,IZ,ISYS)) 
     .        + RX(IX,IY,IZ)*
     .           (CARAY(IX-1,IY,IZ,ISYS)-CARAY(IX,IY,IZ,ISYS)))
           FLXMB(IX+1,IY,IZ,ISYS) = FLXMB(IX+1,IY,IZ,ISYS) +
     .          1./NSPLIT*(1.-FSMSPLT(IX+1,IY,IZ))*
     .         (AMAX1(0.,QXSPLT(ISEG,2)*CARAY(IX,IY,IZ,ISYS))
     .        + AMIN1(0.,QXSPLT(ISEG,2)*CARAY(IX+1,IY,IZ,ISYS))
     .        + RX(IX+1,IY,IZ)*
     .           (CARAY(IX,IY,IZ,ISYS)-CARAY(IX+1,IY,IZ,ISYS)))
           FLYMB(IX,IY,IZ,ISYS) = FLYMB(IX,IY,IZ,ISYS) + 1./NSPLIT*
     .         (AMAX1(0.,QYSPLT(ISEG,1)*CARAY(IX,IY-1,IZ,ISYS))
     .        + AMIN1(0.,QYSPLT(ISEG,1)*CARAY(IX,IY,IZ,ISYS))
     .        + RY(IX,IY,IZ)*
     .           (CARAY(IX,IY-1,IZ,ISYS)-CARAY(IX,IY,IZ,ISYS)))
           FLYMB(IX,IY+1,IZ,ISYS) = FLYMB(IX+1,IY,IZ,ISYS) +
     .          1./NSPLIT*(1.-FSMSPLT(IX,IY+1,IZ))*
     .         (AMAX1(0.,QYSPLT(ISEG,2)*CARAY(IX,IY,IZ,ISYS))
     .        + AMIN1(0.,QYSPLT(ISEG,2)*CARAY(IX,IY+1,IZ,ISYS))
     .        + RY(IX,IY+1,IZ)*
     .           (CARAY(IX,IY,IZ,ISYS)-CARAY(IX,IY+1,IZ,ISYS)))
          ENDDO
        ELSE
          IF(ITIMESECS.LT.ISMBSECS) GO TO 123
          DO  ISEG=1,NSEGSPLT
           IX = ISEGSPLT(ISEG,1)
           IY = ISEGSPLT(ISEG,2)
           IZ = ISEGSPLT(ISEG,3)
           FLXMB(IX,IY,IZ,ISYS) = FLXMB(IX,IY,IZ,ISYS) + DTSPLIT*
     .         (AMAX1(0.,QXSPLT(ISEG,1)*CARAY(IX-1,IY,IZ,ISYS))
     .        + AMIN1(0.,QXSPLT(ISEG,1)*CARAY(IX,IY,IZ,ISYS))
     .        + RX(IX,IY,IZ)*
     .           (CARAY(IX-1,IY,IZ,ISYS)-CARAY(IX,IY,IZ,ISYS)))
           FLXMB(IX+1,IY,IZ,ISYS) = FLXMB(IX+1,IY,IZ,ISYS) + DTSPLIT*
     .          (1.-FSMSPLT(IX+1,IY,IZ))*
     .         (AMAX1(0.,QXSPLT(ISEG,2)*CARAY(IX,IY,IZ,ISYS))
     .        + AMIN1(0.,QXSPLT(ISEG,2)*CARAY(IX+1,IY,IZ,ISYS))
     .        + RX(IX+1,IY,IZ)*
     .           (CARAY(IX,IY,IZ,ISYS)-CARAY(IX+1,IY,IZ,ISYS)))
           FLYMB(IX,IY,IZ,ISYS) = FLYMB(IX,IY,IZ,ISYS) + DTSPLIT*
     .         (AMAX1(0.,QYSPLT(ISEG,1)*CARAY(IX,IY-1,IZ,ISYS))
     .        + AMIN1(0.,QYSPLT(ISEG,1)*CARAY(IX,IY,IZ,ISYS))
     .        + RY(IX,IY,IZ)*
     .           (CARAY(IX,IY-1,IZ,ISYS)-CARAY(IX,IY,IZ,ISYS)))
           FLYMB(IX,IY+1,IZ,ISYS) = FLYMB(IX,IY+1,IZ,ISYS) + DTSPLIT*
     .          (1.-FSMSPLT(IX,IY+1,IZ))*
     .         (AMAX1(0.,QYSPLT(ISEG,2)*CARAY(IX,IY,IZ,ISYS))
     .        + AMIN1(0.,QYSPLT(ISEG,2)*CARAY(IX,IY+1,IZ,ISYS))
     .        + RY(IX,IY+1,IZ)*
     .           (CARAY(IX,IY,IZ,ISYS)-CARAY(IX,IY+1,IZ,ISYS)))
          ENDDO
        ENDIF

  123   DO 155 ISEG=1,NSEGSPLT
          IX = ISEGSPLT(ISEG,1)
          IY = ISEGSPLT(ISEG,2)
          IZ = ISEGSPLT(ISEG,3)
          CARAY(IX,IY,IZ,ISYS) = CONCS(IX,IY,IZ)
  155   CONTINUE

  180  CONTINUE

C        ADJUST MASS FLUX TERMS (OR MASS DERIVATIVES) IN NON-HIGH-SPEED
C        SEGMENTS TO ACCOUNT FOR NUMBER OF HIGH SPEED INTEGRATION STEPS
C        AND ZERO MASS DERIVATIVES IN HIGH-SPEED SEGMENTS
      DM(:,:,:,ISYS) = DM(:,:,:,ISYS)/NSPLIT
      DO 185 ISEG=1,NSEGSPLT
        IX = ISEGSPLT(ISEG,1)
        IY = ISEGSPLT(ISEG,2)
        IZ = ISEGSPLT(ISEG,3)
        DM(IX,IY,IZ,ISYS) = 0.0
  185  CONTINUE

  190 CONTINUE

C        UPDATE VOLUMES FOR CRITICAL SEGMENTS
      DO 195 ISEG=1,NSEGSPLT
        IX = ISEGSPLT(ISEG,1)
        IY = ISEGSPLT(ISEG,2)
        IZ = ISEGSPLT(ISEG,3)
        BVOL(IX,IY,IZ) = BVOLN(IX,IY,IZ)
  195 CONTINUE

  200 CONTINUE

C-----------------------------------------------------------------------
C        NOW TAKE FULL EXPLICIT STEP FOR REMAINING WATER SEGMENTS

C        COMPUTE VOLUMES AT TIME LEVEL 'N+1'
c$doacross local(iz,iy,ix)
      DO 210 IZ=1,NZ
        DO 210 IY=1,NY
          DO 210 IX=1,NX
            BVOLN(IX,IY,IZ) = BVOL(IX,IY,IZ) +
     .           (FSM(IX,IY)-FSMSPLT(IX,IY,IZ))*DT*VDER(IX,IY,IZ)
 210  CONTINUE
 
C        UPDATE -DM- TO INCLUDE KINETICS AND LOADS
c$doacross local(isys,iz,iy,ix,is,ie)
      DO 215 ISYS=1,NOSYS
       DO 215 IZ=1,NZ
        DO 215 IY=1,NY
         IS = IXS(IY)
         IE = IXE(IY)
         IF(IS.EQ.0) GO TO 215
         DO 214 IX=IS,IE
          DM(IX,IY,IZ,ISYS) = DM(IX,IY,IZ,ISYS)
     .       + (FSM(IX,IY)-FSMSPLT(IX,IY,IZ))*CDARAYS(IX,IY,IZ,ISYS)
  214    CONTINUE
  215 CONTINUE
 
c$doacross local(isys,iy,ix,iz,is,ie,i,j,ilyr,aa,fmax,fmin,inegs,totmas,
c$&        concs,antiqx,antiqy,antiqz,qxflx,qyflx,qzflx,fluxin,fluxout,
c$&        rxflx,ryflx),share(negseg)
c$&        ,mp_schedtype=dynamic, chunk=1

c          rxflx,ryflx,mf,al,ad,au,beta,gamma),share(negseg)
      DO 400 ISYS=1,NOSYS 
C
C        CHECK FOR SYSTEM BYPASS
      IF(SYSBY(ISYS).EQ.1) GO TO 400
      INEGS=0
      TOTMAS=0.0

C  CALCULATE CHANGE IN CONCENTRATION DUE TO ADVECTIVE TRANSPORT
C    AND HORIZONTAL MIXING PROCESSES
C        TRANSPORT DERIVATIVE WITH FLUX LIMITER
c$doacross local(iz,iy,ix,is,ie,r)
       DO 225 IZ=1,NZ
        DO 224 IY=1,NY
         IS = IXS(IY)
         IE = IXE(IY)
         IF(IS.EQ.0)   GO TO 224
C        TRANSPORT IN -X- DIRECTION
          DO 223 IX=IS,IE
           IF(FSM(IX,IY).EQ.0.)  GO TO 223
           QXVAL = QX(IX,IY,IZ)
           CXP=RMASK(IX+1,IY)*(CARAY(IX+1,IY,IZ,ISYS)
     .             -CARAY(IX,IY,IZ,ISYS))
           CX=CARAY(IX,IY,IZ,ISYS)-CARAY(IX-1,IY,IZ,ISYS)
           CXM=RMASK(IX-2,IY)*(CARAY(IX-1,IY,IZ,ISYS)
     .             -CARAY(MAX(IX-2,1),IY,IZ,ISYS))
           IF(CX.NE.0.) THEN
             IF(QXVAL.GT.0.) THEN
               R=CXM/(CX+1.E-20)
             ELSE
               R=CXP/(CX+1.E-20)
             ENDIF
           ELSE
             IF(QXVAL.GT.0.) THEN
               R=CXM*1.E+10
             ELSE
               R=CXP*1.E+10
             ENDIF
           ENDIF
C             SUPERBEE
           PHIX = AMAX1(0.,AMIN1(2.*R,1.),AMIN1(R,2.))
           ALPHA = DT*U(IX,IY,IZ)/DXBAR(IX,IY)
           TERM =
     .          0.5*QXVAL*(CARAY(IX,IY,IZ,ISYS)+CARAY(IX-1,IY,IZ,ISYS))
     .        - 0.5*((1.-PHIX)*ABS(QXVAL)+QXVAL*ALPHA*PHIX)*CX
     .        - RX(IX,IY,IZ)*CX
           DM(IX,IY,IZ,ISYS) = DM(IX,IY,IZ,ISYS)+TERM
           DM(IX-1,IY,IZ,ISYS) = DM(IX-1,IY,IZ,ISYS)-TERM

C        TRANSPORT IN -Y- DIRECTION
           QYVAL = QY(IX,IY,IZ)
           CYP=RMASK(IX,IY+1)*(CARAY(IX,IY+1,IZ,ISYS)
     .             -CARAY(IX,IY,IZ,ISYS))
           CY=CARAY(IX,IY,IZ,ISYS)-CARAY(IX,IY-1,IZ,ISYS)
           CYM=RMASK(IX,IY-2)*(CARAY(IX,IY-1,IZ,ISYS)
     .             -CARAY(IX,MAX(IY-2,1),IZ,ISYS))
           IF(CY.NE.0.) THEN
             IF(QYVAL.GT.0.) THEN
               R=CYM/(CY+1.E-20)
             ELSE
               R=CYP/(CY+1.E-20)
             ENDIF
           ELSE
             IF(QYVAL.GT.0.) THEN
               R=CYM*1.E+10
             ELSE
               R=CYP*1.E+10
             ENDIF
           ENDIF
C             SUPERBEE
           PHIY = AMAX1(0.,AMIN1(2.*R,1.),AMIN1(R,2.))
           ALPHA = DT*V(IX,IY,IZ)/DYBAR(IX,IY)
           TERM =
     .          0.5*QYVAL*(CARAY(IX,IY,IZ,ISYS)+CARAY(IX,IY-1,IZ,ISYS))
     .        - 0.5*((1.-PHIY)*ABS(QYVAL)+QYVAL*ALPHA*PHIY)*CY
     .        - RY(IX,IY,IZ)*CY
           DM(IX,IY,IZ,ISYS) = DM(IX,IY,IZ,ISYS)+TERM
           DM(IX,IY-1,IZ,ISYS) = DM(IX,IY-1,IZ,ISYS)-TERM

  223     CONTINUE
  224   CONTINUE
  225  CONTINUE

       IF(NZ.GT.1) THEN
        DO 235 IZ=2,NZ
        DO 235 IY=1,NY
         IS = IXS(IY)
         IE = IXE(IY)
         IF(IS.EQ.0)   GO TO 235
          DO 234 IX=IS,IE
           IF(FSM(IX,IY).NE.1.)  GO TO 234
C        TRANSPORT IN -Z- DIRECTION
           QZVAL = QZ(IX,IY,IZ)
           CZP = CARAY(IX,IY,MAX(1,IZ-2),ISYS)
     .         - CARAY(IX,IY,MAX(1,IZ-1),ISYS)
           CZ = CARAY(IX,IY,MAX(1,IZ-1),ISYS)-CARAY(IX,IY,IZ,ISYS)
           CZM = CARAY(IX,IY,IZ,ISYS)-CARAY(IX,IY,MIN(NZ,IZ+1),ISYS)
           IF(CZ.NE.0.) THEN
             IF(QZVAL.GT.0.) THEN
               R=CZM/(CZ+1.E-20)
             ELSE
               R=CZP/(CZ+1.E-20)
             ENDIF
           ELSE
             IF(QZVAL.GT.0.) THEN
               R=CZM*1.E+10
             ELSE
               R=CZP*1.E+10
             ENDIF
           ENDIF
C             SUPERBEE
           PHIZ = AMAX1(0.,AMIN1(2.*R,1.),AMIN1(R,2.))
           ALPHA = DT*W(IX,IY,IZ)/XAZ(IX,IY)
           TERM =
     .          0.5*QZVAL*(CARAY(IX,IY,IZ,ISYS)+CARAY(IX,IY,IZ-1,ISYS))
     .        - 0.5*((1.-PHIZ)*ABS(QZVAL)+QZVAL*ALPHA*PHIZ)*CZ
           DM(IX,IY,IZ,ISYS) = DM(IX,IY,IZ,ISYS)-TERM
           DM(IX,IY,IZ-1,ISYS) = DM(IX,IY,IZ-1,ISYS)+TERM
  234    CONTINUE
  235   CONTINUE
       ENDIF

C                                      n+1
C  COMPUTE NEW CONCENTRATIONS AT TIME T
c$doacross local(iy,ix,iz,is,ie)
      DO 240 IZ=1,NZ
        DO 240 IY=1,NY
          IS = IXS(IY)
          IE = IXE(IY)
          IF(IS.EQ.0)   GO TO 240
          DO 239 IX=IS,IE
            IF(FSM(IX,IY).NE.1.)  GO TO 239
              CONCS(IX,IY,IZ) = (BVOL(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)
     .                        + DT*DM(IX,IY,IZ,ISYS))/BVOLN(IX,IY,IZ)
 239      CONTINUE
 240  CONTINUE 

C  BOUNDARY ELEMENTS ARE UNCHANGED
      DO 245 I=1,NOBCALL
        IX=IBCALL(1,I)
        IY=IBCALL(2,I)
        IZ=IBCALL(3,I)
        CONCS(IX,IY,IZ)=CARAY(IX,IY,IZ,ISYS)
  245 CONTINUE

C        CHECK FOR MASS/FLUX BALANCE COMPUTATIONS
      IF(MASSBAL.EQ.0) GO TO 260
C        INSTANTANEOUS OR AVERAGED
      IF(IMBDOPT.EQ.0 .AND. ITIMESECS.NE.NXPRTMB) GO TO 260
      IF(ITIMESECS.LT.ISMBSECS) GO TO 260
      DO 250 IZ=1,NZ
       DO 250 IY=1,NY
        DO 250 IX=1,NX
         IF(FSM(IX,IY).NE.1.) GO TO 250
         FLXMB(IX,IY,IZ,ISYS) = FLXMB(IX,IY,IZ,ISYS) + DTMB*
     .        (1.-FSMSPLT(IX,IY,IZ))*
     .        (AMAX1(0.,QX(IX,IY,IZ)*CARAY(IX-1,IY,IZ,ISYS))
     .       + AMIN1(0.,QX(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS))
     .       + RX(IX,IY,IZ)*
     .          (CARAY(IX-1,IY,IZ,ISYS)-CARAY(IX,IY,IZ,ISYS)))
         FLYMB(IX,IY,IZ,ISYS) = FLYMB(IX,IY,IZ,ISYS) + DTMB*
     .        (1.-FSMSPLT(IX,IY,IZ))*
     .        (AMAX1(0.,QY(IX,IY,IZ)*CARAY(IX,IY-1,IZ,ISYS))
     .       + AMIN1(0.,QY(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS))
     .       + RY(IX,IY,IZ)*
     .          (CARAY(IX,IY-1,IZ,ISYS)-CARAY(IX,IY,IZ,ISYS)))
  250 CONTINUE

C***********************************************************************
C        COMPLETE REST OF INTEGRATION STEP
C        I.E., THE IMPLICIT VERTICAL DIFFUSION STEP  (IF NZ > 1)
  260 IF (NZ.EQ.1) GO TO 390
      DO 350 IZ=1,NZ
       DO 350 IY=1,NY
        IS = IXS(IY)
        IE = IXE(IY)
        IF(IS.EQ.0) GO TO 350
        DO 349 IX=IS,IE
          MF(IX,IY,IZ) = CONCS(IX,IY,IZ)*BVOLN(IX,IY,IZ)
 349    CONTINUE
 350  CONTINUE
C        SET UP DIAGONAL AND OFF-DIAGONAL ELEMENTS
      DO 360 IY=1,NY
       IS = IXS(IY)
       IE = IXE(IY)
       IF(IS.EQ.0) GO TO 360
       DO 359 IX=IS,IE
        IF(FSM(IX,IY).NE.1.) GO TO 359
        AL(IX,IY,1) = 0.
        AD(IX,IY,1) = BVOLN(IX,IY,1) + DT*RZ(IX,IY,2)
        AU(IX,IY,1) = -DT*RZ(IX,IY,2)
        DO 355 IZ=2,NZ-1
         AL(IX,IY,IZ) = -DT*RZ(IX,IY,IZ)
         AD(IX,IY,IZ) = BVOLN(IX,IY,IZ) +
     .                     DT*(RZ(IX,IY,IZ) + RZ(IX,IY,IZ+1))
         AU(IX,IY,IZ) = -DT*RZ(IX,IY,IZ+1)
  355   CONTINUE
        AL(IX,IY,NZ) = -DT*RZ(IX,IY,NZ)
        AD(IX,IY,NZ) = BVOLN(IX,IY,NZ) + DT*RZ(IX,IY,NZ)
        AU(IX,IY,NZ) = 0.0
  359  CONTINUE
  360 CONTINUE
C        FORWARD SWEEP OF TRIDIAGONAL SCHEME
      DO 370 IY=1,NY
       IS = IXS(IY)
       IE = IXE(IY)
       IF(IS.EQ.0) GO TO 370
       DO 369 IX=IS,IE
        IF(FSM(IX,IY).NE.1.) GO TO 369
        BETA(IX,IY,1) = AD(IX,IY,1)
        GAMMA(IX,IY,1) = MF(IX,IY,1)/BETA(IX,IY,1)
        DO 365 IZ=2,NZ
         BETA(IX,IY,IZ) = AD(IX,IY,IZ)
     .               - AL(IX,IY,IZ)*AU(IX,IY,IZ-1)/BETA(IX,IY,IZ-1)
         GAMMA(IX,IY,IZ) = (MF(IX,IY,IZ)
     .               - AL(IX,IY,IZ)*GAMMA(IX,IY,IZ-1))/BETA(IX,IY,IZ)
  365   CONTINUE
  369  CONTINUE
  370 CONTINUE
C        BACKWARD SWEEP FOR SOLUTION
      DO 380 IY=1,NY
       IS = IXS(IY)
       IE = IXE(IY)
       IF(IS.EQ.0) GO TO 380
       DO 379 IX=IS,IE
        IF(FSM(IX,IY).NE.1.) GO TO 379
        CONCS(IX,IY,NZ) = GAMMA(IX,IY,NZ)
        DO 375 ILYR=2,NZ
         IZ = NZ+1-ILYR
         CONCS(IX,IY,IZ) = GAMMA(IX,IY,IZ)
     .           - AU(IX,IY,IZ)*CONCS(IX,IY,IZ+1)/BETA(IX,IY,IZ)
  375   CONTINUE
  379  CONTINUE
  380 CONTINUE

C  BOUNDARY ELEMENTS ARE UNCHANGED
      DO 385 I=1,NOBCALL
        IX=IBCALL(1,I)
        IY=IBCALL(2,I)
        IZ=IBCALL(3,I)
        CONCS(IX,IY,IZ)=CARAY(IX,IY,IZ,ISYS)
  385 CONTINUE
 
  390 CONTINUE

C        CHECK TO SEE IF NEGATIVE SOLUTIONS PERMITTED 
      DO 395 IZ=1,NZ
        DO 395 IY=1,NY
          IS = IXS(IY)
          IE = IXE(IY)
          IF(IS.EQ.0) GO TO 395
          DO 394 IX=IS,IE
            IF(FSM(IX,IY).NE.1.) GO TO 394
            IF (NEGSLN.EQ.1) THEN
              CARAY(IX,IY,IZ,ISYS) = CONCS(IX,IY,IZ)
            ELSE
C        IF NOT ... CHECK TO MAKE SURE SOLUTION IS NOT FORCED THRU ZERO
              IF(CONCS(IX,IY,IZ).GE.CMIN(ISYS)) THEN
                CARAY(IX,IY,IZ,ISYS) = CONCS(IX,IY,IZ)
              ELSE
C          PREVENT NEG SOLN BY QUARTERING PRESENT CONC AND PRINT WARNING
                CARAY(IX,IY,IZ,ISYS) =
     .                      MAX(CARAY(IX,IY,IZ,ISYS)/4.,CMIN(ISYS))
c$        call mp_setlock
                INEGS = INEGS+1
                IF(INEGS.LE.99) THEN
                  NEGSEG(INEGS,1) = IX
                  NEGSEG(INEGS,2) = IY
                  NEGSEG(INEGS,3) = IZ
                ENDIF
                TOTMAS = TOTMAS+BVOLN(IX,IY,IZ)*
     .                   (CARAY(IX,IY,IZ,ISYS)-CONCS(IX,IY,IZ))
                ADDMASS(IX,IY,IZ,ISYS) = ADDMASS(IX,IY,IZ,ISYS) +
     .           BVOLN(IX,IY,IZ)*(CARAY(IX,IY,IZ,ISYS)-CONCS(IX,IY,IZ))
                IWRTADDM=1
c$        call mp_unsetlock
                ENDIF
              ENDIF
  394     CONTINUE
  395 CONTINUE

      IF(IADDMDEBUG.EQ.1) THEN
       IF(INEGS.GT.0)  THEN
         CALL RCAMESS(2,0.001*TOTMAS)
C$          call mp_setlock
         WRITE(OUT,1000)  ((NEGSEG(I,J),J=1,3),I=1,MIN(INEGS,99))
 1000    FORMAT(30X,12I5)
C$           call mp_unsetlock
       ENDIF
      ENDIF

  400 CONTINUE

C        SEE IF MASS HAS BEEN ADDED TO SYSTEM
      IF(IWRTADDM.EQ.1) THEN
        OPEN(19,FILE='RCAFADDM',FORM='UNFORMATTED',STATUS='REPLACE')
        WRITE(19)  ADDMASS
        CLOSE(19)
        IWRTADDM=0
      ENDIF

C        FLUX BALANCES FOR MISC KINETIC VARIABLES
      IF(MASSBAL.EQ.0 .OR. NOKINSYS.EQ.0) GO TO 410
C        INSTANTANEOUS OR AVERAGED
      IF(IMBDOPT.EQ.0) THEN 
       IF(ITIMESECS.NE.NXPRTMB) GO TO 410
       DO 405 ISYS=1,NOKINSYS
        DO 405 IZ=1,NZ
         DO 405 IY=1,NY
          DO 405 IX=1,NX
           IF(FSM(IX,IY).NE.1.) GO TO 405
            FLXMB(IX,IY,IZ,NOSYS+ISYS) = 
     .         (AMAX1(0.,QX(IX,IY,IZ)*CKINARRAY(IX-1,IY,IZ,ISYS))
     .        + AMIN1(0.,QX(IX,IY,IZ)*CKINARRAY(IX,IY,IZ,ISYS))
     .        + RX(IX,IY,IZ)
     .           *(CKINARRAY(IX-1,IY,IZ,ISYS)-CKINARRAY(IX,IY,IZ,ISYS)))
            FLYMB(IX,IY,IZ,NOSYS+ISYS) = 
     .         (AMAX1(0.,QY(IX,IY,IZ)*CKINARRAY(IX,IY-1,IZ,ISYS))
     .        + AMIN1(0.,QY(IX,IY,IZ)*CKINARRAY(IX,IY,IZ,ISYS))
     .        + RY(IX,IY,IZ)
     .           *(CKINARRAY(IX,IY-1,IZ,ISYS)-CKINARRAY(IX,IY,IZ,ISYS)))
  405  CONTINUE
      ELSE
       DO 407 ISYS=1,NOKINSYS
        DO 407 IZ=1,NZ
         DO 407 IY=1,NY
          DO 407 IX=1,NX
           IF(FSM(IX,IY).NE.1.) GO TO 407
            FLXMB(IX,IY,IZ,NOSYS+ISYS) = FLXMB(IX,IY,IZ,NOSYS+ISYS) 
     .        +DT*(AMAX1(0.,QX(IX,IY,IZ)*CKINARRAY(IX-1,IY,IZ,ISYS))
     .            +AMIN1(0.,QX(IX,IY,IZ)*CKINARRAY(IX,IY,IZ,ISYS))
     .            + RX(IX,IY,IZ)
     .           *(CKINARRAY(IX-1,IY,IZ,ISYS)-CKINARRAY(IX,IY,IZ,ISYS)))
            FLYMB(IX,IY,IZ,NOSYS+ISYS) = FLYMB(IX,IY,IZ,NOSYS+ISYS) 
     .        +DT*(AMAX1(0.,QY(IX,IY,IZ)*CKINARRAY(IX,IY-1,IZ,ISYS))
     .            +AMIN1(0.,QY(IX,IY,IZ)*CKINARRAY(IX,IY,IZ,ISYS))
     .            + RY(IX,IY,IZ)
     .           *(CKINARRAY(IX,IY-1,IZ,ISYS)-CKINARRAY(IX,IY,IZ,ISYS)))
  407  CONTINUE
      ENDIF
        
C***********************************************************************

C        UPDATE VOLUMES FOR NEXT TIMESTEP
  410 DO 415 IZ=1,NZ
       DO 415 IY=1,NY
        DO 415 IX=1,NX
         BVOL(IX,IY,IZ) = BVOLN(IX,IY,IZ)
  415 CONTINUE

C  PREPARE FOR NEXT TIME STEP
      ITIMESECS = ITIMESECS + IDTSECS
      TIME = ITIMESECS/86400.
 
C        CHECK TO SEE IF IT IS TIME TO PRINT RESULTS
 
C  FIRST DETAILED DUMPS
      IF(ITIMESECS.LT.NXPRTD) GO TO 435
C  DETAILED PRINT TIME
C  SET IDISK FOR DETAILED DUMPS
      IDISK=2
      NXPRTD = NXPRTD + IPRNTDSECS
C  SECOND GLOBAL DUMPS
 435  IF(ITIMESECS.LT.NXPRTG) GO TO 450
C  GLOBAL PRINT TIME
C  CALL PRINT ROUTINE
      CALL RCA09
      IDISK=IDISK+1
      NXPRTG = NXPRTG + IPRNTGSECS
       
C  NOW PERFORM STABILITY CHECK
      DO 445 ISYS=1,NOSYS 
        IF(SYSBY(ISYS).EQ.1) GO TO 445
        CKMAX = CMAX(ISYS)
        DO 440 IZ=1,NZ
          DO 440 IY=1,NY
            IS = IXS(IY)
            IE = IXE(IY)
            IF(IS.EQ.0) GO TO 440
            DO 439 IX=IS,IE
              IF(FSM(IX,IY).NE.1.) GO TO 439
              IF(CARAY(IX,IY,IZ,ISYS).GE.CKMAX) GO TO 500
  439       CONTINUE
  440   CONTINUE
  445 CONTINUE
C  MASS/FLUX BALANCE DUMPS
  450 IF(MASSBAL.EQ.0) GO TO 470
      IF(ITIMESECS.LT.NXPRTMB) GO TO 470
       IF(IMBDOPT.EQ.0) THEN
        WRITE(17)  TIME,SYSMASS,SYSLOADS,FLXMB,FLYMB
       ELSE
        TIMEAVE=FLOAT(IPRNTMBSECS)/86400.
        DO 455 ISYS=1,NOSYS+NOKINSYS
         DO 455 IZ=1,NZ
          DO 455 IY=1,NY
           DO 455 IX=1,NX
            FLXMB(IX,IY,IZ,ISYS)=FLXMB(IX,IY,IZ,ISYS)/TIMEAVE
            FLYMB(IX,IY,IZ,ISYS)=FLYMB(IX,IY,IZ,ISYS)/TIMEAVE
  455   CONTINUE
        DO ISYS=1,NOSYS
         DO I=1,4
          SYSLOADS(I,ISYS)=SYSLOADS(I,ISYS)/TIMEAVE
         ENDDO
        ENDDO
        WRITE(17)  TIME,SYSMASS,SYSLOADS,FLXMB,FLYMB
C        RESET ARRAYS AND COUNTER
       ENDIF
      DO 460 ISYS=1,NOSYS
       DO 460 I=1,4
        SYSLOADS(I,ISYS)=0.
  460 CONTINUE
      DO 465 ISYS=1,NOSYS+NOKINSYS
       DO 465 IZ=1,NZ
        DO 465 IY=1,NY
         DO 465 IX=1,NX
          FLXMB(IX,IY,IZ,ISYS)=0.0
          FLYMB(IX,IY,IZ,ISYS)=0.0
  465 CONTINUE
      NXPRTMB = NXPRTMB + IPRNTMBSECS
      IF(NXPRTMB.GT.IEMBSECS) MASSBAL=0

C        CHECK TO SEE IF USER WISHES TO TERMINATE RUN
      CALL CHECKSTOP(IVAL)
      IF(IVAL.EQ.0) GO TO 470
C        TERMINATE / CALL TUNER TO PERFORM LAST DUMPS
      CALL TUNER
      WRITE(OUT,7000)
 7000 FORMAT(///30X,'USER REQUESTED TERMINATION VIA CHECKSTOP FILE'/
     .          30X,'RCASPLTFL FINISHED INTEGRATION')
      IF(MASSBAL.EQ.1) THEN
        DEALLOCATE(FLXMB)
        DEALLOCATE(FLYMB)
      ENDIF
      CALL EXIT


C        CHECK TO SEE IF NECESSARY TO UPDATE TIME-VARIABLE FUNCTIONS
C        POINT SOURCE LOADS 
  470 IF(IPSOPT.GT.1.AND.TIME.GE.NXPST) THEN
         CALL RCA10(SPS,BPS,MXWK,NOPS,NXPST,33,IPSPWLOPT,SCALPS)
      ENDIF
C        NONPOINT SOURCE LOADS 
      IF(INPSOPT.GT.1.AND.TIME.GE.NXNPST) THEN
         CALL RCA10(SNPS,BNPS,MXWK,NONPS,NXNPST,34,INPSPWLOPT,SCALNPS)
      ENDIF
C        FALL-LINE LOADS 
      IF(IFLOPT.GT.1.AND.TIME.GE.NXFLT) THEN
         CALL RCA10(SFL,BFL,MXWK,NOFL,NXFLT,35,IFLPWLOPT,SCALFL)
      ENDIF
C        ATMOSPHERIC LOADS 
      IF(IATMOPT.GT.1.AND.TIME.GE.NXATMT) THEN
         CALL RCA10(SATM,BATM,NX*NY,NOATM,NXATMT,36,IATMPWLOPT,
     .              SCALATM)
      ENDIF
C        NEXT BOUNDARY CONDITIONS 
      IF(IBCOPT.GT.1.AND.TIME.GT.NXBCT) CALL RCA11 

C        CHECK TO SEE IF NECESSARY TO UPDATE TRANSPORT FIELDS
C     IF(ITIMESECS.GE.HYDBRK(ITIMHYD)) THEN
      IF(ITIMESECS.GE.NXHYDTSECS) THEN
         CALL RCA03A
         CALL RCASPLT2
C        ITIMHYD = ITIMHYD+1
      ENDIF

C        CHECK FOR END OF SIMULATION...
C           IF NOT GO BACK AND TAKE NEXT INTEGRATION STEP

      IF(TIME.LE.TEND) GO TO 30 


C        FINISHED...
      WRITE(OUT,8000)
 8000 FORMAT(///30X,'RCASPLT FINISHED INTEGRATION'/
     .          30X,'USER DUMPS TO FOLLOW'//)
      IF(MASSBAL.EQ.1) THEN
        DEALLOCATE(FLXMB)
        DEALLOCATE(FLYMB)
      ENDIF
      RETURN

C         STABILITY CRITERIA VIOLATED...ABEND 
  500 CALL RCAMESS(1,CKMAX) 
      WRITE(OUT,9000)  BVOLN(IX,IY,IZ),DIAG(IX,IY,IZ)
 9000 FORMAT(10X,'VOLUME =',E13.4,'  ,DIAGONAL =',E13.4)
      IREC = IREC+1 
      IDISK = 1 
      INITB = 2
      CALL TUNER
      RETURN
      END 
