      MODULE ALLOCRCASPLTS
       REAL, ALLOCATABLE :: FLXMB(:,:,:,:)
       REAL, ALLOCATABLE :: FLYMB(:,:,:,:)
      END MODULE ALLOCRCASPLTS
      SUBROUTINE RCASPLTS
      USE  ALLOCRCASPLTS
C 
C        RCASPLTS IS THE MASTER SUBROUTINE USED FOR INTEGRATING THE
C                 DIFFERENTIAL EQUATIONS OF THE WATER QUALITY MODEL.
C                 TIME DERIVATIVE: EXPLICIT - SPLIT TIMESTEP
C                 SPACE DERIVATIVE: UPWIND WITH SMOLARKIEWICZ CORRECTOR
C
C
C************************************************************************
C 
      SAVE
      INCLUDE 'RCACM' 
      INTEGER  NEGSEG(99,3)
      REAL   CONCS(NX,NY,0:NZ),CDARAYS(NX,NY,NZ,NOSYS)
     .      ,DM(NX,NY,NZ,NOSYS),BVOLN(NX,NY,NZ)
     .      ,BVOLNT(NX,NY,NZ),D(NX,NY),MF(NX,NY,NZ)
     .      ,DXBAR1(NX,NY),DYBAR2(NX,NY),DXBAR2(NX,NY),DYBAR1(NX,NY)
     .      ,FLUXIN(NX,NY,NZ),FLUXOUT(NX,NY,NZ)
     .      ,U(NX,NY,NZ),V(NX,NY,NZ),W(NX,NY,NZ)
     .      ,RXSPLT(MXSEGSPLT,2),RYSPLT(MXSEGSPLT,2)
     .      ,ANTIQX(NX,NY,NZ),ANTIQY(NX,NY,NZ)
     .      ,ANTIQZ(NX,NY,NZ),QXFLX(NX,NY,NZ)
     .      ,QYFLX(NX,NY,NZ),QZFLX(NX,NY,NZ)
     .      ,RXFLX(NX,NY,NZ),RYFLX(NX,NY,NZ)
     .      ,AL(NX,NY,NZ),AD(NX,NY,NZ),AU(NX,NY,NZ)
     .      ,BETA(NX,NY,NZ),GAMMA(NX,NY,NZ)
     .      ,SYSMASS(NOSYS+NOKINSYS),SYSLOADS(4,NOSYS)
     .      ,ADDMASS(NX,NY,NZ,NOSYS)
      REAL
     .    QXSPLT(MXSEGSPLT,2),QYSPLT(MXSEGSPLT,2),QZSPLT(MXSEGSPLT,2)
     .   ,USPLT(MXSEGSPLT,2),VSPLT(MXSEGSPLT,2),WSPLT(MXSEGSPLT,2)
      REAL   CSLAVE(NX,NY,NZ,NOSYS)


C        INITIALIZATION
      INITB=0
      ITRAK=1 
      ITIMESECS=0
      ITIMEWQSECS=0
      TIME=0.0
      NXPRTD=IPRNTDSECS
      NXPRTG=IPRNTGSECS
      IWRTADDM=0
      IADDMDEBUG=0
      INITMB=1
      ICHANGE=1
      IF(MASSBAL.EQ.1) THEN
        IF(ISMBSECS.EQ.0) THEN
          NXPRTMB=0
          INITMB=0
        ELSE
          NXPRTMB=ISMBSECS
          INITMB=1
        ENDIF
      ENDIF
      NSPLIT = DTFULL/DTSPLIT
      CNONZERO=1.E-10
      IF(TZERO.NE.0.) THEN
         TIME = TZERO
         CALL RCA08
         ITIMESECS = 86400.*TZERO
         ITIMEWQSECS = 86400.*TZERO
         NXPRTD = ITIMESECS+IPRNTDSECS
         NXPRTG = ITIMESECS+IPRNTGSECS
         IF(MASSBAL.EQ.1) THEN
           IF(ITIMESECS.LT.ISMBSECS) THEN
             NXPRTMB=ISMBSECS
             INITMB=1
           ELSE
             NXPRTMB = ITIMESECS
             INITMB=0
           ENDIF
         ENDIF
      ENDIF
C        INITIALIZE TUNER
      CALL TUNER_INIT
C        INITIALIZE ARRAYS
      DO 10 IZ=1,NZ
        DO 10 IY=1,NY
          DO 10 IX=1,NX
            CONCS(IX,IY,IZ) = 0.0
            ANTIQX(IX,IY,IZ) = 0.0
            ANTIQY(IX,IY,IZ) = 0.0
            ANTIQZ(IX,IY,IZ) = 0.0
            QXFLX(IX,IY,IZ) = 0.0
            RXFLX(IX,IY,IZ) = 0.0
            QYFLX(IX,IY,IZ) = 0.0
            RYFLX(IX,IY,IZ) = 0.0
            QZFLX(IX,IY,IZ) = 0.0
            U(IX,IY,IZ) = 0.0
            V(IX,IY,IZ) = 0.0
            W(IX,IY,IZ) = 0.0
            D(IX,IY) = 0.0
   10 CONTINUE
      IF(MASSBAL.EQ.1) THEN
       ALLOCATE(FLXMB(NX,NY,NZ,NOSYS+NOKINSYS),STAT=ISTAT)
       ALLOCATE(FLYMB(NX,NY,NZ,NOSYS+NOKINSYS),STAT=ISTAT)
       DO 12 ISYS=1,NOSYS+NOKINSYS
        DO 12 IZ=1,NZ
         DO 12 IY=1,NY
          DO 12 IX=1,NX
            FLXMB(IX,IY,IZ,ISYS)=0.
            FLYMB(IX,IY,IZ,ISYS)=0.
   12  CONTINUE
       DO 14 ISYS=1,NOSYS
         DO I=1,4
          SYSLOADS(I,ISYS)=0.0
         ENDDO
   14  CONTINUE
       IF(INITMB.EQ.0) THEN
        DO 16 ISYS=1,NOSYS
         SYSMASS(ISYS)=0.0
         DO 16 IZ=1,NZ
          DO 16 IY=1,NY
           DO 16 IX=1,NX
            IF(FSM(IX,IY).EQ.1.)  SYSMASS(ISYS) = SYSMASS(ISYS) +
     .                            BVOL(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)
  16    CONTINUE
        DO 17 ISYS=1,NOKINSYS
         SYSMASS(NOSYS+ISYS)=0.0
         DO 17 IZ=1,NZ
          DO 17 IY=1,NY
           DO 17 IX=1,NX
            IF(FSM(IX,IY).EQ.1.)
     .                 SYSMASS(NOSYS+ISYS) = SYSMASS(NOSYS+ISYS) +
     .                 BVOL(IX,IY,IZ)*CKINARRAY(IX,IY,IZ,ISYS)
  17    CONTINUE
        WRITE(17)  TIME,SYSMASS,SYSLOADS,FLXMB,FLYMB
        NXPRTMB=NXPRTMB+IPRNTMBSECS
        INITMB=1
       ENDIF
      ENDIF

c$doacross local(isys,iz,iy,ix) , share(cslave)
      DO 18 ISYS=1,NOSYS
       DO 18 IZ=1,NZ
        DO 18 IY=1,NY
         DO 18 IX=1,NX
            CSLAVE(IX,IY,IZ,ISYS) = 0.0
   18 CONTINUE

C        SET UP -AVECT- ARRAYS FOR TIME = 0.0 (TZERO)
      CALL RCASPLT1
C        TRANSFER HORIZONTAL MIXING COEFFICIENTS FOR "HIGH SPEED" SEGMENTS
c$doacross local(iseg,iz,iy,ix)
      IF(NSEGSPLT.GT.0) THEN
       DO 20 ISEG=1,NSEGSPLT
        IX = ISEGSPLT(ISEG,1)
        IY = ISEGSPLT(ISEG,2)
        IZ = ISEGSPLT(ISEG,3)
        RXSPLT(ISEG,1) = RX(IX,IY,IZ)
        RXSPLT(ISEG,2) = RX(IX+1,IY,IZ)
        RYSPLT(ISEG,1) = RY(IX,IY,IZ)
        RYSPLT(ISEG,2) = RY(IX,IY+1,IZ)
   20  CONTINUE
c$doacross local(iseg,iz,iy,ix)
       DO 25 ISEG=1,NSEGSPLT
        IX = ISEGSPLT(ISEG,1)
        IY = ISEGSPLT(ISEG,2)
        IZ = ISEGSPLT(ISEG,3)
        RX(IX,IY,IZ) = 0.0
        RX(IX+1,IY,IZ) = 0.0
        RY(IX,IY,IZ) = 0.0
        RY(IX,IY+1,IZ) = 0.0
   25  CONTINUE
      ENDIF

C        PRINT INITIAL CONDITIONS
      CALL RCA09
      IDISK = 3 
 
C        BEGINNING OF FULL INTEGRATION TIMESTEP LOOP
   30 CONTINUE

C        CHECK FOR SIGMA-LEVEL CORRECTION OPTION
        IF(SLCOPT.EQ.1 .AND.
     .      MOD((ITIMESECS-IFIX(86400.*TZERO)),IDTSLCSECS).LE.0.) THEN
          DO 33 ISYS=1,NOSYS
            CALL RCAMPROF(CARAY(1,1,1,ISYS),CSLAVE(1,1,1,ISYS))
   33     CONTINUE
        ENDIF

C        GET TOTAL MASS PER SYSTEM IF MASS/FLUX BALANCES REQUESTED
      IF(MASSBAL.EQ.1 .AND. ITIMESECS.EQ.NXPRTMB) THEN
       DO 35 ISYS=1,NOSYS
        SYSMASS(ISYS)=0.0
        DO 35 IZ=1,NZ
         DO 35 IY=1,NY
          DO 35 IX=1,NX
           IF(FSM(IX,IY).EQ.1.)  SYSMASS(ISYS) = SYSMASS(ISYS) +
     .                           BVOL(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)
  35   CONTINUE
       DO 40 ISYS=1,NOKINSYS
        SYSMASS(NOSYS+ISYS)=0.0
        DO 40 IZ=1,NZ
         DO 40 IY=1,NY
          DO 40 IX=1,NX
           IF(FSM(IX,IY).EQ.1.)
     .                SYSMASS(NOSYS+ISYS) = SYSMASS(NOSYS+ISYS) +
     .                BVOL(IX,IY,IZ)*CKINARRAY(IX,IY,IZ,ISYS)
  40   CONTINUE
      ENDIF

C        IF PIECEWISE LINEAR BOUNDARY CONDITIONS THEN
C           GET CONCENTRATIONS AT CURRENT TIME LEVEL
      IF(IBCPWLOPT.EQ.1) THEN
c$doacross local(isys,deltbc,iz,iy,ix,i)
        DO 50 ISYS=1,NOSYS
          IF(NOBC(ISYS).EQ.0) GO TO 50
          DELTBC = TIME - NXBCT
          DO 45 I=1,NOBC(ISYS)
            IX=IBC(1,I,ISYS)
            IY=IBC(2,I,ISYS)
            IZ=IBC(3,I,ISYS)
            CARAY(IX,IY,IZ,ISYS) = DELTBC*SBC(I,ISYS) + BBC(I,ISYS)
   45     CONTINUE
   50  CONTINUE
      ENDIF

C        EVALUATE KINETIC DERIVATIVES 
      IF(DTWQ.EQ.0.0 .OR. ITIMESECS.GE.ITIMEWQSECS) THEN
        CALL TUNER
        IDISK = 0
        ITIMEWQSECS=ITIMEWQSECS+IDTWQSECS
        TIMEWQ=ITIMEWQSECS/86400.
        ICHANGE=1
      ENDIF
      INITB = 1 

C        SET MASS BALANCE FLAG FOR ACCUMULATING LOADS
       IMBWK=0
       IF(MASSBAL.EQ.1 .AND. ITIMESECS.GE.ISMBSECS) THEN
        IF(IMBDOPT.EQ.0) THEN
         IF(ITIMESECS.EQ.NXPRTMB) IMBWK=1
         DTMB=1.
        ELSE
         IMBWK=1
         DTMB=DT
        ENDIF
       ENDIF
 
C        IF TUNER CALLED OR IF LOADS CHANGED THEN UPDATE -CDARAYS-
      IF(ICHANGE.EQ.1) THEN

C   Begin McCardell
C   Skip the next block McCardell DEBUG
      GO TO 51
      IF (TIME-LAST_BC_WRITE_TIME.GE.1) THEN
        LAST_BC_WRITE_TIME=TIME
        WRITE(441) TIME
        WRITE(441) BPS
        WRITE(442) TIME
        WRITE(442) BNPS
        WRITE(443) TIME
        WRITE(443) BFL
        WRITE(444) TIME
        WRITE(444) BATM
      ENDIF
   51 CONTINUE
C   End McCardell

c$doacross local(isys,iz,iy,ix,is,ie,i),share(cdarays)
       DO 80 ISYS=1,NOSYS

C      SOURCES/SINKS DUE TO KINETICS
        DO 55 IZ=1,NZ
         DO 55 IY=1,NY
          IS = IXS(IY)
          IE = IXE(IY)
          IF(IS.EQ.0) GO TO 55
          DO 54 IX=IS,IE
            CDARAYS(IX,IY,IZ,ISYS) = CDARAY(IX,IY,IZ,ISYS)
  54      CONTINUE
  55    CONTINUE

C  ADD LOADS
       IF(NOPS(ISYS).GT.0) THEN
        DELTPS = TIME - NXPST
        DO 60 I=1,NOPS(ISYS) 
         WK = DELTPS*SPS(I,ISYS) + BPS(I,ISYS)
         IF(IMBWK.EQ.1)  SYSLOADS(1,ISYS) = SYSLOADS(1,ISYS)+DTMB*WK
         IX = IPS(1,I,ISYS)
         IY = IPS(2,I,ISYS)
         IWK = IPS(3,I,ISYS)
C   McCardell -- mod here to change PS loads
         DO IZ=1,NZ
          CDARAYS(IX,IY,IZ,ISYS) = CDARAYS(IX,IY,IZ,ISYS) +
     .         ZFRACPS(IZ,IWK)*WK
         ENDDO
   60   CONTINUE
       ENDIF
       IF(NONPS(ISYS).GT.0) THEN
        DELTNPS = TIME - NXNPST
        DO 65 I=1,NONPS(ISYS)
         WK = DELTNPS*SNPS(I,ISYS) + BNPS(I,ISYS)
         IF(IMBWK.EQ.1)  SYSLOADS(2,ISYS) = SYSLOADS(2,ISYS)+DTMB*WK
         IX = INPS(1,I,ISYS)
         IY = INPS(2,I,ISYS)
         IWK = INPS(3,I,ISYS)
         DO IZ=1,NZ
          CDARAYS(IX,IY,IZ,ISYS) = CDARAYS(IX,IY,IZ,ISYS) +
     .          ZFRACNPS(IZ,IWK)*WK
         ENDDO
   65   CONTINUE
       ENDIF
       IF(NOFL(ISYS).GT.0) THEN
        DELTFL = TIME - NXFLT
        DO 70 I=1,NOFL(ISYS)
         WK = DELTFL*SFL(I,ISYS) + BFL(I,ISYS)
         IF(IMBWK.EQ.1)  SYSLOADS(3,ISYS) = SYSLOADS(3,ISYS)+DTMB*WK
         IX = IFL(1,I,ISYS)
         IY = IFL(2,I,ISYS)
         IWK = IFL(3,I,ISYS)
         DO IZ=1,NZ
          CDARAYS(IX,IY,IZ,ISYS) = CDARAYS(IX,IY,IZ,ISYS) + 
     .          ZFRACFL(IZ,IWK)*WK
         ENDDO
   70   CONTINUE
       ENDIF
       IF(NOATM(ISYS).GT.0) THEN
       DELTATM = TIME - NXATMT
        DO 75 IY=1,NY
         IS = IXS(IY)
         IE = IXE(IY)
         IF(IS.EQ.0) GO TO 75
         DO 74 IX=IS,IE
          IF(FSM(IX,IY).NE.1.) GO TO 74
          CDARAYS(IX,IY,1,ISYS) = CDARAYS(IX,IY,1,ISYS) +
     .         (DELTATM*SATM(IX,IY,ISYS) + BATM(IX,IY,ISYS))*XAZ(IX,IY)
          IF(IMBWK.EQ.1)  SYSLOADS(4,ISYS) = SYSLOADS(4,ISYS) +
     .       DTMB*(DELTATM*SATM(IX,IY,ISYS)+BATM(IX,IY,ISYS))*XAZ(IX,IY)
   74    CONTINUE
   75   CONTINUE
       ENDIF

   80  CONTINUE
       ICHANGE = 0
      ENDIF

C        CALCULATE INITIAL DEPTHS
      DELT = TIME - (NXHYDTSECS-IHYDDTSECS)/86400.
c$doacross local(iy,ix)
      DO 85 IY=1,NY
       DO 85 IX=1,NX
        D(IX,IY) = H(IX,IY)+ETA(IX,IY)+DELT*DETA(IX,IY)*86400.
   85 CONTINUE

C  CALCULATE CONSTANTS USED FOR SMOLARKIEWICZ METHOD
c$doacross local(iy,ix),share(dxbar1,dxbar2,dybar1,dybar2)
      DO 90 IY=2,NY
        DO 90 IX=2,NX
          DXBAR1(IX,IY) = 0.5*(DX(IX,IY)+DX(IX-1,IY))
          DXBAR2(IX,IY) = 0.5*(DX(IX,IY)+DX(IX,IY-1))
          DYBAR1(IX,IY) = 0.5*(DY(IX,IY)+DY(IX-1,IY))
          DYBAR2(IX,IY) = 0.5*(DY(IX,IY)+DY(IX,IY-1))
   90 CONTINUE
c$doacross local(iy,ix,iz)
      DO 95 IZ=1,NZ
        DO 95 IY=2,NY
        DO 95 IX=2,NX
            U(IX,IY,IZ)=QX(IX,IY,IZ)/
     .         (DZ(IZ)*0.5*(D(IX,IY)+D(IX-1,IY))*DYBAR1(IX,IY)+1.0E-20)
            V(IX,IY,IZ)=QY(IX,IY,IZ)/
     .         (DZ(IZ)*0.5*(D(IX,IY)+D(IX,IY-1))*DXBAR2(IX,IY)+1.0E-20)
            W(IX,IY,IZ)=QZ(IX,IY,IZ)/(XAZ(IX,IY)+1.0E-20)
   95 CONTINUE
      IF(NSEGSPLT.GT.0) THEN
       DO 100 ISEG=1,NSEGSPLT
        IX = ISEGSPLT(ISEG,1)
        IY = ISEGSPLT(ISEG,2)
        IZ = ISEGSPLT(ISEG,3)
        USPLT(ISEG,1) = U(IX,IY,IZ)
        USPLT(ISEG,2) = U(IX+1,IY,IZ)
        VSPLT(ISEG,1) = V(IX,IY,IZ)
        VSPLT(ISEG,2) = V(IX,IY+1,IZ)
        WSPLT(ISEG,1) = W(IX,IY,IZ)
        IF(IZ.LT.NZ) THEN
          WSPLT(ISEG,2) = W(IX,IY,IZ+1)
        ELSE
          WSPLT(ISEG,2) = 0.0
        ENDIF
  100  CONTINUE
       DO 105 ISEG=1,NSEGSPLT
        IX = ISEGSPLT(ISEG,1)
        IY = ISEGSPLT(ISEG,2)
        IZ = ISEGSPLT(ISEG,3)
        U(IX,IY,IZ) = 0.0
        U(IX+1,IY,IZ) = 0.0
        V(IX,IY,IZ) = 0.0
        V(IX,IY+1,IZ) = 0.0
        W(IX,IY,IZ) = 0.0
        IF(IZ.LT.NZ)  W(IX,IY,IZ+1) = 0.0
  105  CONTINUE
      ENDIF


C        INTEGRATION STEP BEGINS HERE

C        UPDATE CARAY IF SUBDOMAIN GRID OPTION ACTIVE
      IF(ISUBDOM.EQ.1) CALL RCA14SUBD

c$doacross local(isys,iz,iy,ix),share(dm)
      DO 110 ISYS=1,NOSYS
      DO 110 IZ=1,NZ
        DO 110 IY=1,NY
          DO 110 IX=1,NX
            DM(IX,IY,IZ,ISYS) = 0.0
  110 CONTINUE

C        CHECK TO SEE IF THERE ARE "HIGH SPEED" SEGMENTS
      IF(NSEGSPLT.EQ.0) GO TO 200
C     PERFORM SPLIT TIMESTEP COMPUTATION
C        FIRST INTEGRATING CRITICAL TIMESTEP SEGMENTS
c$doacross local(isys,isplit,iseg,iz,iy,ix,is,ie,inegs,aa,fmax,fmin,
c$&              totmas,concs,dmsplt,qxsplt,antiqxsplt,fluxin,fluxout,
c$&              qysplt,antiqysplt,qzsplt,antiqzsplt,
c$&              rxflx1,rxflx2,ryflx1,ryflx2),
c$&              mp_schedtype=dynamic, chunk=1
Crlm for time test put chunk back in see above line
cccc$&              rxflx1,rxflx2,ryflx1,ryflx2), 
cccc$&       ,mp_schedtype=dynamic, chunk=1
C        OVERALL HIGH SPEED TIMESTEP SYSTEM LOOP
      DO 190 ISYS=1,NOSYS 
C        CHECK FOR SYSTEM BYPASS
       IF(SYSBY(ISYS).EQ.1) GO TO 190
       INEGS=0
       TOTMAS=0.0
       DO 115 IZ=1,NZ
        DO 115 IY=1,NY
          DO 115 IX=1,NX
            CONCS(IX,IY,IZ) = CARAY(IX,IY,IZ,ISYS)
  115  CONTINUE
      
       DO 180 ISPLIT=1,NSPLIT
        DO 120 ISEG=1,NSEGSPLT
          IX = ISEGSPLT(ISEG,1)
          IY = ISEGSPLT(ISEG,2)
          IZ = ISEGSPLT(ISEG,3)

C        COMPUTE VOLUMES AT TIME LEVEL 'N+1'
          BVOLNT(IX,IY,IZ) = BVOL(IX,IY,IZ)
     .                         + ISPLIT*DTSPLIT*VDERSPLT(ISEG)

C        COMPUTE CHANGE IN MASS FOR CRITICAL SEGMENT
          DMSPLT = CDARAYS(IX,IY,IZ,ISYS)
     .        - DIAGSPLT(ISEG)*CARAY(IX,IY,IZ,ISYS)
     .         + AVECTSPLT(ISEG,1)*CARAY(IX-1,IY,IZ,ISYS)
     .          + AVECTSPLT(ISEG,2)*CARAY(IX+1,IY,IZ,ISYS)
     .           + AVECTSPLT(ISEG,3)*CARAY(IX,IY-1,IZ,ISYS)
     .            + AVECTSPLT(ISEG,4)*CARAY(IX,IY+1,IZ,ISYS)
          IF(IZ.GT.1)   
     .      DMSPLT = DMSPLT + AVECTSPLT(ISEG,5)*CARAY(IX,IY,IZ-1,ISYS)
          IF(IZ.LT.NZ)   
     .      DMSPLT = DMSPLT + AVECTSPLT(ISEG,6)*CARAY(IX,IY,IZ+1,ISYS)
C        COMPUTE CHANGE IN MASS IN SEGMENTS ADJOINING CRITICAL SEGMENT
            DM(IX-1,IY,IZ,ISYS) = DM(IX-1,IY,IZ,ISYS) +
     .         AVECTSPLT(ISEG,7)*CARAY(IX,IY,IZ,ISYS)/NSPLIT
            DM(IX+1,IY,IZ,ISYS) = DM(IX+1,IY,IZ,ISYS) +
     .         AVECTSPLT(ISEG,8)*CARAY(IX,IY,IZ,ISYS)/NSPLIT
            DM(IX,IY-1,IZ,ISYS) = DM(IX,IY-1,IZ,ISYS) +
     .         AVECTSPLT(ISEG,9)*CARAY(IX,IY,IZ,ISYS)/NSPLIT
            DM(IX,IY+1,IZ,ISYS) = DM(IX,IY+1,IZ,ISYS) +
     .         AVECTSPLT(ISEG,10)*CARAY(IX,IY,IZ,ISYS)/NSPLIT
            IF(IZ.GT.1)  DM(IX,IY,IZ-1,ISYS) = DM(IX,IY,IZ-1,ISYS) +
     .         AVECTSPLT(ISEG,11)*CARAY(IX,IY,IZ,ISYS)/NSPLIT
            IF(IZ.LT.NZ)  DM(IX,IY,IZ+1,ISYS) = DM(IX,IY,IZ+1,ISYS) +
     .         AVECTSPLT(ISEG,12)*CARAY(IX,IY,IZ,ISYS)/NSPLIT

C        NOW COMPUTE CHANGE IN CONCENTRATION FOR CRITICAL SEGMENT
            CONCS(IX,IY,IZ) = ((BVOL(IX,IY,IZ)+(ISPLIT-1)*DTSPLIT
     .           *VDERSPLT(ISEG))*CARAY(IX,IY,IZ,ISYS) + DTSPLIT*DMSPLT)
     .                  /BVOLNT(IX,IY,IZ)
  120   CONTINUE

C        CHECK FOR MASS/FLUX BALANCE COMPUTATIONS
        IF(MASSBAL.EQ.0) GO TO 123
C        INSTANTANEOUS OR AVERAGED
        IF(IMBDOPT.EQ.0) THEN 
          IF(NXPRTMB.NE.ITIMESECS) GO TO 123
          DO  ISEG=1,NSEGSPLT
           IX = ISEGSPLT(ISEG,1)
           IY = ISEGSPLT(ISEG,2)
           IZ = ISEGSPLT(ISEG,3)
           FLXMB(IX,IY,IZ,ISYS) = FLXMB(IX,IY,IZ,ISYS) + 1./NSPLIT*
     .         (AMAX1(0.,QX(IX,IY,IZ)*CARAY(IX-1,IY,IZ,ISYS))
     .        + AMIN1(0.,QX(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)))
           FLXMB(IX+1,IY,IZ,ISYS) = FLXMB(IX+1,IY,IZ,ISYS) +
     .          1./NSPLIT*(1.-FSMSPLT(IX+1,IY,IZ))*
     .          AMAX1(0.,QX(IX+1,IY,IZ)*CARAY(IX,IY,IZ,ISYS))
     .        + AMIN1(0.,QX(IX+1,IY,IZ)*CARAY(IX+1,IY,IZ,ISYS))
           FLYMB(IX,IY,IZ,ISYS) = FLYMB(IX,IY,IZ,ISYS) + 1./NSPLIT* 
     .         (AMAX1(0.,QY(IX,IY,IZ)*CARAY(IX,IY-1,IZ,ISYS))
     .        + AMIN1(0.,QY(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)))
           FLYMB(IX,IY+1,IZ,ISYS) = FLYMB(IX,IY+1,IZ,ISYS) +
     .          1./NSPLIT*(1.-FSMSPLT(IX,IY+1,IZ))*
     .          AMAX1(0.,QY(IX,IY+1,IZ)*CARAY(IX,IY,IZ,ISYS))
     .        + AMIN1(0.,QY(IX,IY+1,IZ)*CARAY(IX,IY+1,IZ,ISYS))
          ENDDO
        ELSE
          IF(ITIMESECS.LT.ISMBSECS) GO TO 123
          DO  ISEG=1,NSEGSPLT
           IX = ISEGSPLT(ISEG,1)
           IY = ISEGSPLT(ISEG,2)
           IZ = ISEGSPLT(ISEG,3)
           FLXMB(IX,IY,IZ,ISYS) = FLXMB(IX,IY,IZ,ISYS) + DTSPLIT*
     .         (AMAX1(0.,QX(IX,IY,IZ)*CARAY(IX-1,IY,IZ,ISYS))
     .        + AMIN1(0.,QX(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)))
           FLXMB(IX+1,IY,IZ,ISYS) = FLXMB(IX+1,IY,IZ,ISYS) +
     .          DTSPLIT*(1.-FSMSPLT(IX+1,IY,IZ))*
     .         (AMAX1(0.,QX(IX+1,IY,IZ)*CARAY(IX,IY,IZ,ISYS))
     .        + AMIN1(0.,QX(IX+1,IY,IZ)*CARAY(IX+1,IY,IZ,ISYS)))
           FLYMB(IX,IY,IZ,ISYS) = FLYMB(IX,IY,IZ,ISYS) + DTSPLIT*
     .         (AMAX1(0.,QY(IX,IY,IZ)*CARAY(IX,IY-1,IZ,ISYS))
     .        + AMIN1(0.,QY(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)))
           FLYMB(IX,IY+1,IZ,ISYS) = FLYMB(IX,IY+1,IZ,ISYS) +
     .          DTSPLIT*(1.-FSMSPLT(IX,IY+1,IZ))*
     .         (AMAX1(0.,QY(IX,IY+1,IZ)*CARAY(IX,IY,IZ,ISYS))
     .        + AMIN1(0.,QY(IX,IY+1,IZ)*CARAY(IX,IY+1,IZ,ISYS)))
          ENDDO
        ENDIF

C******************************************************************
C  SMOLARKIEWICZ METHOD FOR SECOND-ORDER ACCURACY
  123  IF(ISMOLAR .GE. 0) THEN
 
C        CALCULATE ANTIDIFFUSIION FLOWS ( = VELOCITIES * AREAS)
C        AND THEN CALCULATE ANTIDIFFUSION FLUXES

C        COMPUTE FOR I,J,K INTERFACES
       DO 125 ISEG=1,NSEGSPLT
        IX = ISEGSPLT(ISEG,1)
        IY = ISEGSPLT(ISEG,2)
        IZ = ISEGSPLT(ISEG,3)
          IF(CONCS(IX,IY,IZ).LE.1.0E-09 .OR.
     .            CONCS(IX-1,IY,IZ).LE.1.0E-09) THEN
             QXSPLT(ISEG,1) = 0.0
          ELSE IF(ABS(USPLT(ISEG,1)).LT.(USPLT(ISEG,1)*USPLT(ISEG,1)*
     .               DTSPLIT/DXBAR1(IX,IY))) THEN
             QXSPLT(ISEG,1) = 0.0
          ELSE
            IF(FSM(IX-1,IY).GE.1. .OR.
     .         (ISMOLBCOPT.EQ.1 .AND. FSM(IX-1,IY).EQ.-2.)) THEN
              ANTIQXSPLT = ABS(USPLT(ISEG,1))*
     .          (1.-ABS(USPLT(ISEG,1))*DTSPLIT/DXBAR1(IX,IY))*
     .               (CONCS(IX,IY,IZ)-CONCS(IX-1,IY,IZ))/
     .                  (CONCS(IX,IY,IZ)+CONCS(IX-1,IY,IZ)+CNONZERO)
              QXSPLT(ISEG,1) = 0.5*
     .              (ANTIQXSPLT*(CONCS(IX,IY,IZ)+CONCS(IX-1,IY,IZ))
     .          -ABS(ANTIQXSPLT)*(CONCS(IX,IY,IZ)-CONCS(IX-1,IY,IZ)))
     .          *DYBAR1(IX,IY)*0.5*(D(IX,IY)+D(IX-1,IY))*DZ(IZ)
            ELSE
              QXSPLT(ISEG,1) = 0.0
            ENDIF
          ENDIF
          IF(CONCS(IX,IY,IZ).LE.1.0E-09 .OR.
     .          CONCS(IX,IY-1,IZ).LE.1.0E-09) THEN
             QYSPLT(ISEG,1) = 0.0
          ELSE IF(ABS(VSPLT(ISEG,1)).LT.(VSPLT(ISEG,1)*VSPLT(ISEG,1)*
     .               DTSPLIT/DYBAR2(IX,IY))) THEN
             QYSPLT(ISEG,1) = 0.0
          ELSE
            IF(FSM(IX,IY-1).GE.1. .OR.
     .         (ISMOLBCOPT.EQ.1 .AND. FSM(IX,IY-1).EQ.-2.)) THEN
              ANTIQYSPLT = ABS(VSPLT(ISEG,1))*
     .          (1.-ABS(VSPLT(ISEG,1))*DTSPLIT/DYBAR2(IX,IY))*
     .               (CONCS(IX,IY,IZ)-CONCS(IX,IY-1,IZ))/
     .                  (CONCS(IX,IY,IZ)+CONCS(IX,IY-1,IZ)+CNONZERO)
              QYSPLT(ISEG,1) = 0.5*
     .              (ANTIQYSPLT*(CONCS(IX,IY,IZ)+CONCS(IX,IY-1,IZ))
     .          -ABS(ANTIQYSPLT)*(CONCS(IX,IY,IZ)-CONCS(IX,IY-1,IZ)))
     .          *DXBAR2(IX,IY)*0.5*(D(IX,IY)+D(IX,IY-1))*DZ(IZ)
            ELSE
              QYSPLT(ISEG,1) = 0.0
            ENDIF
          ENDIF
        IF(IZ.GT.1) THEN
          IF(CONCS(IX,IY,IZ).LE.1.0E-09 .OR.
     .          CONCS(IX,IY,IZ-1).LE.1.0E-09) THEN
            QZSPLT(ISEG,1) = 0.0
          ELSE IF(ABS(WSPLT(ISEG,1)).LT.(WSPLT(ISEG,1)*WSPLT(ISEG,1)*
     .               DTSPLIT/(D(IX,IY)*DZZ(IZ-1)))) THEN
            QZSPLT(ISEG,1) = 0.0
          ELSE
            ANTIQZSPLT = ABS(WSPLT(ISEG,1))*
     .           (1.-ABS(WSPLT(ISEG,1))*DTSPLIT/(D(IX,IY)*DZZ(IZ-1)))*
     .             (CONCS(IX,IY,IZ-1)-CONCS(IX,IY,IZ))/
     .                  (CONCS(IX,IY,IZ-1)+CONCS(IX,IY,IZ)+CNONZERO)
            QZSPLT(ISEG,1) = 0.5*
     .            (ANTIQZSPLT*(CONCS(IX,IY,IZ-1)+CONCS(IX,IY,IZ))
     .        -ABS(ANTIQZSPLT)*(CONCS(IX,IY,IZ-1)-CONCS(IX,IY,IZ)))
     .         *XAZ(IX,IY)
          ENDIF
        ELSE
          QZSPLT(ISEG,1) = 0.0
        ENDIF
 125   CONTINUE

C        I+1,J+1,K+1 INTERFACES
       DO 130 ISEG=1,NSEGSPLT
        IX = ISEGSPLT(ISEG,1)
        IY = ISEGSPLT(ISEG,2)
        IZ = ISEGSPLT(ISEG,3)
        IF(CONCS(IX,IY,IZ).LE.1.0E-09 .OR.
     .       CONCS(IX+1,IY,IZ).LE.1.0E-09) THEN
          QXSPLT(ISEG,2) = 0.0
        ELSE IF(ABS(USPLT(ISEG,2)).LT.(USPLT(ISEG,2)*USPLT(ISEG,2)*
     .               DTSPLIT/DXBAR1(IX+1,IY))) THEN
          QXSPLT(ISEG,2) = 0.0
        ELSE
          IF(FSM(IX+1,IY).GE.1. .OR.
     .         (ISMOLBCOPT.EQ.1 .AND. FSM(IX+1,IY).EQ.-2.)) THEN
            ANTIQXSPLT = ABS(USPLT(ISEG,2))*
     .         (1.-ABS(USPLT(ISEG,2))*DTSPLIT/DXBAR1(IX+1,IY))*
     .              (CONCS(IX,IY,IZ)-CONCS(IX+1,IY,IZ))/
     .                 (CONCS(IX,IY,IZ)+CONCS(IX+1,IY,IZ)+CNONZERO)
            QXSPLT(ISEG,2) = 0.5*
     .         (ANTIQXSPLT*(CONCS(IX,IY,IZ)+CONCS(IX+1,IY,IZ)) -
     .      ABS(ANTIQXSPLT)*(CONCS(IX,IY,IZ)-CONCS(IX+1,IY,IZ)))
     .          *DYBAR1(IX+1,IY)*0.5*(D(IX,IY)+D(IX+1,IY))*DZ(IZ)
          ELSE
             QXSPLT(ISEG,2) = 0.0
          ENDIF
        ENDIF

        IF(CONCS(IX,IY,IZ).LE.1.0E-09 .OR.
     .       CONCS(IX,IY+1,IZ).LE.1.0E-09) THEN
          QYSPLT(ISEG,2) = 0.0
        ELSE IF(ABS(VSPLT(ISEG,2)).LT.(VSPLT(ISEG,2)*VSPLT(ISEG,2)*
     .               DTSPLIT/DYBAR2(IX,IY+1))) THEN
          QYSPLT(ISEG,2) = 0.0
        ELSE
          IF(FSM(IX,IY+1).GE.1. .OR.
     .         (ISMOLBCOPT.EQ.1 .AND. FSM(IX,IY+1).EQ.-2.)) THEN
            ANTIQYSPLT = ABS(VSPLT(ISEG,2))*
     .         (1.-ABS(VSPLT(ISEG,2))*DTSPLIT/DYBAR2(IX,IY+1))*
     .              (CONCS(IX,IY,IZ)-CONCS(IX,IY+1,IZ))/
     .                 (CONCS(IX,IY,IZ)+CONCS(IX,IY+1,IZ)+CNONZERO)
            QYSPLT(ISEG,2) = 0.5*
     .         (ANTIQYSPLT*(CONCS(IX,IY,IZ)+CONCS(IX,IY+1,IZ)) -
     .      ABS(ANTIQYSPLT)*(CONCS(IX,IY,IZ)-CONCS(IX,IY+1,IZ)))      
     .          *DXBAR2(IX,IY+1)*0.5*(D(IX,IY)+D(IX,IY+1))*DZ(IZ)
          ELSE
            QYSPLT(ISEG,2) = 0.0
          ENDIF
        ENDIF

        IF(IZ.LT.NZ) THEN
         IF(CONCS(IX,IY,IZ).LE.1.0E-09 .OR.
     .           CONCS(IX,IY,IZ+1).LE.1.0E-09) THEN
           QZSPLT(ISEG,2) = 0.0
         ELSE IF(ABS(WSPLT(ISEG,2)).LT.(WSPLT(ISEG,2)*WSPLT(ISEG,2)*
     .                DTSPLIT/(D(IX,IY)*DZZ(IZ)))) THEN
           QZSPLT(ISEG,2) = 0.0
         ELSE
           ANTIQZSPLT = ABS(WSPLT(ISEG,2))*
     .            (1.-ABS(WSPLT(ISEG,2))*DTSPLIT/(D(IX,IY)*DZZ(IZ)))*
     .              (CONCS(IX,IY,IZ+1)-CONCS(IX,IY,IZ))/
     .                 (CONCS(IX,IY,IZ+1)+CONCS(IX,IY,IZ)+CNONZERO)
           QZSPLT(ISEG,2) = 0.5*
     .         (ANTIQZSPLT*(CONCS(IX,IY,IZ+1)+CONCS(IX,IY,IZ)) -
     .      ABS(ANTIQZSPLT)*(CONCS(IX,IY,IZ+1)-CONCS(IX,IY,IZ)))
     .          *XAZ(IX,IY)
         ENDIF
        ELSE
         QZSPLT(ISEG,2) = 0.0
        ENDIF
  130  CONTINUE
      ENDIF

C  TAKE CORRECTOR UPWIND STEP
C    PLACING RESULTS BACK INTO CONCS (NOW AT (N+1))
      DO 135 ISEG=1,NSEGSPLT
       IX = ISEGSPLT(ISEG,1)
       IY = ISEGSPLT(ISEG,2)
       IZ = ISEGSPLT(ISEG,3)
       CONCS(IX,IY,IZ)=CONCS(IX,IY,IZ)
     .     +DTSPLIT*(QXSPLT(ISEG,1)+QXSPLT(ISEG,2)
     .              +QYSPLT(ISEG,1)+QYSPLT(ISEG,2)
     .              +QZSPLT(ISEG,1)+QZSPLT(ISEG,2))/
     .                                     BVOLNT(IX,IY,IZ)
        DM(IX-1,IY,IZ,ISYS) = DM(IX-1,IY,IZ,ISYS)
     .                              - QXSPLT(ISEG,1)/NSPLIT
        DM(IX+1,IY,IZ,ISYS) = DM(IX+1,IY,IZ,ISYS)
     .                              - QXSPLT(ISEG,2)/NSPLIT
        DM(IX,IY-1,IZ,ISYS) = DM(IX,IY-1,IZ,ISYS)
     .                              - QYSPLT(ISEG,1)/NSPLIT
        DM(IX,IY+1,IZ,ISYS) = DM(IX,IY+1,IZ,ISYS)
     .                              - QYSPLT(ISEG,2)/NSPLIT
        IF(IZ.GT.1)   DM(IX,IY,IZ-1,ISYS) = DM(IX,IY,IZ-1,ISYS)
     .                              - QZSPLT(ISEG,1)/NSPLIT
        IF(IZ.LT.NZ)  DM(IX,IY,IZ+1,ISYS) = DM(IX,IY,IZ+1,ISYS)
     .                              - QZSPLT(ISEG,2)/NSPLIT
  135 CONTINUE

C        CHECK FOR MASS/FLUX BALANCE COMPUTATIONS
      IF(MASSBAL.EQ.0) GO TO 140
C        INSTANTANEOUS OR AVERAGED
      IF(IMBDOPT.EQ.0) THEN
       IF(NXPRTMB.NE.ITIMESECS) GO TO 140
       DO  ISEG=1,NSEGSPLT
        IX = ISEGSPLT(ISEG,1)
        IY = ISEGSPLT(ISEG,2)
        IZ = ISEGSPLT(ISEG,3)
        FLXMB(IX,IY,IZ,ISYS) = FLXMB(IX,IY,IZ,ISYS) +
     .          1./NSPLIT*QXSPLT(ISEG,1)
        FLXMB(IX+1,IY,IZ,ISYS) = FLXMB(IX+1,IY,IZ,ISYS) +
     .          1./NSPLIT*(1.-FSMSPLT(IX+1,IY,IZ))*QXSPLT(ISEG,2)
        FLYMB(IX,IY,IZ,ISYS) = FLYMB(IX,IY,IZ,ISYS) +
     .          1./NSPLIT*QYSPLT(ISEG,1)
        FLYMB(IX,IY+1,IZ,ISYS) = FLYMB(IX,IY+1,IZ,ISYS) +
     .          1./NSPLIT*(1.-FSMSPLT(IX,IY+1,IZ))*QYSPLT(ISEG,2)
       ENDDO
      ELSE
       IF(ITIMESECS.LT.ISMBSECS) GO TO 140
       DO  ISEG=1,NSEGSPLT
        IX = ISEGSPLT(ISEG,1)
        IY = ISEGSPLT(ISEG,2)
        IZ = ISEGSPLT(ISEG,3)
        FLXMB(IX,IY,IZ,ISYS) = FLXMB(IX,IY,IZ,ISYS) + DTSPLIT*
     .          QXSPLT(ISEG,1)
        FLXMB(IX+1,IY,IZ,ISYS) = FLXMB(IX+1,IY,IZ,ISYS) + DTSPLIT*
     .          (1.-FSMSPLT(IX+1,IY,IZ))*QXSPLT(ISEG,2)
        FLYMB(IX,IY,IZ,ISYS) = FLYMB(IX,IY,IZ,ISYS) + DTSPLIT*
     .          QYSPLT(ISEG,1)
        FLYMB(IX,IY+1,IZ,ISYS) = FLYMB(IX,IY+1,IZ,ISYS) + DTSPLIT*
     .          (1.-FSMSPLT(IX,IY+1,IZ))*QYSPLT(ISEG,2)
       ENDDO
      ENDIF

C  CALCULATE HORIZONTAL DIFFUSION FLUXES
C    AND THEN CHANGE IN CONCENTRATIONS DUE TO HORIZONTAL DIFFUSION
  140 DO 145 ISEG=1,NSEGSPLT
        IX = ISEGSPLT(ISEG,1)
        IY = ISEGSPLT(ISEG,2)
        IZ = ISEGSPLT(ISEG,3)
        RXFLX1 = RXSPLT(ISEG,1)*
     .          ((CARAY(IX-1,IY,IZ,ISYS)-CSLAVE(IX-1,IY,IZ,ISYS))
     .          -(CARAY(IX,IY,IZ,ISYS)-CSLAVE(IX,IY,IZ,ISYS)))
        RXFLX2 = RXSPLT(ISEG,2)*
     .          ((CARAY(IX+1,IY,IZ,ISYS)-CSLAVE(IX+1,IY,IZ,ISYS))
     .          -(CARAY(IX,IY,IZ,ISYS)-CSLAVE(IX,IY,IZ,ISYS)))
        RYFLX1 = RYSPLT(ISEG,1)*
     .          ((CARAY(IX,IY-1,IZ,ISYS)-CSLAVE(IX,IY-1,IZ,ISYS))
     .          -(CARAY(IX,IY,IZ,ISYS)-CSLAVE(IX,IY,IZ,ISYS)))
        RYFLX2 = RYSPLT(ISEG,2)*
     .          ((CARAY(IX,IY+1,IZ,ISYS)-CSLAVE(IX,IY+1,IZ,ISYS))
     .          -(CARAY(IX,IY,IZ,ISYS)-CSLAVE(IX,IY,IZ,ISYS)))
        CONCS(IX,IY,IZ) = CONCS(IX,IY,IZ) +
     .     DTSPLIT*(RXFLX1+RXFLX2+RYFLX1+RYFLX2)/BVOLNT(IX,IY,IZ)
        DM(IX-1,IY,IZ,ISYS) = DM(IX-1,IY,IZ,ISYS) - RXFLX1/NSPLIT
        DM(IX+1,IY,IZ,ISYS) = DM(IX+1,IY,IZ,ISYS) - RXFLX2/NSPLIT
        DM(IX,IY-1,IZ,ISYS) = DM(IX,IY-1,IZ,ISYS) - RYFLX1/NSPLIT
        DM(IX,IY+1,IZ,ISYS) = DM(IX,IY+1,IZ,ISYS) - RYFLX2/NSPLIT
  145 CONTINUE

C        CHECK FOR MASS/FLUX BALANCE COMPUTATIONS
      IF(MASSBAL.EQ.0) GO TO 150
C        INSTANTANEOUS OR AVERAGED
      IF(IMBDOPT.EQ.0) THEN 
        IF(NXPRTMB.NE.ITIMESECS) GO TO 150
        DO  ISEG=1,NSEGSPLT
         IX = ISEGSPLT(ISEG,1)
         IY = ISEGSPLT(ISEG,2)
         IZ = ISEGSPLT(ISEG,3)
         FLXMB(IX,IY,IZ,ISYS) = FLXMB(IX,IY,IZ,ISYS) + 1./NSPLIT*
     .     RXSPLT(ISEG,1)*
     .     ((CARAY(IX-1,IY,IZ,ISYS)-CSLAVE(IX-1,IY,IZ,ISYS))-
     .     (CARAY(IX,IY,IZ,ISYS)-CSLAVE(IX,IY,IZ,ISYS)))
         FLXMB(IX+1,IY,IZ,ISYS) = FLXMB(IX+1,IY,IZ,ISYS) +
     .     1./NSPLIT*(1.-FSMSPLT(IX+1,IY,IZ))*
     .     RXSPLT(ISEG,2)*
     .     ((CARAY(IX+1,IY,IZ,ISYS)-CSLAVE(IX+1,IY,IZ,ISYS))-
     .     (CARAY(IX,IY,IZ,ISYS)-CSLAVE(IX,IY,IZ,ISYS)))
         FLYMB(IX,IY,IZ,ISYS) = FLYMB(IX,IY,IZ,ISYS) + 1./NSPLIT*
     .     RYSPLT(ISEG,1)*
     .     ((CARAY(IX,IY-1,IZ,ISYS)-CSLAVE(IX,IY-1,IZ,ISYS))-
     .     (CARAY(IX,IY,IZ,ISYS)-CSLAVE(IX,IY,IZ,ISYS)))
         FLYMB(IX,IY+1,IZ,ISYS) = FLYMB(IX,IY+1,IZ,ISYS) +
     .     1./NSPLIT*(1.-FSMSPLT(IX,IY+1,IZ))*
     .     RYSPLT(ISEG,2)*
     .     ((CARAY(IX,IY+1,IZ,ISYS)-CSLAVE(IX,IY+1,IZ,ISYS))-
     .     (CARAY(IX,IY,IZ,ISYS)-CSLAVE(IX,IY,IZ,ISYS)))
        ENDDO
      ELSE
        IF(ITIMESECS.LT.ISMBSECS) GO TO 150
        DO  ISEG=1,NSEGSPLT
         IX = ISEGSPLT(ISEG,1)
         IY = ISEGSPLT(ISEG,2)
         IZ = ISEGSPLT(ISEG,3)
         FLXMB(IX,IY,IZ,ISYS) = FLXMB(IX,IY,IZ,ISYS) + DTSPLIT*
     .     RXSPLT(ISEG,1)*
     .     ((CARAY(IX-1,IY,IZ,ISYS)-CSLAVE(IX-1,IY,IZ,ISYS))-
     .     (CARAY(IX,IY,IZ,ISYS)-CSLAVE(IX,IY,IZ,ISYS)))
         FLXMB(IX+1,IY,IZ,ISYS) = FLXMB(IX+1,IY,IZ,ISYS) + DTSPLIT*
     .     (1.-FSMSPLT(IX+1,IY,IZ))*RXSPLT(ISEG,2)*
     .     ((CARAY(IX+1,IY,IZ,ISYS)-CSLAVE(IX+1,IY,IZ,ISYS))-
     .     (CARAY(IX,IY,IZ,ISYS)-CSLAVE(IX,IY,IZ,ISYS)))
         FLYMB(IX,IY,IZ,ISYS) = FLYMB(IX,IY,IZ,ISYS) + DTSPLIT*
     .     RYSPLT(ISEG,1)*
     .     ((CARAY(IX,IY-1,IZ,ISYS)-CSLAVE(IX,IY-1,IZ,ISYS))-
     .     (CARAY(IX,IY,IZ,ISYS)-CSLAVE(IX,IY,IZ,ISYS)))
         FLYMB(IX,IY+1,IZ,ISYS) = FLYMB(IX,IY+1,IZ,ISYS) + DTSPLIT*
     .     (1.-FSMSPLT(IX,IY+1,IZ))*RYSPLT(ISEG,2)*
     .     ((CARAY(IX,IY+1,IZ,ISYS)-CSLAVE(IX,IY+1,IZ,ISYS))-
     .     (CARAY(IX,IY,IZ,ISYS)-CSLAVE(IX,IY,IZ,ISYS)))
        ENDDO
      ENDIF

C  END OF SMOLARKIEWICZ METHOD FOR "HIGH-SPEED" SEGMENTS

  150   DO 155 ISEG=1,NSEGSPLT
          IX = ISEGSPLT(ISEG,1)
          IY = ISEGSPLT(ISEG,2)
          IZ = ISEGSPLT(ISEG,3)
          CARAY(IX,IY,IZ,ISYS) = CONCS(IX,IY,IZ)
  155   CONTINUE

  180 CONTINUE

              DO 185 ISEG=1,NSEGSPLT
        IX = ISEGSPLT(ISEG,1)
        IY = ISEGSPLT(ISEG,2)
        IZ = ISEGSPLT(ISEG,3)
        DM(IX,IY,IZ,ISYS) = 0.0
  185  CONTINUE

  190 CONTINUE

C        UPDATE VOLUMES FOR HIGH-SPEED SEGMENTS
      DO 195 ISEG=1,NSEGSPLT
        IX = ISEGSPLT(ISEG,1)
        IY = ISEGSPLT(ISEG,2)
        IZ = ISEGSPLT(ISEG,3)
        BVOL(IX,IY,IZ) = BVOLNT(IX,IY,IZ)
  195 CONTINUE

  200 CONTINUE

C-----------------------------------------------------------------------
C        NOW TAKE FULL EXPLICIT STEP FOR REMAINING WATER SEGMENTS

C        COMPUTE VOLUMES AT TIME LEVEL 'N+1'
c$doacross local(iz,iy,ix)
      DO 210 IZ=1,NZ
        DO 210 IY=1,NY
          DO 210 IX=1,NX
            BVOLN(IX,IY,IZ) = BVOL(IX,IY,IZ) +
     .           (FSM(IX,IY)-FSMSPLT(IX,IY,IZ))*DT*VDER(IX,IY,IZ)
 210  CONTINUE

C        UPDATE -DM- TO INCLUDE KINETICS AND LOADS
c$doacross local(isys,iz,iy,ix,is,ie)
      DO 215 ISYS=1,NOSYS
       DO 215 IZ=1,NZ
        DO 215 IY=1,NY
         IS = IXS(IY)
         IE = IXE(IY)
         IF(IS.EQ.0) GO TO 215
         DO 214 IX=IS,IE
          DM(IX,IY,IZ,ISYS) = DM(IX,IY,IZ,ISYS)
     .       + (FSM(IX,IY)-FSMSPLT(IX,IY,IZ))*CDARAYS(IX,IY,IZ,ISYS)
  214    CONTINUE
  215 CONTINUE
 
c$doacross local(isys,iy,ix,iz,is,ie,i,j,izyr,aa,fmax,fmin,inegs,totmas,
c$&       concs,antiqx,antiqy,antiqz,qxflx,qyflx,qzflx,fluxin,fluxout,
c$&       rxflx,ryflx,mf,al,ad,au,beta,gamma),share(negseg)
c$&       ,mp_schedtype=dynamic, chunk=1

      DO 400 ISYS=1,NOSYS 

C        CHECK FOR SYSTEM BYPASS
      IF(SYSBY(ISYS).EQ.1) GO TO 400
      INEGS=0
      TOTMAS=0.0

C  CALCULATE CHANGE IN CONCENTRATION DUE TO ADVECTIVE TRANSPORT
C    AND HORIZONTAL MIXING PROCESSES
      IF (NZ.GT.1) THEN
C      SURFACE LAYER
        DO 220 IY=1,NY
          IS = IXS(IY)
          IE = IXE(IY)
          IF(IS.EQ.0) GO TO 220
          DO 219 IX=IS,IE
            IF(FSM(IX,IY).NE.1.)GO TO 219
            DM(IX,IY,1,ISYS) = DM(IX,IY,1,ISYS)
     .        - DIAG(IX,IY,1)*CARAY(IX,IY,1,ISYS)
     .         + AVECT(IX,IY,1,1)*CARAY(IX-1,IY,1,ISYS)
     .          + AVECT(IX,IY,1,2)*CARAY(IX+1,IY,1,ISYS)
     .           + AVECT(IX,IY,1,3)*CARAY(IX,IY-1,1,ISYS)
     .            + AVECT(IX,IY,1,4)*CARAY(IX,IY+1,1,ISYS)
     .             + AVECT(IX,IY,1,6)*CARAY(IX,IY,2,ISYS)
            CONCS(IX,IY,1) = (BVOL(IX,IY,1)*CARAY(IX,IY,1,ISYS)
     .                         + DT*DM(IX,IY,1,ISYS))/BVOLN(IX,IY,1)
  219     CONTINUE
  220   CONTINUE
C      LAYERS 2 TO NZ-1
        DO 225 IZ=2,NZ-1
          DO 225 IY=1,NY
            IS = IXS(IY)
            IE = IXE(IY)
            IF(IS.EQ.0) GO TO 225
            DO 224 IX=IS,IE
              IF(FSM(IX,IY).NE.1.)GO TO 224
              DM(IX,IY,IZ,ISYS) = DM(IX,IY,IZ,ISYS)
     .         - DIAG(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)
     .          + AVECT(IX,IY,IZ,1)*CARAY(IX-1,IY,IZ,ISYS)
     .           + AVECT(IX,IY,IZ,2)*CARAY(IX+1,IY,IZ,ISYS)
     .            + AVECT(IX,IY,IZ,3)*CARAY(IX,IY-1,IZ,ISYS)
     .             + AVECT(IX,IY,IZ,4)*CARAY(IX,IY+1,IZ,ISYS)
     .              + AVECT(IX,IY,IZ,5)*CARAY(IX,IY,IZ-1,ISYS)
     .               + AVECT(IX,IY,IZ,6)*CARAY(IX,IY,IZ+1,ISYS)
              CONCS(IX,IY,IZ) = (BVOL(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)
     .                           + DT*DM(IX,IY,IZ,ISYS))/BVOLN(IX,IY,IZ)
  224       CONTINUE
  225   CONTINUE
C      BOTTOM LAYER
        DO 230 IY=1,NY
          IS = IXS(IY)
          IE = IXE(IY)
          IF(IS.EQ.0) GO TO 230
          DO 229 IX=IS,IE
            IF(FSM(IX,IY).NE.1.)GO TO 229
            DM(IX,IY,NZ,ISYS) = DM(IX,IY,NZ,ISYS)
     .        - DIAG(IX,IY,NZ)*CARAY(IX,IY,NZ,ISYS)
     .         + AVECT(IX,IY,NZ,1)*CARAY(IX-1,IY,NZ,ISYS)
     .          + AVECT(IX,IY,NZ,2)*CARAY(IX+1,IY,NZ,ISYS)
     .           + AVECT(IX,IY,NZ,3)*CARAY(IX,IY-1,NZ,ISYS)
     .            + AVECT(IX,IY,NZ,4)*CARAY(IX,IY+1,NZ,ISYS)
     .             + AVECT(IX,IY,NZ,5)*CARAY(IX,IY,NZ-1,ISYS)
            CONCS(IX,IY,NZ) =
     .             (BVOL(IX,IY,NZ)*CARAY(IX,IY,NZ,ISYS)
     .                   + DT*DM(IX,IY,NZ,ISYS))/BVOLN(IX,IY,NZ)
  229     CONTINUE
  230   CONTINUE
 
      ELSE
 
C        ONE LAYER MODEL
        IZ=1
        DO 235 IY=1,NY
          IS = IXS(IY)
          IE = IXE(IY)
          IF(IS.EQ.0) GO TO 235
          DO 234 IX=IS,IE
            IF(FSM(IX,IY).NE.1.)GO TO 234
            DM(IX,IY,IZ,ISYS) = DM(IX,IY,IZ,ISYS)
     .       - DIAG(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)
     .        + AVECT(IX,IY,IZ,1)*CARAY(IX-1,IY,IZ,ISYS)
     .         + AVECT(IX,IY,IZ,2)*CARAY(IX+1,IY,IZ,ISYS)
     .          + AVECT(IX,IY,IZ,3)*CARAY(IX,IY-1,IZ,ISYS)
     .           + AVECT(IX,IY,IZ,4)*CARAY(IX,IY+1,IZ,ISYS)
            CONCS(IX,IY,IZ) = (BVOL(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)
     .                         + DT*DM(IX,IY,IZ,ISYS))/BVOLN(IX,IY,IZ)
  234     CONTINUE
  235   CONTINUE

      ENDIF

C  BOUNDARY ELEMENTS ARE UNCHANGED
      DO 240 I=1,NOBCALL
        IX=IBCALL(1,I)
        IY=IBCALL(2,I)
        IZ=IBCALL(3,I)
        CONCS(IX,IY,IZ)=CARAY(IX,IY,IZ,ISYS)
  240 CONTINUE

C        CHECK FOR MASS/FLUX BALANCE COMPUTATIONS
      IF(MASSBAL.EQ.0) GO TO 260
C        INSTANTANEOUS OR AVERAGED
      IF(IMBDOPT.EQ.0 .AND. ITIMESECS.NE.NXPRTMB) GO TO 260
      IF(ITIMESECS.LT.ISMBSECS) GO TO 260
      DO 250 IZ=1,NZ
       DO 250 IY=1,NY
        DO 250 IX=1,NX
         IF(FSM(IX,IY).NE.1.) GO TO 250
         FLXMB(IX,IY,IZ,ISYS) = FLXMB(IX,IY,IZ,ISYS) + DTMB*
     .        (1.-FSMSPLT(IX,IY,IZ))*
     .        (AMAX1(0.,QX(IX,IY,IZ)*CARAY(IX-1,IY,IZ,ISYS))
     .       + AMIN1(0.,QX(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)))
         FLYMB(IX,IY,IZ,ISYS) = FLYMB(IX,IY,IZ,ISYS) + DTMB*
     .        (1.-FSMSPLT(IX,IY,IZ))*
     .        (AMAX1(0.,QY(IX,IY,IZ)*CARAY(IX,IY-1,IZ,ISYS))
     .       + AMIN1(0.,QY(IX,IY,IZ)*CARAY(IX,IY,IZ,ISYS)))
  250 CONTINUE

C***********************************************************************

C        SMOLARKIEWICZ CORRECTIONS

C        INITIALIZE ARRAYS
  260 DO 265 IZ=1,NZ 
       DO 265 IY=1,NY
        DO 265 IX=1,NX
         ANTIQX(IX,IY,IZ)=0.0
         ANTIQY(IX,IY,IZ)=0.0
         ANTIQZ(IX,IY,IZ)=0.0
         QXFLX(IX,IY,IZ)=0.0
         QYFLX(IX,IY,IZ)=0.0
         QZFLX(IX,IY,IZ)=0.0
  265 CONTINUE

C-----------------------------------------------------------------------
C        SECOND ORDER ACCURATE SCHEME (ISMOLAR.EQ.0)
      IF(ISMOLAR.EQ.0) THEN
C        CALCULATE ANTIDIFFUSION FLOWS ( = VELOCITIES * AREAS)
       DO 280 IZ=1,NZ
        DO 280 IY=2,NY
         DO 280 IX=2,NX
          IF(FSM(IX,IY).EQ.0. .OR. FSM(IX,IY).EQ.-1.) GO TO 280
          IF(FSM(IX,IY).EQ.-2. .AND. ISMOLBCOPT.EQ.0) GO TO 280
           IF(CONCS(IX,IY,IZ).LE.1.0E-09 .OR.
     .           CONCS(IX-1,IY,IZ).LE.1.0E-09) THEN
              ANTIQX(IX,IY,IZ) = 0.0
           ELSE IF(ABS(U(IX,IY,IZ)).LT.(U(IX,IY,IZ)*U(IX,IY,IZ)*
     .                DT/DXBAR1(IX,IY))) THEN
              ANTIQX(IX,IY,IZ) = 0.0
           ELSE
              ANTIQX(IX,IY,IZ) = ABS(U(IX,IY,IZ))*
     .         (1.-ABS(U(IX,IY,IZ))*DT/DXBAR1(IX,IY))*
     .              (CONCS(IX,IY,IZ)-CONCS(IX-1,IY,IZ))/
     .                 (CONCS(IX,IY,IZ)+CONCS(IX-1,IY,IZ)+CNONZERO)
           ENDIF

           IF(CONCS(IX,IY,IZ).LE.1.0E-09 .OR.
     .            CONCS(IX,IY-1,IZ).LE.1.0E-09) THEN
              ANTIQY(IX,IY,IZ) = 0.0
           ELSE IF(ABS(V(IX,IY,IZ)).LT.(V(IX,IY,IZ)*V(IX,IY,IZ)*
     .                DT/DYBAR2(IX,IY))) THEN
              ANTIQY(IX,IY,IZ) = 0.0
           ELSE
              ANTIQY(IX,IY,IZ) = ABS(V(IX,IY,IZ))*
     .         (1.-ABS(V(IX,IY,IZ))*DT/DYBAR2(IX,IY))*
     .              (CONCS(IX,IY,IZ)-CONCS(IX,IY-1,IZ))/
     .                 (CONCS(IX,IY,IZ)+CONCS(IX,IY-1,IZ)+CNONZERO)
           ENDIF

          IF(FSM(IX,IY).GT.0.) THEN
           IF (IZ.GT.1) THEN
              IF(CONCS(IX,IY,IZ).LE.1.0E-09 .OR.
     .              CONCS(IX,IY,IZ-1).LE.1.0E-09) THEN
                 ANTIQZ(IX,IY,IZ) = 0.0
              ELSE IF(ABS(W(IX,IY,IZ)).LT.(W(IX,IY,IZ)*W(IX,IY,IZ)*
     .                   DT/(D(IX,IY)*DZZ(IZ-1)))) THEN
                 ANTIQZ(IX,IY,IZ) = 0.0
              ELSE
                ANTIQZ(IX,IY,IZ) = ABS(W(IX,IY,IZ))*
     .               (1.-ABS(W(IX,IY,IZ))*DT/(D(IX,IY)*DZZ(IZ-1)))*
     .                 (CONCS(IX,IY,IZ-1)-CONCS(IX,IY,IZ))/
     .                    (CONCS(IX,IY,IZ-1)+CONCS(IX,IY,IZ)+CNONZERO)
              ENDIF
           ENDIF
         ENDIF

 280   CONTINUE

      ENDIF

C-----------------------------------------------------------------------
C        RECURSIVE SMOLARKIEWICZ (ISMOLAR.EQ.1)
      IF(ISMOLAR .EQ. 1) THEN
        DO 281 IZ=1,NZ
        DO 281 IY=2,NY-1
        DO 281 IX=2,NX
          IF(CONCS(IX,IY,IZ).LT.1.E-9.OR.CONCS(IX-1,IY,IZ).LT.1.E-9)THEN
            ANTIQX(IX,IY,IZ)=0.0 
          ELSE
            AA=(CONCS(IX,IY,IZ)-CONCS(IX-1,IY,IZ))/
     .             (CONCS(IX-1,IY,IZ)+CONCS(IX,IY,IZ)+1.0E-15)
            ANTIQX(IX,IY,IZ)=ABS(U(IX,IY,IZ))*AA/(1.-ABS(AA)+1.0E-15) 
          END IF
  281   CONTINUE
        DO 282 IZ=1,NZ
        DO 282 IY=2,NY
        DO 282 IX=2,NX-1
          IF(CONCS(IX,IY,IZ).LT.1.E-9.OR.CONCS(IX,IY-1,IZ).LT.1.E-9)THEN
            ANTIQY(IX,IY,IZ)=0.0  
          ELSE
            AA=(CONCS(IX,IY,IZ)-CONCS(IX,IY-1,IZ))/
     .             (CONCS(IX,IY-1,IZ)+CONCS(IX,IY,IZ)+1.0E-15)
            ANTIQY(IX,IY,IZ)=ABS(V(IX,IY,IZ))*AA/(1.-ABS(AA)+1.0E-15)  
          END IF
  282   CONTINUE
        DO 283 IZ=2,NZ
        DO 283 IY=2,NY-1
        DO 283 IX=2,NX-1
          IF(CONCS(IX,IY,IZ).LT.1.E-9.OR.CONCS(IX,IY,IZ-1).LT.1.E-9)THEN
            ANTIQZ(IX,IY,IZ)=0.0 
          ELSE
            AA=(CONCS(IX,IY,IZ-1)-CONCS(IX,IY,IZ))/
     .             (CONCS(IX,IY,IZ)+CONCS(IX,IY,IZ-1)+1.0E-15)
            ANTIQZ(IX,IY,IZ)=ABS(W(IX,IY,IZ))*AA/(1.-ABS(AA)+1.0E-15)
          END IF
  283   CONTINUE

C        ADJUST FOR RIVER/WALL FLUXES
        DO 284 IZ=1,NZ
        DO 284 IY=2,NY
        DO 284 IX=2,NX
        IF(FSM(IX,IY).EQ.1..AND.FSM(IX-1,IY).EQ.-1.)ANTIQX(IX,IY,IZ)=0.0
        IF(FSM(IX,IY).EQ.-1..AND.FSM(IX-1,IY).EQ.1.)ANTIQX(IX,IY,IZ)=0.0
        IF(FSM(IX,IY).EQ.1..AND.FSM(IX,IY-1).EQ.-1.)ANTIQY(IX,IY,IZ)=0.0
        IF(FSM(IX,IY).EQ.-1..AND.FSM(IX,IY-1).EQ.1.)ANTIQY(IX,IY,IZ)=0.0
  284   CONTINUE

        DO 285 IZ=1,NZ
        DO 285 IY=1,NY
        DO 285 IX=1,NX
          FLUXIN(IX,IY,IZ)=0.0
          FLUXOUT(IX,IY,IZ)=0.0
  285   CONTINUE
        DO 286 IZ=1,NZ
        DO 286 IY=2,NY-1
         DO IX=2,NX
          IF(ANTIQX(IX,IY,IZ).GE.0.)THEN
            FLUXIN( IX,IY,IZ)=FLUXIN(IX,IY,IZ)+
     .             ANTIQX(IX,IY,IZ)/DXBAR1(IX,IY)*CONCS(IX-1,IY,IZ)
          ELSE
            FLUXOUT(IX,IY,IZ)=FLUXOUT(IX,IY,IZ)-
     .             ANTIQX(IX,IY,IZ)/DXBAR1(IX,IY)*CONCS(IX,IY,IZ)
          ENDIF
         ENDDO
         DO IX=1,NX-1
          IF(ANTIQX(IX+1,IY,IZ).GE.0.)THEN
            FLUXOUT(IX,IY,IZ)=FLUXOUT(IX,IY,IZ)+
     .             ANTIQX(IX+1,IY,IZ)/DXBAR1(IX+1,IY)*CONCS(IX,IY,IZ)
          ELSE
            FLUXIN(IX,IY,IZ)=FLUXIN(IX,IY,IZ)-
     .             ANTIQX(IX+1,IY,IZ)/DXBAR1(IX+1,IY)*CONCS(IX+1,IY,IZ)
          ENDIF
         ENDDO
  286   CONTINUE
        DO 287 IZ=1,NZ
        DO 287 IX=2,NX-1
         DO  IY=2,NY
          IF(ANTIQY(IX,IY,IZ).GE.0.)THEN
            FLUXIN(IX,IY,IZ)=FLUXIN(IX,IY,IZ)+
     .             ANTIQY(IX,IY,IZ)/DYBAR2(IX,IY)*CONCS(IX,IY-1,IZ)
          ELSE
            FLUXOUT(IX,IY,IZ)=FLUXOUT(IX,IY,IZ)-
     .             ANTIQY(IX,IY,IZ)/DYBAR2(IX,IY)*CONCS(IX,IY,IZ)
          ENDIF
         ENDDO
         DO IY=1,NY-1
          IF(ANTIQY(IX,IY+1,IZ).GE.0.)THEN
            FLUXOUT(IX,IY,IZ)=FLUXOUT(IX,IY,IZ)+
     .             ANTIQY(IX,IY+1,IZ)/DYBAR2(IX,IY+1)*CONCS(IX,IY,IZ)
          ELSE
            FLUXIN(IX,IY,IZ)=FLUXIN(IX,IY,IZ)-
     .             ANTIQY(IX,IY+1,IZ)/DYBAR2(IX,IY+1)*CONCS(IX,IY+1,IZ)
          ENDIF
         ENDDO
  287   CONTINUE
        DO 288 IY=2,NY-1
        DO 288 IX=2,NX-1
          IF(ANTIQZ(IX,IY,2).GE.0.)THEN
            FLUXIN(IX,IY,1)=FLUXIN(IX,IY,1)+
     .             ANTIQZ(IX,IY,2)/(DZZ(1)*D(IX,IY))*CONCS(IX,IY,2)
          ELSE
            FLUXOUT(IX,IY,1)=FLUXOUT(IX,IY,1)-
     .             ANTIQZ(IX,IY,2)/(DZZ(1)*D(IX,IY))*CONCS(IX,IY,1)
          ENDIF
          IF(ANTIQZ(IX,IY,NZ).GE.0.)THEN
           FLUXOUT(IX,IY,NZ)=FLUXOUT(IX,IY,NZ)+ANTIQZ(IX,IY,NZ)
     .                     /(DZZ(NZ-1)*D(IX,IY))*CONCS(IX,IY,NZ)
          ELSE
            FLUXIN(IX,IY,NZ)=FLUXIN(IX,IY,NZ)-ANTIQZ(IX,IY,NZ)
     .                   /(DZZ(NZ-1)*D(IX,IY))*CONCS(IX,IY,NZ-1)
          ENDIF
  288   CONTINUE
        DO 289 IZ=2,NZ-1
        DO 289 IY=2,NY-1
        DO 289 IX=2,NX-1
          IF(ANTIQZ(IX,IY,IZ).GE.0.)THEN
            FLUXOUT(IX,IY,IZ)=FLUXOUT(IX,IY,IZ)+ANTIQZ(IX,IY,IZ)
     .                         /(DZZ(IZ-1)*D(IX,IY))*CONCS(IX,IY,IZ)
          ELSE
            FLUXIN(IX,IY,IZ)=FLUXIN(IX,IY,IZ)-ANTIQZ(IX,IY,IZ)
     .                         /(DZZ(IZ-1)*D(IX,IY))*CONCS(IX,IY,IZ-1)
          ENDIF
          IF(ANTIQZ(IX,IY,IZ+1).GE.0.)THEN
            FLUXIN(IX,IY,IZ)=FLUXIN(IX,IY,IZ)+ANTIQZ(IX,IY,IZ+1)
     .                         /(DZZ(IZ)*D(IX,IY))*CONCS(IX,IY,IZ+1)
          ELSE
            FLUXOUT(IX,IY,IZ)=FLUXOUT(IX,IY,IZ)-ANTIQZ(IX,IY,IZ+1)
     .                         /(DZZ(IZ)*D(IX,IY))*CONCS(IX,IY,IZ)
          ENDIF
  289   CONTINUE
        DO IZ=1,NZ 
        DO IY=1,NY
        DO IX=1,NX
          IF(FSM(IX,IY).EQ.0.)CARAY(IX,IY,IZ,ISYS)=0.0
          IF(FSM(IX,IY).EQ.0.)CONCS(IX,IY,IZ)=0.0
        ENDDO
        ENDDO
        ENDDO
        DO 291 IZ=1,NZ 
        DO 291 IY=1,NY
        DO 291 IX=1,NX
          FMAX=AMAX1(CARAY(IX,IY,IZ,ISYS),
     .     CARAY(MAX(1,IX-1),IY,IZ,ISYS),CARAY(MIN(NX,IX+1),IY,IZ,ISYS),
     .     CARAY(IX,MAX(1,IY-1),IZ,ISYS),CARAY(IX,MIN(NY,IY+1),IZ,ISYS),
     .     CARAY(IX,IY,MAX(1,IZ-1),ISYS),CARAY(IX,IY,MIN(NZ,IZ+1),ISYS),
     .     CONCS(IX,IY,IZ),
     .     CONCS(MAX(1,IX-1),IY,IZ),CONCS(MIN(NX,IX+1),IY,IZ),
     .     CONCS(IX,MAX(1,IY-1),IZ),CONCS(IX,MIN(NY,IY+1),IZ),
     .     CONCS(IX,IY,MAX(1,IZ-1)),CONCS(IX,IY,MIN(NZ,IZ+1)))
          FLUXIN(IX,IY,IZ)=(FMAX-CONCS(IX,IY,IZ))/
     .                 (DT*FLUXIN(IX,IY,IZ)+1.0E-15)
  291   CONTINUE

        DO IZ=1,NZ 
        DO IY=1,NY
        DO IX=1,NX
          IF(FSM(IX,IY).EQ.0.)CARAY(IX,IY,IZ,ISYS)=1.E+20
          IF(FSM(IX,IY).EQ.0.)CONCS(IX,IY,IZ)=1.E+20
        ENDDO
        ENDDO
        ENDDO
        DO 292 IZ=1,NZ 
        DO 292 IY=1,NY
        DO 292 IX=1,NX
          FMIN=AMIN1(CARAY(IX,IY,IZ,ISYS),
     .     CARAY(MAX(1,IX-1),IY,IZ,ISYS),CARAY(MIN(NX,IX+1),IY,IZ,ISYS),
     .     CARAY(IX,MAX(1,IY-1),IZ,ISYS),CARAY(IX,MIN(NY,IY+1),IZ,ISYS),
     .     CARAY(IX,IY,MAX(1,IZ-1),ISYS),CARAY(IX,IY,MIN(NZ,IZ+1),ISYS),
     .     CONCS(IX,IY,IZ),
     .     CONCS(MAX(1,IX-1),IY,IZ),CONCS(MIN(NX,IX+1),IY,IZ),
     .     CONCS(IX,MAX(1,IY-1),IZ),CONCS(IX,MIN(NY,IY+1),IZ),
     .     CONCS(IX,IY,MAX(1,IZ-1)),CONCS(IX,IY,MIN(NZ,IZ+1)))
          FLUXOUT(IX,IY,IZ)=(CONCS(IX,IY,IZ)-FMIN)/
     .                  (DT*FLUXOUT(IX,IY,IZ)+1.0E-15)
  292   CONTINUE
 
        DO 293 IZ=1,NZ 
        DO 293 IY=1,NY
        DO 293 IX=1,NX
          IF(FSM(IX,IY).EQ.0.)CARAY(IX,IY,IZ,ISYS)=0.0
          IF(FSM(IX,IY).EQ.0.)CONCS(IX,IY,IZ)=0.0
          IF(FSM(IX,IY).EQ.-1.)FLUXIN(IX,IY,IZ)=0.
          IF(FSM(IX,IY).EQ.-1.)FLUXOUT(IX,IY,IZ)=0.
  293   CONTINUE
        DO 294 IZ=1,NZ
        DO 294 IY=2,NY
        DO 294 IX=2,NX
          IF(ANTIQX(IX,IY,IZ).GE.0.)THEN
            ANTIQX(IX,IY,IZ)=ANTIQX(IX,IY,IZ)*
     .            (AMIN1(1.,FLUXIN(IX,IY,IZ),FLUXOUT(IX-1,IY,IZ)))
          ELSE
            ANTIQX(IX,IY,IZ)=ANTIQX(IX,IY,IZ)*
     .            (AMIN1(1.,FLUXIN(IX-1,IY,IZ),FLUXOUT(IX,IY,IZ)))
          ENDIF
          IF(ANTIQY(IX,IY,IZ).GE.0.)THEN
            ANTIQY(IX,IY,IZ)=ANTIQY(IX,IY,IZ)*
     .            (AMIN1(1.,FLUXIN(IX,IY,IZ),FLUXOUT(IX,IY-1,IZ)))
          ELSE
            ANTIQY(IX,IY,IZ)=ANTIQY(IX,IY,IZ)*
     .            (AMIN1(1.,FLUXIN(IX,IY-1,IZ),FLUXOUT(IX,IY,IZ)))
          ENDIF
          IF(IZ.GE.2)THEN
            IF(ANTIQZ(IX,IY,IZ).GE.0.)THEN
              ANTIQZ(IX,IY,IZ)=ANTIQZ(IX,IY,IZ)*
     .            (AMIN1(1.,FLUXIN(IX,IY,IZ-1),FLUXOUT(IX,IY,IZ)))
            ELSE
              ANTIQZ(IX,IY,IZ)=ANTIQZ(IX,IY,IZ)*
     .            (AMIN1(1.,FLUXIN(IX,IY,IZ),FLUXOUT(IX,IY,IZ-1)))
            ENDIF
          ENDIF
  294   CONTINUE

      ENDIF

C  END OF EVALUATION OF TERMS REQUIRED FOR SMOLARKIEWICZ CORRECTION

C-----------------------------------------------------------------------
C  NOW USE TERMS TO CALCULATE ANTIDIFFUSION FLUXES

      DO 300 IZ=1,NZ
        DO 300 IY=2,NY
          DO 300 IX=2,NX
            QXFLX(IX,IY,IZ) = 0.5*(ANTIQX(IX,IY,IZ)*(CONCS(IX,IY,IZ)+
     .           CONCS(IX-1,IY,IZ))-ABS(ANTIQX(IX,IY,IZ))*
     .           (CONCS(IX,IY,IZ)-CONCS(IX-1,IY,IZ)))
     .           *DYBAR1(IX,IY)*0.5*(D(IX,IY)+D(IX-1,IY))*DZ(IZ)
            QYFLX(IX,IY,IZ) = 0.5*(ANTIQY(IX,IY,IZ)*(CONCS(IX,IY,IZ)+
     .          CONCS(IX,IY-1,IZ))-ABS(ANTIQY(IX,IY,IZ))*
     .          (CONCS(IX,IY,IZ)-CONCS(IX,IY-1,IZ)))      
     .           *DXBAR2(IX,IY)*0.5*(D(IX,IY)+D(IX,IY-1))*DZ(IZ)
            IF(NZ.GT.1.AND.IZ.GT.1.AND.FSM(IX,IY).EQ.1.) 
     .        QZFLX(IX,IY,IZ) = 0.5*
     .        (ANTIQZ(IX,IY,IZ)*(CONCS(IX,IY,IZ-1)+CONCS(IX,IY,IZ))-
     .          ABS(ANTIQZ(IX,IY,IZ))*(CONCS(IX,IY,IZ-1)-
     .          CONCS(IX,IY,IZ)))*XAZ(IX,IY)

            IF(FSM(IX,IY).EQ.0. .OR. FSM(IX,IY).EQ.-1.) THEN
             QXFLX(IX,IY,IZ) = 0.0
             QYFLX(IX,IY,IZ) = 0.0
             QZFLX(IX,IY,IZ) = 0.0
            ENDIF
  300 CONTINUE

C  SET HORIZONTAL ANTIDIFFUSION FLUXES IN BOUNDARY ELEMENTS TO ZERO
        IF(ISMOLBCOPT.EQ.0) THEN
          DO 310 I=1,NOBCALL
            IX=IBCALL(1,I)
            IY=IBCALL(2,I)
            IZ=IBCALL(3,I)
            QXFLX(IX,IY,IZ)=0.0
            QXFLX(MIN(IX+1,NX),IY,IZ)=0.0
            QYFLX(IX,IY,IZ)=0.0
            QYFLX(IX,MIN(IY+1,NY),IZ)=0.0
 310      CONTINUE
        ENDIF

C  TAKE UPWIND STEP, PLACING RESULTS BACK INTO CONCS NOW AT (N+1)''
        IF (NZ.GT.1) THEN
          DO 320 IZ=1,NZ-1
            DO 320 IY=1,NY
              IS = IXS(IY)
              IE = IXE(IY)
              IF(IS.EQ.0) GO TO 320
              DO 319 IX=IS,IE
                IF(FSM(IX,IY).NE.1.)GO TO 319
                CONCS(IX,IY,IZ)=CONCS(IX,IY,IZ)
     .             +DT*(QXFLX(IX,IY,IZ)-QXFLX(IX+1,IY,IZ)
     .                 +QYFLX(IX,IY,IZ)-QYFLX(IX,IY+1,IZ)
     .                 +QZFLX(IX,IY,IZ+1)-QZFLX(IX,IY,IZ))/
     .                                             BVOLN(IX,IY,IZ)
  319         CONTINUE
  320     CONTINUE

          IZ=NZ
          DO 325 IY=1,NY
            IS = IXS(IY)
            IE = IXE(IY)
            IF(IS.EQ.0) GO TO 325
            DO 324 IX=IS,IE
              IF(FSM(IX,IY).NE.1.)GO TO 324
              CONCS(IX,IY,IZ)=CONCS(IX,IY,IZ)
     .           +DT*(QXFLX(IX,IY,IZ)-QXFLX(IX+1,IY,IZ)
     .               +QYFLX(IX,IY,IZ)-QYFLX(IX,IY+1,IZ)
     .               -QZFLX(IX,IY,IZ))/BVOLN(IX,IY,IZ)
  324       CONTINUE
  325     CONTINUE
        ELSE
          IZ=1
          DO 330 IY=1,NY
            IS = IXS(IY)
            IE = IXE(IY)
            IF(IS.EQ.0) GO TO 330
            DO 329 IX=IS,IE
              IF(FSM(IX,IY).NE.1.)GO TO 329
              CONCS(IX,IY,IZ)=CONCS(IX,IY,IZ)
     .           +DT*(QXFLX(IX,IY,IZ)-QXFLX(IX+1,IY,IZ)
     .               +QYFLX(IX,IY,IZ)-QYFLX(IX,IY+1,IZ))/
     .                                             BVOLN(IX,IY,IZ)
  329       CONTINUE
  330     CONTINUE
        ENDIF
C  END OF SMOLARKIEWICZ CORRECTION CODE

C        CHECK FOR MASS/FLUX BALANCE COMPUTATIONS
      IF(MASSBAL.EQ.0) GO TO 333
C        INSTANTANEOUS OR AVERAGED
      IF(IMBDOPT.EQ.0 .AND. NXPRTMB.NE.ITIMESECS) GO TO 333
      IF(ITIMESECS.LT.ISMBSECS) GO TO 333
      DO IZ=1,NZ
       DO IY=1,NY
        DO IX=1,NX
         FLXMB(IX,IY,IZ,ISYS)=FLXMB(IX,IY,IZ,ISYS)+DTMB*QXFLX(IX,IY,IZ)
         FLYMB(IX,IY,IZ,ISYS)=FLYMB(IX,IY,IZ,ISYS)+DTMB*QYFLX(IX,IY,IZ)
        ENDDO
       ENDDO
      ENDDO

C***********************************************************************

C  CALCULATE HORIZONTAL DIFFUSION FLUXES

c$doacross local(iz,iy,ix,is,ie)
  333   DO 335 IZ=1,NZ
        DO 335 IY=2,NY
        DO 335 IX=2,NX
              IF(FSM(IX,IY).GE.1. .OR. FSM(IX,IY).LE.-2.)THEN
                IF(FSM(IX-1,IY).GE.1. .OR. FSM(IX-1,IY).LE.-2.)THEN
                  RXFLX(IX,IY,IZ)=RX(IX,IY,IZ)*
     .             ((CARAY(IX-1,IY,IZ,ISYS)-CSLAVE(IX-1,IY,IZ,ISYS)) -
     .             (CARAY(IX,IY,IZ,ISYS)-CSLAVE(IX,IY,IZ,ISYS)))
                ENDIF
                IF(FSM(IX,IY-1).GE.1. OR. FSM(IX,IY-1).LE.-2.)THEN
                  RYFLX(IX,IY,IZ)=RY(IX,IY,IZ)*
     .             ((CARAY(IX,IY-1,IZ,ISYS)-CSLAVE(IX,IY-1,IZ,ISYS)) -
     .             (CARAY(IX,IY,IZ,ISYS)-CSLAVE(IX,IY,IZ,ISYS)))
                ENDIF
              ENDIF
 335    CONTINUE

c$doacross local(iz,iy,ix,is,ie)
        DO 340 IZ=1,NZ
          DO 340 IY=1,NY
            IS = IXS(IY)
            IE = IXE(IY)
            IF(IS.EQ.0)   GO TO 340
            DO 339 IX=IS,IE
              IF(FSM(IX,IY).NE.1.)  GO TO 339
              CONCS(IX,IY,IZ)=CONCS(IX,IY,IZ)+DT*
     .           (RXFLX(IX,IY,IZ)-RXFLX(IX+1,IY,IZ)+RYFLX(IX,IY,IZ)
     .           -RYFLX(IX,IY+1,IZ))/BVOLN(IX,IY,IZ)
 339      CONTINUE
 340    CONTINUE

C  BOUNDARY ELEMENTS ARE UNCHANGED
        DO 345 I=1,NOBCALL
          IX=IBCALL(1,I)
          IY=IBCALL(2,I)
          IZ=IBCALL(3,I)
          CONCS(IX,IY,IZ)=CARAY(IX,IY,IZ,ISYS)
  345   CONTINUE

C        CHECK FOR MASS/FLUX BALANCE COMPUTATIONS
      IF(MASSBAL.EQ.0) GO TO 348
C        INSTANTANEOUS OR AVERAGED
      IF(IMBDOPT.EQ.0 .AND. NXPRTMB.NE.ITIMESECS) GO TO 348
      IF(ITIMESECS.LT.ISMBSECS) GO TO 348
      DO  IZ=1,NZ
       DO  IY=1,NY
        DO  IX=1,NX
         FLXMB(IX,IY,IZ,ISYS)=FLXMB(IX,IY,IZ,ISYS)+DTMB*RXFLX(IX,IY,IZ)
         FLYMB(IX,IY,IZ,ISYS)=FLYMB(IX,IY,IZ,ISYS)+DTMB*RYFLX(IX,IY,IZ)
        ENDDO
       ENDDO
      ENDDO

C**********************************************************************

C        COMPLETE REST OF INTEGRATION STEP
C        I.E., THE IMPLICIT VERTICAL DIFFUSION STEP  (IF NZ > 1)
  348  IF (NZ.EQ.1) GO TO 390
        DO 350 IZ=1,NZ
         DO 350 IY=1,NY
          IS = IXS(IY)
          IE = IXE(IY)
          IF(IS.EQ.0) GO TO 350
          DO 349 IX=IS,IE
            MF(IX,IY,IZ) = CONCS(IX,IY,IZ)*BVOLN(IX,IY,IZ)
  349     CONTINUE
  350   CONTINUE
C        SET UP DIAGONAL AND OFF-DIAGONAL ELEMENTS
        DO 360 IY=1,NY
         IS = IXS(IY)
         IE = IXE(IY)
         IF(IS.EQ.0) GO TO 360
         DO 359 IX=IS,IE
          IF(FSM(IX,IY).NE.1.) GO TO 359
          AL(IX,IY,1) = 0.
          AD(IX,IY,1) = BVOLN(IX,IY,1) + DT*RZ(IX,IY,2)
          AU(IX,IY,1) = -DT*RZ(IX,IY,2)
           DO 355 IZ=2,NZ-1
            AL(IX,IY,IZ) = -DT*RZ(IX,IY,IZ)
            AD(IX,IY,IZ) = BVOLN(IX,IY,IZ) +
     .                        DT*(RZ(IX,IY,IZ) + RZ(IX,IY,IZ+1))
            AU(IX,IY,IZ) = -DT*RZ(IX,IY,IZ+1)
  355      CONTINUE
          AL(IX,IY,NZ) = -DT*RZ(IX,IY,NZ)
          AD(IX,IY,NZ) = BVOLN(IX,IY,NZ) + DT*RZ(IX,IY,NZ)
          AU(IX,IY,NZ) = 0.0
  359    CONTINUE
  360   CONTINUE
C        FORWARD SWEEP OF TRIDIAGONAL SCHEME
        DO 370 IY=1,NY
         IS = IXS(IY)
         IE = IXE(IY)
         IF(IS.EQ.0) GO TO 370
         DO 369 IX=IS,IE
          IF(FSM(IX,IY).NE.1.) GO TO 369
          BETA(IX,IY,1) = AD(IX,IY,1)
          GAMMA(IX,IY,1) = MF(IX,IY,1)/BETA(IX,IY,1)
          DO 365 IZ=2,NZ
           BETA(IX,IY,IZ) = AD(IX,IY,IZ)
     .                 - AL(IX,IY,IZ)*AU(IX,IY,IZ-1)/BETA(IX,IY,IZ-1)
           GAMMA(IX,IY,IZ) = (MF(IX,IY,IZ)
     .                 - AL(IX,IY,IZ)*GAMMA(IX,IY,IZ-1))/BETA(IX,IY,IZ)
  365     CONTINUE
  369    CONTINUE
  370   CONTINUE
C        BACKWARD SWEEP FOR SOLUTION
        DO 380 IY=1,NY
         IS = IXS(IY)
         IE = IXE(IY)
         IF(IS.EQ.0) GO TO 380
         DO 379 IX=IS,IE
          IF(FSM(IX,IY).NE.1.) GO TO 379
          CONCS(IX,IY,NZ) = GAMMA(IX,IY,NZ)
          DO 375 ILYR=2,NZ
           IZ = NZ+1-ILYR
           CONCS(IX,IY,IZ) = GAMMA(IX,IY,IZ)
     .               - AU(IX,IY,IZ)*CONCS(IX,IY,IZ+1)/BETA(IX,IY,IZ)
  375     CONTINUE
  379    CONTINUE
  380   CONTINUE

C  BOUNDARY ELEMENTS ARE UNCHANGED
        DO 385 I=1,NOBCALL
          IX=IBCALL(1,I)
          IY=IBCALL(2,I)
          IZ=IBCALL(3,I)
          CONCS(IX,IY,IZ)=CARAY(IX,IY,IZ,ISYS)
  385   CONTINUE
 
  390   CONTINUE
 
C        CHECK TO SEE IF NEGATIVE SOLUTIONS PERMITTED 
        DO 395 IZ=1,NZ
          DO 395 IY=1,NY
            IS = IXS(IY)
            IE = IXE(IY)
            IF(IS.EQ.0) GO TO 395
            DO 394 IX=IS,IE
              IF(FSM(IX,IY).NE.1.)GO TO 394
              IF (NEGSLN.EQ.1) THEN
                CARAY(IX,IY,IZ,ISYS) = CONCS(IX,IY,IZ)
              ELSE
C        IF NOT ... CHECK TO MAKE SURE SOLUTION IS NOT FORCED THRU ZERO
                IF(CONCS(IX,IY,IZ).GE.CMIN(ISYS)) THEN
                  CARAY(IX,IY,IZ,ISYS) = CONCS(IX,IY,IZ)
                ELSE
C          PREVENT NEG SOLN BY QUARTERING PRESENT CONC AND PRINT WARNING
c                 print *,'negative conc at time in ix,iy,ix,isys',
c    .               time,ix,iy,iz,isys,concs(ix,iy,iz)
                  CARAY(IX,IY,IZ,ISYS) = 
     .                     MAX(CARAY(IX,IY,IZ,ISYS)/4.,CMIN(ISYS))
c$        call mp_setlock
                 INEGS = INEGS+1
                 IF(INEGS.LE.99) THEN
                   NEGSEG(INEGS,1) = IX
                   NEGSEG(INEGS,2) = IY
                   NEGSEG(INEGS,3) = IZ
                 ENDIF
                 TOTMAS = TOTMAS+BVOLN(IX,IY,IZ)*
     .                    (CARAY(IX,IY,IZ,ISYS)-CONCS(IX,IY,IZ))
                 ADDMASS(IX,IY,IZ,ISYS) = ADDMASS(IX,IY,IZ,ISYS) +
     .            BVOLN(IX,IY,IZ)*(CARAY(IX,IY,IZ,ISYS)-CONCS(IX,IY,IZ))
                 IWRTADDM=1
c$        call mp_unsetlock
                ENDIF
              ENDIF
  394       CONTINUE
  395  CONTINUE

       IF(IADDMDEBUG.EQ.1) THEN
        IF(INEGS.GT.0) THEN
C$         call mp_setlock
         CALL RCAMESS(2,0.001*TOTMAS)
         WRITE(OUT,1000)  ((NEGSEG(I,J),J=1,3),I=1,MIN(INEGS,99))
 1000     FORMAT(30X,12I5)
C$          call mp_unsetlock
        ENDIF
       ENDIF

  400 CONTINUE

C        FLUX BALANCES FOR MISC KINETIC VARIABLES
      IF(MASSBAL.EQ.0 .OR. NOKINSYS.EQ.0) GO TO 410
C        INSTANTANEOUS OR AVERAGED
      IF(IMBDOPT.EQ.0) THEN 
       IF(NXPRTMB.NE.ITIMESECS) GO TO 410
       DO 405 ISYS=1,NOKINSYS
        DO 405 IZ=1,NZ
         DO 405 IY=1,NY
          DO 405 IX=1,NX
           IF(FSM(IX,IY).NE.1.) GO TO 405
            FLXMB(IX,IY,IZ,NOSYS+ISYS) = 
     .         (AMAX1(0.,QX(IX,IY,IZ)*CKINARRAY(IX-1,IY,IZ,ISYS))
     .        + AMIN1(0.,QX(IX,IY,IZ)*CKINARRAY(IX,IY,IZ,ISYS))
     .        + RX(IX,IY,IZ)
     .           *(CKINARRAY(IX-1,IY,IZ,ISYS)-CKINARRAY(IX,IY,IZ,ISYS)))
            FLYMB(IX,IY,IZ,NOSYS+ISYS) = 
     .         (AMAX1(0.,QY(IX,IY,IZ)*CKINARRAY(IX,IY-1,IZ,ISYS))
     .        + AMIN1(0.,QY(IX,IY,IZ)*CKINARRAY(IX,IY,IZ,ISYS))
     .        + RY(IX,IY,IZ)
     .           *(CKINARRAY(IX,IY-1,IZ,ISYS)-CKINARRAY(IX,IY,IZ,ISYS)))
  405  CONTINUE
      ELSE
       IF(ITIMESECS.LT.ISMBSECS) GO TO 410
       DO 407 ISYS=1,NOKINSYS
        DO 407 IZ=1,NZ
         DO 407 IY=1,NY
          DO 407 IX=1,NX
           IF(FSM(IX,IY).NE.1.) GO TO 407
            FLXMB(IX,IY,IZ,NOSYS+ISYS) = FLXMB(IX,IY,IZ,NOSYS+ISYS) 
     .        +DT*(AMAX1(0.,QX(IX,IY,IZ)*CKINARRAY(IX-1,IY,IZ,ISYS))
     .             + AMIN1(0.,QX(IX,IY,IZ)*CKINARRAY(IX,IY,IZ,ISYS))
     .             + RX(IX,IY,IZ)
     .           *(CKINARRAY(IX-1,IY,IZ,ISYS)-CKINARRAY(IX,IY,IZ,ISYS)))
            FLYMB(IX,IY,IZ,NOSYS+ISYS) = FLYMB(IX,IY,IZ,NOSYS+ISYS) 
     .        +DT*(AMAX1(0.,QY(IX,IY,IZ)*CKINARRAY(IX,IY-1,IZ,ISYS))
     .             + AMIN1(0.,QY(IX,IY,IZ)*CKINARRAY(IX,IY,IZ,ISYS))
     .             + RY(IX,IY,IZ)
     .           *(CKINARRAY(IX,IY-1,IZ,ISYS)-CKINARRAY(IX,IY,IZ,ISYS)))
  407  CONTINUE
      ENDIF
        

C***********************************************************************

C        UPDATE VOLUMES FOR NEXT TIMESTEP
  410 DO 415 IZ=1,NZ
       DO 415 IY=1,NY
        DO 415 IX=1,NX
         BVOL(IX,IY,IZ) = BVOLN(IX,IY,IZ)
  415 CONTINUE

C  PREPARE FOR NEXT TIME STEP
      ITIMESECS = ITIMESECS + IDTSECS
      TIME = ITIMESECS/86400.

C        CHECK TO SEE IF IT IS TIME TO PRINT RESULTS

C  FIRST DETAILED DUMPS
      IF(ITIMESECS.LT.NXPRTD) GO TO 435
C  DETAILED PRINT TIME
C  SET IDISK FOR DETAILED DUMPS
      IDISK=2
      NXPRTD = NXPRTD + IPRNTDSECS
C  SECOND GLOBAL DUMPS
 435  IF(ITIMESECS.LT.NXPRTG) GO TO 450
C  GLOBAL PRINT TIME
C  CALL PRINT ROUTINE
      CALL RCA09
      IDISK=IDISK+1
      NXPRTG = NXPRTG + IPRNTGSECS

C        SEE IF MASS HAS BEEN ADDED TO THE SYSTEM
      IF(IWRTADDM.EQ.1) THEN
        OPEN(19,FILE='RCAFADDM',FORM='UNFORMATTED',STATUS='REPLACE')
        WRITE(19)  ADDMASS
        CLOSE(19)
        IWRTADDM=0
      ENDIF
       
C  NOW PERFORM STABILITY CHECK
      DO 445 ISYS=1,NOSYS 
        IF(SYSBY(ISYS).EQ.1) GO TO 445
        CKMAX = CMAX(ISYS)
        DO 440 IZ=1,NZ
          DO 440 IY=1,NY
            IS = IXS(IY)
            IE = IXE(IY)
            IF(IS.EQ.0) GO TO 440
            DO 439 IX=IS,IE
              IF(FSM(IX,IY).NE.1.) GO TO 439
              IF(CARAY(IX,IY,IZ,ISYS).GE.CKMAX) GO TO 500
  439       CONTINUE
  440   CONTINUE
  445 CONTINUE

C  MASS/FLUX BALANCE DUMPS
  450 IF(MASSBAL.EQ.0) GO TO 470
      IF(ITIMESECS.LT.NXPRTMB) GO TO 470
       IF(IMBDOPT.EQ.0) THEN
        WRITE(17)  TIME,SYSMASS,SYSLOADS,FLXMB,FLYMB
       ELSE
        TIMEAVE=FLOAT(IPRNTMBSECS)/86400.
        DO 455 ISYS=1,NOSYS+NOKINSYS
         DO 455 IZ=1,NZ
          DO 455 IY=1,NY
           DO 455 IX=1,NX
            FLXMB(IX,IY,IZ,ISYS)=FLXMB(IX,IY,IZ,ISYS)/TIMEAVE
            FLYMB(IX,IY,IZ,ISYS)=FLYMB(IX,IY,IZ,ISYS)/TIMEAVE
  455   CONTINUE
        DO ISYS=1,NOSYS
         DO I=1,4
          SYSLOADS(I,ISYS)=SYSLOADS(I,ISYS)/TIMEAVE
         ENDDO
        ENDDO
        WRITE(17)  TIME,SYSMASS,SYSLOADS,FLXMB,FLYMB
       ENDIF
C        RESET ARRAYS AND COUNTER
      DO 460 ISYS=1,NOSYS
       DO 460 I=1,4
        SYSLOADS(I,ISYS)=0.
  460 CONTINUE
      DO 465 ISYS=1,NOSYS+NOKINSYS
       DO 465 IZ=1,NZ
        DO 465 IY=1,NY
         DO 465 IX=1,NX
          FLXMB(IX,IY,IZ,ISYS)=0.0
          FLYMB(IX,IY,IZ,ISYS)=0.0
  465 CONTINUE
      NXPRTMB = NXPRTMB + IPRNTMBSECS
      IF(NXPRTMB.GT.IEMBSECS) MASSBAL=0

C        CHECK TO SEE IF USER WISHES TO TERMINATE RUN
      CALL CHECKSTOP(IVAL)
      IF(IVAL.EQ.0) GO TO 470
C        TERMINATE / CALL TUNER TO PERFORM LAST DUMPS
      CALL TUNER
      WRITE(OUT,7000)
 7000 FORMAT(///30X,'USER REQUESTED TERMINATION VIA CHECKSTOP FILE'/
     .          30X,'RCASPLTS FINISHED INTEGRATION')
      IF(MASSBAL.EQ.1) THEN
        DEALLOCATE(FLXMB)
        DEALLOCATE(FLYMB)
      ENDIF
      CALL EXIT

C        CHECK TO SEE IF NECESSARY TO UPDATE TIME-VARIABLE FUNCTIONS
C        POINT SOURCE LOADS 
  470 IF(IPSOPT.GT.1.AND.TIME.GE.NXPST)   THEN
         CALL RCA10(SPS,BPS,MXWK,NOPS,NXPST,33,IPSPWLOPT,SCALPS)
      ENDIF
C        NONPOINT SOURCE LOADS 
      IF(INPSOPT.GT.1.AND.TIME.GE.NXNPST)   THEN
         CALL RCA10(SNPS,BNPS,MXWK,NONPS,NXNPST,34,INPSPWLOPT,SCALNPS)
      ENDIF
C        FALL-LINE LOADS 
      IF(IFLOPT.GT.1.AND.TIME.GE.NXFLT)   THEN
         CALL RCA10(SFL,BFL,MXWK,NOFL,NXFLT,35,IFLPWLOPT,SCALFL)
      ENDIF
C        ATMOSPHERIC LOADS 
      IF(IATMOPT.GT.1.AND.TIME.GE.NXATMT)   THEN
         CALL RCA10(SATM,BATM,NX*NY,NOATM,NXATMT,36,IATMPWLOPT,
     .              SCALATM)
      ENDIF
C        NEXT BOUNDARY CONDITIONS 
      IF(IBCOPT.GT.1.AND.TIME.GT.NXBCT) CALL RCA11 

C        CHECK TO SEE IF NECESSARY TO UPDATE TRANSPORT FIELDS
C     IF(ITIMESECS.GE.HYDBRK(ITIMHYD)) THEN
      IF(ITIMESECS.GE.NXHYDTSECS) THEN
         CALL RCA03A
         CALL RCASPLT1
C        ITIMHYD = ITIMHYD+1
         DO 480 ISEG=1,NSEGSPLT
           IX = ISEGSPLT(ISEG,1)
           IY = ISEGSPLT(ISEG,2)
           IZ = ISEGSPLT(ISEG,3)
           RXSPLT(ISEG,1) = RX(IX,IY,IZ)
           RXSPLT(ISEG,2) = RX(IX+1,IY,IZ)
           RYSPLT(ISEG,1) = RY(IX,IY,IZ)
           RYSPLT(ISEG,2) = RY(IX,IY+1,IZ)
  480    CONTINUE
         DO 485 ISEG=1,NSEGSPLT
           IX = ISEGSPLT(ISEG,1)
           IY = ISEGSPLT(ISEG,2)
           IZ = ISEGSPLT(ISEG,3)
           RX(IX,IY,IZ) = 0.0
           RX(IX+1,IY,IZ) = 0.0
           RY(IX,IY,IZ) = 0.0
           RY(IX,IY+1,IZ) = 0.0
  485    CONTINUE
      ENDIF

C        CHECK FOR END OF SIMULATION...
C           IF NOT GO BACK AND TAKE NEXT INTEGRATION STEP
      IF(TIME.LE.TEND) GO TO 30 

C        FINISHED...CALL FOR FINAL DUMPS
      IDISK = 1
      CALL TUNER
      CLOSE(121)
      CLOSE(131)
      WRITE(OUT,8000)
 8000 FORMAT(///30X,'RCASPLTS FINISHED INTEGRATION'/
     .          30X,'USER DUMPS TO FOLLOW'//)
      IF(MASSBAL.EQ.1) THEN
        DEALLOCATE(FLXMB)
        DEALLOCATE(FLYMB)
      ENDIF
      RETURN

C         STABILITY CRITERIA VIOLATED...ABEND 
  500 CALL RCAMESS(1,CKMAX) 
      WRITE(OUT,9000)  BVOLN(IX,IY,IZ),DIAG(IX,IY,IZ)
 9000 FORMAT(10X,'VOLUME =',E13.4,'  ,DIAGONAL =',E13.4)
      IREC = IREC+1 
      IDISK = 1 
      INITB = 2
      CALL TUNER
      RETURN
      END 
